/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core;

import modesteditor.core.model.Model;
import modesteditor.core.model.ModestSimulation;
import modesteditor.core.model.Process;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import antlr.RecognitionException;
import antlr.TokenStreamException;




/*public class ModestContentProvider implements ITreeContentProvider, IDeltaListener {
	
	private IDocumentProvider fDocumentProvider;
	private Object fInput;
	private TreeViewer viewer;
	private Model root;
	private ModestContentOutlinePage outlinePage;
	
	private static Object[] EMPTY_ARRAY = new Object[0];

	public ModestContentProvider(Object input, IDocumentProvider provider) {
		try {
			if (input == null) System.err.println("Input ist leer ihr Nasen");
			if (provider == null) System.err.println("provider ist NULL");
			
			fDocumentProvider = provider;
			fInput = input;
			if (fDocumentProvider.getDocument(fInput) == null) System.err.println("fDocumentProvider.getDocument(fInput) liefert NULL");
			if (fDocumentProvider.getDocument(fInput).get() == "") System.err.println("fDocumentProvider.getDocument(fInput).get() liefert leeren String");
							
			} catch (Exception e) {
    		System.err.println("Exception in Konstruktor von modestContentProvider: "+ e);
    	}
	}

	//protected final static String SEGMENTS= "__modest_segments";
	//protected IPositionUpdater fPositionUpdater= new DefaultPositionUpdater(SEGMENTS);
	protected List fContent= new ArrayList(10);

	
		
	
	
	protected void parse(IDocument document) {

		int lines= document.getNumberOfLines();
		//CharStream cs = new CharStream(document.get().toCharArray());
		int increment= Math.max(Math.round(lines / 10), 10);

		for (int line= 0; line < lines; line += increment) {

			int length= increment;
			if (line + increment > lines)
				length= lines - line;

			try {

				int offset= document.getLineOffset(line);
				int end= document.getLineOffset(line + length);
				length= end - offset;
				Position p= new Position(offset, length);
				document.addPosition(SEGMENTS, p);
				fContent.add(new Segment(MessageFormat.format(ModestEditorMessages.getString("OutlinePage.segment.title_pattern"), new Object[] { new Integer(offset) }), p));

			} catch (BadPositionCategoryException x) {
			} catch (BadLocationException x) {
			}
		}
	}

	
	 * @see IContentProvider#inputChanged(Viewer, Object, Object)
	 
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		this.viewer = (TreeViewer)viewer;
	    if(oldInput != null) 
	    	//removeListenerFrom((Process)root);
	    	removeListenerFrom((Process)oldInput);
	    if(newInput != null) {
	    	try {
//	    		gibt den kompletten String im Dokument aus, brauch man zum parsen
		    	//fehlt noch das element in getDocument()
		    	//String doc = fDocumentProvider.getDocument(newInput).get();
		    	//root = parse(doc);
		    	//addListenerTo((Process)root);
		    	
	    		addListenerTo((Process)newInput);
	    		
		    	// TODO check whether this is correct ... 
		    	//viewer.setInput(root);
		    	
		    	//outlinePage.setViewerRoot((Process)root);
		    	
			} catch (Exception e) {
				System.err.println("Exception in inputChanged: " + e);
			}
	    	
	    }
	}

	
	 * @see IContentProvider#dispose
	 
	public void dispose() {
		if (fContent != null) {
			fContent.clear();
			fContent= null;
		}
	}

	
	 * @see IContentProvider#isDeleted(Object)
	 
	public boolean isDeleted(Object element) {
		return false;
	}

	
	 * @see IStructuredContentProvider#getElements(Object)
	 
	public Object[] getElements(Object element) {
		return getChildren(element);
	}

	
	 * @see ITreeContentProvider#hasChildren(Object)
	 
	public boolean hasChildren(Object element) {
		return getChildren(element).length > 0;
	}

	
	 * @see ITreeContentProvider#getParent(Object)
	 
	public Object getParent(Object element) {
		if (element instanceof Model)
			return ((Model)element).getParent();
		return null;
	}

	
	 * @see ITreeContentProvider#getChildren(Object)
	 
	public Object[] getChildren(Object element) {
		if (element instanceof Process) {
			Process proc = (Process)element;
			return concat(proc.getProcesses().toArray(), proc.getActions().toArray(), proc.getExceptions().toArray(), proc.getVariables().toArray(), proc.getTypes().toArray());
		}	
		return EMPTY_ARRAY;
	}

	*//** Because the domain model does not have a richer
	 * listener model, recursively add this listener
	 * to each child process of the given process. *//*
	protected void addListenerTo(Process proc) {
	    proc.addListener(this);
	    for (Iterator iterator = proc.getProcesses().iterator(); iterator.hasNext();) {
	       Process lProc = (Process) iterator.next();
	       addListenerTo(lProc);
	    }
	}
	
	*//** Because the domain model does not have a richer
	 * listener model, recursively remove this listener
	 * to each child process of the given process. *//*
	protected void removeListenerFrom(Process proc) {
	    proc.removeListener(this);
	    for (Iterator iterator = proc.getProcesses().iterator(); iterator.hasNext();) {
	       Process lProc = (Process) iterator.next();
	       removeListenerFrom(lProc);
	    }
	}
	
	protected Object[] concat(Object[] object, Object[] more, Object[] more2, Object[] more3, Object[] more4) {
		Object[] both = new Object[object.length + more.length + more2.length+ more3.length+ more4.length];
		System.arraycopy(object, 0, both, 0, object.length);
		System.arraycopy(more, 0, both, object.length, more.length);
		System.arraycopy(more2, 0, both, object.length + more.length, more2.length);		
		System.arraycopy(more3, 0, both, object.length + more.length, more3.length);
		System.arraycopy(more4, 0, both, object.length + more.length, more4.length);
		return both;
	}
	
	
	 * @see IDeltaListener#add(DeltaEvent)
	 
	public void add(DeltaEvent event) {
		Object process = ((Model)event.receiver()).getParent();
		viewer.refresh(process, false);
	}

	
	 * @see IDeltaListener#remove(DeltaEvent)
	 
	public void remove(DeltaEvent event) {
		add(event);
	}

	public void setContentOutlinePage (ModestContentOutlinePage page) {
		outlinePage = page;
	}
	
}*/


/** This class provides the outline page's internal tree viewer with
 * information about the actual model tree. The tree viewer expects to
 * be given arbitrary Objects as input, so it depends on a content provider
 * to find out the nodes in the tree. In our case, the viewer is given
 * a ModestSimulation, and calls getElements on it to get the top-level elements
 * in the tree, then getChildren on them to find their children, and so on. */
public class ModestContentProvider implements ITreeContentProvider {
	
	private static Object[] EMPTY_ARRAY = new Object[0];

	/** Returns the children models of the given Model (only processes can have children). */
	public Object[] getChildren (Object element) {
		//return ((SmlBinding)element).getChildren();
		if (element instanceof Process) {
			//Process proc = (Process)element;
			//return concat(proc.getProcesses().toArray(), proc.getActions().toArray(), proc.getExceptions().toArray(), proc.getVariables().toArray(), proc.getTypes().toArray());
			return ((Process)element).getChildren().toArray();
		}	
		return EMPTY_ARRAY;
	}

	/** Returns the parent model of the given model. */
	public Object getParent (Object element) {
		return ((Model)element).getParent();
	}

	/** Returns whether the given model has any children. */
	public boolean hasChildren (Object element) {
		//return ((SmlBinding)element).hasChildren();
		if (element instanceof Process)
			return (getChildren(element).length > 0);
		else return false;
	}

	/** Returns the top-level models of the given program (which is
	 * conceptually the root of the tree, but is not displayed in the view).
	 * This method is called only on the object given to the tree viewer
	 * in setInput(). */
	public Object[] getElements (Object inputElement){
		return ((ModestSimulation)inputElement).getModels();
	}

	public void dispose () {}

	public void inputChanged (Viewer viewer, Object oldInput, Object newInput) {}

	/*protected Object[] concat(Object[] object, Object[] more, Object[] more2, Object[] more3, Object[] more4) {
		Object[] both = new Object[object.length + more.length + more2.length+ more3.length+ more4.length];
		System.arraycopy(object, 0, both, 0, object.length);
		System.arraycopy(more, 0, both, object.length, more.length);
		System.arraycopy(more2, 0, both, object.length + more.length, more2.length);		
		System.arraycopy(more3, 0, both, object.length + more.length, more3.length);
		System.arraycopy(more4, 0, both, object.length + more.length, more4.length);
		return both;
	}*/
	
}