/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core;


import org.eclipse.core.filebuffers.IDocumentSetupParticipant;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentExtension3;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.jface.text.rules.FastPartitioner;


/**
 * Sets up the document and connects it with a MoDeST specific partitioner. 
 */
public class ModestDocumentSetupParticipant implements IDocumentSetupParticipant {

	public ModestDocumentSetupParticipant() {
	}
	
	/*
	 * @see org.eclipse.core.filebuffers.IDocumentSetupParticipant#setup(org.eclipse.jface.text.IDocument)
	 */
	public void setup(IDocument document) {
		if (document instanceof IDocumentExtension3) {
			IDocumentExtension3 extension3= (IDocumentExtension3) document;
			IDocumentPartitioner partitioner= new FastPartitioner(ModestEditorPlugin.getDefault().getModestPartitionScanner(), ModestPartitionScanner.MODEST_PARTITION_TYPES);
			extension3.setDocumentPartitioner(ModestEditorPlugin.MODEST_PARTITIONING, partitioner);
			partitioner.connect(document);
		}
	}
}
