/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.antlrparser;

import java.io.Reader;

import antlr.RecognitionException;
import antlr.TokenStreamException;
import antlr.collections.AST;

/**
 * The parser that will be used for the outline.
 *
 */
public class ModestOutlineParser extends ModestParser {

	private ModestLexer lexer;
	
	public ModestOutlineParser(ModestLexer lexer) {
		super(lexer);
		this.lexer = lexer;
	}
	
	public ModestOutlineParser(Reader in) {
		this(new ModestLexer(in));
	}
	
	/**
	 * Method is called to build the AST. In order to have the possibility to work with
	 * the offset informations, the AST node class to use is set to ASTWithOffsetInfos.
	 * @return the AST from the given document.
	 * @throws RecognitionException
	 * @throws TokenStreamException
	 */
	
	public AST createAST() throws RecognitionException, TokenStreamException {
		//Class<ASTWithOffsetInfos> myClass = ASTWithOffsetInfos.class;
		/*try { Class ASTNodeClass = Class.forName(ASTWithOffsetInfos.class.getName());
		System.err.println("Die gefundene ASTNodeClass ist: " + ASTNodeClass.toString() + " "+ ASTNodeClass.getName());
		} catch (ClassNotFoundException e) {
			System.err.println("ClassNotFound exception in createAST: " + e);
		}*/
		//setASTNodeClass(ASTWithOffsetInfos.class.getName());
		//setASTNodeType(ASTWithOffsetInfos.class.getName());
		simulation();
		return getAST();
	}
	
	
}
