// $ANTLR 2.7.7 (20061129): "ModestParser.g" -> "ModestParser.java"$

package modesteditor.core.antlrparser;

import modesteditor.core.ModestEditor;
    
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream; 
import java.util.ArrayList;

import org.eclipse.jface.text.IDocument; 
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.Region;

import antlr.CommonAST;  

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class ModestParser extends antlr.LLkParser       implements ModestParserTokenTypes
 {

  // Define a main
  public static void main(String[] args) {
    // Use a try/catch block for parser exceptions
    try {
      // if we have at least one command-line argument
      if (args.length > 0 ) {
        //System.err.println("Parsing...");

        // for each directory/file specified on the command line
        for(int i=0; i< args.length;i++){
        	//System.err.println("Doing file: " + args[i]);
        	doFile(new File(args[i])); // parse it
        	
          	}
      }
      else
        System.err.println("Usage: java ModestParser <directory name>");

    }
    catch(Exception e) {
      System.err.println("exception: "+e);
      e.printStackTrace(System.err);   // so we can get stack trace
    }
  }


  // This method decides what action to take based on the type of
  //   file we are looking at
  public static void doFile(File f) throws Exception {
    // If this is a directory, walk each file/dir in that directory
    if (f.isDirectory()) {
      String files[] = f.list();
      for(int i=0; i < files.length; i++)
        doFile(new File(f, files[i]));
    }

    // otherwise, if this is a MoDeST file, parse it!
    else {
      //System.err.println("-------------------------------------------");
      //System.err.println(f.getAbsolutePath());
      parseFile(new FileInputStream(f));
    }
  }

  // Here's where we do the real work...
  public static void parseFile(InputStream s) throws Exception {
    try {
      // Create a scanner that reads from the input stream passed to us
      ModestLexer lexer = new ModestLexer(s);

      // Create a parser that reads from the scanner
      ModestParser parser = new ModestParser(lexer);

      // start parsing at the compilationUnit rule
      parser.simulation();
    }
    catch (EndOfFileException e) {
    	//System.err.println("Finished parsing!");
    	
    }
    catch (Exception e) {
      System.err.println("parser exception: "+e);
      e.printStackTrace();   // so we can get stack trace		
    }
  }
  
  public ArrayList<IRegion> problems;
  private int actualBreakLine;
  private int actualDocOffset;
  
  public void setActualDocumentOffset(int offset){
	  actualDocOffset=offset;
  }
  
  public void reportError(RecognitionException ex){
	
	try {
		ModestEditor editor = ModestEditor.getEditor();
		IDocument document = editor.getDocumentProvider().getDocument(editor.getEditorInput());
		
		int actualLine = document.getLineOfOffset(actualDocOffset);
		System.err.println("Syntax error at line " + (ex.getLine()+actualLine) + ": " + ex.getMessage());
		
		
		int lineOffset = document.getLineOffset(ex.getLine()-1+actualLine);
		int nextLineOffset = document.getLineOffset(ex.getLine()+actualLine);
		problems.add(new Region(lineOffset,nextLineOffset-lineOffset-1));
	} catch (BadLocationException e) {
		System.err.println("Bad line offset for the erroneous element.");
	}
  }
  
  public int getBreakLine() {
	  return actualBreakLine;
  }

protected ModestParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public ModestParser(TokenBuffer tokenBuf) {
  this(tokenBuf,4);
}

protected ModestParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public ModestParser(TokenStream lexer) {
  this(lexer,4);
}

public ModestParser(ParserSharedInputState state) {
  super(state,4);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void simulation() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos simulation_AST = null;
		astFactory.setASTNodeClass(ASTWithOffsetInfos.class);
		problems = new ArrayList<IRegion>();
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_defaults:
			{
				defaultsSection();
				break;
			}
			case LBRACE:
			case LITERAL_patient:
			case LITERAL_impatient:
			case LITERAL_urgent:
			case LITERAL_action:
			case ID:
			case LITERAL_float:
			case LITERAL_int:
			case LITERAL_bool:
			case LITERAL_clock:
			case LITERAL_const:
			case LITERAL_extern:
			case LITERAL_exception:
			case LITERAL_typedef:
			case LITERAL_process:
			case LITERAL_try:
			case LITERAL_when:
			case LITERAL_alt:
			case LITERAL_do:
			case LITERAL_par:
			case LITERAL_hide:
			case LITERAL_relabel:
			case LITERAL_extend:
			case LITERAL_prefix:
			case LITERAL_break:
			case LITERAL_return:
			case LITERAL_throw:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop4:
			do {
				if ((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2))) && (_tokenSet_2.member(LA(3))) && (_tokenSet_3.member(LA(4)))) {
					declaration();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop4;
				}
				
			} while (true);
			}
			sequentialProcess();
			actualBreakLine = LT(1).getLine();
			simulation_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_4);
		}
		returnAST = simulation_AST;
	}
	
/** Rule to take care of defaults section
 */
	public final void defaultsSection() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos defaultsSection_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp1_AST = null;
			tmp1_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp1_AST);
			match(LITERAL_defaults);
			ASTWithOffsetInfos tmp2_AST = null;
			tmp2_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp2_AST);
			match(LBRACE);
			{
			int _cnt9=0;
			_loop9:
			do {
				switch ( LA(1)) {
				case LITERAL_actions:
				{
					ASTWithOffsetInfos tmp3_AST = null;
					tmp3_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp3_AST);
					match(LITERAL_actions);
					ASTWithOffsetInfos tmp4_AST = null;
					tmp4_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp4_AST);
					match(EQUAL);
					{
					switch ( LA(1)) {
					case LITERAL_patient:
					{
						ASTWithOffsetInfos tmp5_AST = null;
						tmp5_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp5_AST);
						match(LITERAL_patient);
						break;
					}
					case LITERAL_impatient:
					{
						ASTWithOffsetInfos tmp6_AST = null;
						tmp6_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp6_AST);
						match(LITERAL_impatient);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					ASTWithOffsetInfos tmp7_AST = null;
					tmp7_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp7_AST);
					match(SEMI);
					break;
				}
				case LITERAL_guards:
				{
					ASTWithOffsetInfos tmp8_AST = null;
					tmp8_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp8_AST);
					match(LITERAL_guards);
					ASTWithOffsetInfos tmp9_AST = null;
					tmp9_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp9_AST);
					match(EQUAL);
					{
					switch ( LA(1)) {
					case LITERAL_urgent:
					{
						ASTWithOffsetInfos tmp10_AST = null;
						tmp10_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp10_AST);
						match(LITERAL_urgent);
						break;
					}
					case LITERAL_not_urgent:
					{
						ASTWithOffsetInfos tmp11_AST = null;
						tmp11_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp11_AST);
						match(LITERAL_not_urgent);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					ASTWithOffsetInfos tmp12_AST = null;
					tmp12_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp12_AST);
					match(SEMI);
					break;
				}
				default:
				{
					if ( _cnt9>=1 ) { break _loop9; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				}
				_cnt9++;
			} while (true);
			}
			ASTWithOffsetInfos tmp13_AST = null;
			tmp13_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp13_AST);
			match(RBRACE);
			defaultsSection_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_5);
		}
		returnAST = defaultsSection_AST;
	}
	
	public final void declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos declaration_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_exception:
			{
				exceptionDeclaration();
				astFactory.addASTChild(currentAST, returnAST);
				declaration_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_typedef:
			{
				structDeclaration();
				astFactory.addASTChild(currentAST, returnAST);
				declaration_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_process:
			{
				processDeclaration();
				astFactory.addASTChild(currentAST, returnAST);
				declaration_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
				if ((LA(1)==LITERAL_patient||LA(1)==LITERAL_impatient||LA(1)==LITERAL_action) && (LA(2)==LITERAL_action||LA(2)==ID) && (LA(3)==SEMI||LA(3)==ID||LA(3)==COMMA) && (_tokenSet_6.member(LA(4)))) {
					actionDeclaration();
					astFactory.addASTChild(currentAST, returnAST);
					declaration_AST = (ASTWithOffsetInfos)currentAST.root;
				}
				else if ((_tokenSet_7.member(LA(1))) && (_tokenSet_8.member(LA(2))) && (_tokenSet_9.member(LA(3))) && (_tokenSet_10.member(LA(4)))) {
					variableDeclaration();
					astFactory.addASTChild(currentAST, returnAST);
					declaration_AST = (ASTWithOffsetInfos)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = declaration_AST;
	}
	
	public final void sequentialProcess() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos sequentialProcess_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_12.member(LA(1))) && (_tokenSet_13.member(LA(2))) && (_tokenSet_14.member(LA(3))) && (_tokenSet_15.member(LA(4)))) {
				localProcess();
				astFactory.addASTChild(currentAST, returnAST);
				sequentialProcess_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_12.member(LA(1))) && (_tokenSet_16.member(LA(2))) && (_tokenSet_17.member(LA(3))) && (_tokenSet_15.member(LA(4)))) {
				localProcess();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp14_AST = null;
				tmp14_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp14_AST);
				match(SEMI);
				sequentialProcess();
				astFactory.addASTChild(currentAST, returnAST);
				sequentialProcess_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_18);
		}
		returnAST = sequentialProcess_AST;
	}
	
	public final void actionDeclaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos actionDeclaration_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_action:
			{
				ASTWithOffsetInfos tmp15_AST = null;
				tmp15_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp15_AST);
				match(LITERAL_action);
				idList();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp16_AST = null;
				tmp16_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp16_AST);
				match(SEMI);
				actionDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_patient:
			{
				ASTWithOffsetInfos tmp17_AST = null;
				tmp17_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp17_AST);
				match(LITERAL_patient);
				ASTWithOffsetInfos tmp18_AST = null;
				tmp18_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp18_AST);
				match(LITERAL_action);
				idList();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp19_AST = null;
				tmp19_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp19_AST);
				match(SEMI);
				actionDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_impatient:
			{
				ASTWithOffsetInfos tmp20_AST = null;
				tmp20_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp20_AST);
				match(LITERAL_impatient);
				ASTWithOffsetInfos tmp21_AST = null;
				tmp21_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp21_AST);
				match(LITERAL_action);
				idList();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp22_AST = null;
				tmp22_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp22_AST);
				match(SEMI);
				actionDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = actionDeclaration_AST;
	}
	
	public final void variableDeclaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos variableDeclaration_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_19.member(LA(1))) && (_tokenSet_20.member(LA(2))) && (LA(3)==ID||LA(3)==LBRACKET) && (_tokenSet_21.member(LA(4)))) {
				{
				switch ( LA(1)) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case LITERAL_action:
				case ID:
				case LITERAL_float:
				case LITERAL_int:
				case LITERAL_clock:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				qType();
				astFactory.addASTChild(currentAST, returnAST);
				arrayDeclaration();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp23_AST = null;
				tmp23_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp23_AST);
				match(SEMI);
				variableDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==LITERAL_float||LA(1)==LITERAL_const||LA(1)==LITERAL_extern) && (LA(2)==ID||LA(2)==LITERAL_float) && (_tokenSet_22.member(LA(3))) && (_tokenSet_23.member(LA(4)))) {
				{
				switch ( LA(1)) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case LITERAL_float:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				ASTWithOffsetInfos tmp24_AST = null;
				tmp24_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp24_AST);
				match(LITERAL_float);
				ASTWithOffsetInfos tmp25_AST = null;
				tmp25_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp25_AST);
				match(ID);
				{
				switch ( LA(1)) {
				case EQUAL:
				{
					ASTWithOffsetInfos tmp26_AST = null;
					tmp26_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp26_AST);
					match(EQUAL);
					ASTWithOffsetInfos tmp27_AST = null;
					tmp27_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp27_AST);
					match(FLOAT);
					break;
				}
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				{
				_loop21:
				do {
					if ((LA(1)==COMMA)) {
						ASTWithOffsetInfos tmp28_AST = null;
						tmp28_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp28_AST);
						match(COMMA);
						ASTWithOffsetInfos tmp29_AST = null;
						tmp29_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp29_AST);
						match(ID);
						{
						switch ( LA(1)) {
						case EQUAL:
						{
							ASTWithOffsetInfos tmp30_AST = null;
							tmp30_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp30_AST);
							match(EQUAL);
							ASTWithOffsetInfos tmp31_AST = null;
							tmp31_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp31_AST);
							match(FLOAT);
							break;
						}
						case SEMI:
						case COMMA:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
					}
					else {
						break _loop21;
					}
					
				} while (true);
				}
				ASTWithOffsetInfos tmp32_AST = null;
				tmp32_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp32_AST);
				match(SEMI);
				variableDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==LITERAL_int||LA(1)==LITERAL_const||LA(1)==LITERAL_extern) && (LA(2)==ID||LA(2)==LITERAL_int) && (_tokenSet_22.member(LA(3))) && (_tokenSet_24.member(LA(4)))) {
				{
				switch ( LA(1)) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case LITERAL_int:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				ASTWithOffsetInfos tmp33_AST = null;
				tmp33_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp33_AST);
				match(LITERAL_int);
				ASTWithOffsetInfos tmp34_AST = null;
				tmp34_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp34_AST);
				match(ID);
				{
				switch ( LA(1)) {
				case EQUAL:
				{
					ASTWithOffsetInfos tmp35_AST = null;
					tmp35_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp35_AST);
					match(EQUAL);
					ASTWithOffsetInfos tmp36_AST = null;
					tmp36_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp36_AST);
					match(INT);
					break;
				}
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				{
				_loop26:
				do {
					if ((LA(1)==COMMA)) {
						ASTWithOffsetInfos tmp37_AST = null;
						tmp37_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp37_AST);
						match(COMMA);
						ASTWithOffsetInfos tmp38_AST = null;
						tmp38_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp38_AST);
						match(ID);
						{
						switch ( LA(1)) {
						case EQUAL:
						{
							ASTWithOffsetInfos tmp39_AST = null;
							tmp39_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp39_AST);
							match(EQUAL);
							ASTWithOffsetInfos tmp40_AST = null;
							tmp40_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp40_AST);
							match(INT);
							break;
						}
						case SEMI:
						case COMMA:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
					}
					else {
						break _loop26;
					}
					
				} while (true);
				}
				ASTWithOffsetInfos tmp41_AST = null;
				tmp41_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp41_AST);
				match(SEMI);
				variableDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==LITERAL_bool||LA(1)==LITERAL_const||LA(1)==LITERAL_extern) && (LA(2)==ID||LA(2)==LITERAL_bool) && (_tokenSet_22.member(LA(3))) && (_tokenSet_25.member(LA(4)))) {
				{
				switch ( LA(1)) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case LITERAL_bool:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				ASTWithOffsetInfos tmp42_AST = null;
				tmp42_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp42_AST);
				match(LITERAL_bool);
				ASTWithOffsetInfos tmp43_AST = null;
				tmp43_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp43_AST);
				match(ID);
				{
				switch ( LA(1)) {
				case EQUAL:
				{
					ASTWithOffsetInfos tmp44_AST = null;
					tmp44_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp44_AST);
					match(EQUAL);
					{
					switch ( LA(1)) {
					case LITERAL_true:
					{
						ASTWithOffsetInfos tmp45_AST = null;
						tmp45_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp45_AST);
						match(LITERAL_true);
						break;
					}
					case LITERAL_false:
					{
						ASTWithOffsetInfos tmp46_AST = null;
						tmp46_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp46_AST);
						match(LITERAL_false);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				{
				_loop33:
				do {
					if ((LA(1)==COMMA)) {
						ASTWithOffsetInfos tmp47_AST = null;
						tmp47_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp47_AST);
						match(COMMA);
						ASTWithOffsetInfos tmp48_AST = null;
						tmp48_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp48_AST);
						match(ID);
						{
						switch ( LA(1)) {
						case EQUAL:
						{
							ASTWithOffsetInfos tmp49_AST = null;
							tmp49_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp49_AST);
							match(EQUAL);
							{
							switch ( LA(1)) {
							case LITERAL_true:
							{
								ASTWithOffsetInfos tmp50_AST = null;
								tmp50_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
								astFactory.addASTChild(currentAST, tmp50_AST);
								match(LITERAL_true);
								break;
							}
							case LITERAL_false:
							{
								ASTWithOffsetInfos tmp51_AST = null;
								tmp51_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
								astFactory.addASTChild(currentAST, tmp51_AST);
								match(LITERAL_false);
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							}
							}
							break;
						}
						case SEMI:
						case COMMA:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
					}
					else {
						break _loop33;
					}
					
				} while (true);
				}
				ASTWithOffsetInfos tmp52_AST = null;
				tmp52_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp52_AST);
				match(SEMI);
				variableDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if (((LA(1) >= LITERAL_clock && LA(1) <= LITERAL_extern)) && (LA(2)==ID||LA(2)==LITERAL_clock) && (_tokenSet_22.member(LA(3))) && (_tokenSet_24.member(LA(4)))) {
				{
				switch ( LA(1)) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case LITERAL_clock:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				ASTWithOffsetInfos tmp53_AST = null;
				tmp53_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp53_AST);
				match(LITERAL_clock);
				ASTWithOffsetInfos tmp54_AST = null;
				tmp54_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp54_AST);
				match(ID);
				{
				switch ( LA(1)) {
				case EQUAL:
				{
					ASTWithOffsetInfos tmp55_AST = null;
					tmp55_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp55_AST);
					match(EQUAL);
					ASTWithOffsetInfos tmp56_AST = null;
					tmp56_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp56_AST);
					match(INT);
					break;
				}
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				{
				_loop38:
				do {
					if ((LA(1)==COMMA)) {
						ASTWithOffsetInfos tmp57_AST = null;
						tmp57_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp57_AST);
						match(COMMA);
						ASTWithOffsetInfos tmp58_AST = null;
						tmp58_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp58_AST);
						match(ID);
						{
						switch ( LA(1)) {
						case EQUAL:
						{
							ASTWithOffsetInfos tmp59_AST = null;
							tmp59_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp59_AST);
							match(EQUAL);
							ASTWithOffsetInfos tmp60_AST = null;
							tmp60_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp60_AST);
							match(INT);
							break;
						}
						case SEMI:
						case COMMA:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
					}
					else {
						break _loop38;
					}
					
				} while (true);
				}
				ASTWithOffsetInfos tmp61_AST = null;
				tmp61_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp61_AST);
				match(SEMI);
				variableDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = variableDeclaration_AST;
	}
	
	public final void exceptionDeclaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos exceptionDeclaration_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp62_AST = null;
			tmp62_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp62_AST);
			match(LITERAL_exception);
			idList();
			astFactory.addASTChild(currentAST, returnAST);
			ASTWithOffsetInfos tmp63_AST = null;
			tmp63_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp63_AST);
			match(SEMI);
			exceptionDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = exceptionDeclaration_AST;
	}
	
	public final void structDeclaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos structDeclaration_AST = null;
		
		try {      // for error handling
			if ((LA(1)==LITERAL_typedef) && (LA(2)==LITERAL_struct)) {
				ASTWithOffsetInfos tmp64_AST = null;
				tmp64_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp64_AST);
				match(LITERAL_typedef);
				ASTWithOffsetInfos tmp65_AST = null;
				tmp65_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp65_AST);
				match(LITERAL_struct);
				ASTWithOffsetInfos tmp66_AST = null;
				tmp66_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp66_AST);
				match(LBRACE);
				{
				int _cnt52=0;
				_loop52:
				do {
					if ((_tokenSet_7.member(LA(1)))) {
						variableDeclaration();
					}
					else {
						if ( _cnt52>=1 ) { break _loop52; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt52++;
				} while (true);
				}
				ASTWithOffsetInfos tmp67_AST = null;
				tmp67_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp67_AST);
				match(RBRACE);
				ASTWithOffsetInfos tmp68_AST = null;
				tmp68_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp68_AST);
				match(ID);
				ASTWithOffsetInfos tmp69_AST = null;
				tmp69_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp69_AST);
				match(SEMI);
				structDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==LITERAL_typedef) && (LA(2)==LITERAL_set)) {
				ASTWithOffsetInfos tmp70_AST = null;
				tmp70_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp70_AST);
				match(LITERAL_typedef);
				ASTWithOffsetInfos tmp71_AST = null;
				tmp71_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp71_AST);
				match(LITERAL_set);
				ASTWithOffsetInfos tmp72_AST = null;
				tmp72_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp72_AST);
				match(LBRACE);
				{
				idList();
				}
				ASTWithOffsetInfos tmp73_AST = null;
				tmp73_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp73_AST);
				match(RBRACE);
				ASTWithOffsetInfos tmp74_AST = null;
				tmp74_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp74_AST);
				match(ID);
				ASTWithOffsetInfos tmp75_AST = null;
				tmp75_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp75_AST);
				match(SEMI);
				structDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==LITERAL_typedef) && (LA(2)==LITERAL_range)) {
				ASTWithOffsetInfos tmp76_AST = null;
				tmp76_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp76_AST);
				match(LITERAL_typedef);
				ASTWithOffsetInfos tmp77_AST = null;
				tmp77_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp77_AST);
				match(LITERAL_range);
				ASTWithOffsetInfos tmp78_AST = null;
				tmp78_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp78_AST);
				match(LBRACKET);
				ASTWithOffsetInfos tmp79_AST = null;
				tmp79_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp79_AST);
				match(INT);
				ASTWithOffsetInfos tmp80_AST = null;
				tmp80_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp80_AST);
				match(DOTDOT);
				ASTWithOffsetInfos tmp81_AST = null;
				tmp81_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp81_AST);
				match(INT);
				ASTWithOffsetInfos tmp82_AST = null;
				tmp82_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp82_AST);
				match(RBRACKET);
				ASTWithOffsetInfos tmp83_AST = null;
				tmp83_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp83_AST);
				match(ID);
				ASTWithOffsetInfos tmp84_AST = null;
				tmp84_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp84_AST);
				match(SEMI);
				structDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = structDeclaration_AST;
	}
	
	public final void processDeclaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos processDeclaration_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp85_AST = null;
			tmp85_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp85_AST);
			match(LITERAL_process);
			ASTWithOffsetInfos tmp86_AST = null;
			tmp86_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp86_AST);
			match(ID);
			ASTWithOffsetInfos tmp87_AST = null;
			tmp87_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp87_AST);
			match(LPAR);
			{
			arguments();
			}
			ASTWithOffsetInfos tmp88_AST = null;
			tmp88_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp88_AST);
			match(RPAR);
			ASTWithOffsetInfos tmp89_AST = null;
			tmp89_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp89_AST);
			match(LBRACE);
			body();
			astFactory.addASTChild(currentAST, returnAST);
			ASTWithOffsetInfos tmp90_AST = null;
			tmp90_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp90_AST);
			match(RBRACE);
			processDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = processDeclaration_AST;
	}
	
	public final void idList() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos idList_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp91_AST = null;
			tmp91_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp91_AST);
			match(ID);
			{
			_loop14:
			do {
				if ((LA(1)==COMMA)) {
					ASTWithOffsetInfos tmp92_AST = null;
					tmp92_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp92_AST);
					match(COMMA);
					ASTWithOffsetInfos tmp93_AST = null;
					tmp93_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp93_AST);
					match(ID);
				}
				else {
					break _loop14;
				}
				
			} while (true);
			}
			idList_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_26);
		}
		returnAST = idList_AST;
	}
	
	public final void modifier() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos modifier_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_const:
			{
				ASTWithOffsetInfos tmp94_AST = null;
				tmp94_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp94_AST);
				match(LITERAL_const);
				modifier_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_extern:
			{
				ASTWithOffsetInfos tmp95_AST = null;
				tmp95_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp95_AST);
				match(LITERAL_extern);
				modifier_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_8);
		}
		returnAST = modifier_AST;
	}
	
	public final void qType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos qType_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_int:
			{
				ASTWithOffsetInfos tmp96_AST = null;
				tmp96_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp96_AST);
				match(LITERAL_int);
				qType_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_float:
			{
				ASTWithOffsetInfos tmp97_AST = null;
				tmp97_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp97_AST);
				match(LITERAL_float);
				qType_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_clock:
			{
				ASTWithOffsetInfos tmp98_AST = null;
				tmp98_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp98_AST);
				match(LITERAL_clock);
				qType_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_action:
			{
				ASTWithOffsetInfos tmp99_AST = null;
				tmp99_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp99_AST);
				match(LITERAL_action);
				qType_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case ID:
			{
				ASTWithOffsetInfos tmp100_AST = null;
				tmp100_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp100_AST);
				match(ID);
				qType_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_27);
		}
		returnAST = qType_AST;
	}
	
	public final void arrayDeclaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos arrayDeclaration_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp101_AST = null;
			tmp101_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp101_AST);
			match(ID);
			{
			int _cnt43=0;
			_loop43:
			do {
				if ((LA(1)==LBRACKET)) {
					ASTWithOffsetInfos tmp102_AST = null;
					tmp102_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp102_AST);
					match(LBRACKET);
					{
					expression();
					}
					ASTWithOffsetInfos tmp103_AST = null;
					tmp103_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp103_AST);
					match(RBRACKET);
				}
				else {
					if ( _cnt43>=1 ) { break _loop43; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt43++;
			} while (true);
			}
			{
			_loop48:
			do {
				if ((LA(1)==COMMA)) {
					ASTWithOffsetInfos tmp104_AST = null;
					tmp104_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp104_AST);
					match(COMMA);
					ASTWithOffsetInfos tmp105_AST = null;
					tmp105_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp105_AST);
					match(ID);
					{
					int _cnt47=0;
					_loop47:
					do {
						if ((LA(1)==LBRACKET)) {
							ASTWithOffsetInfos tmp106_AST = null;
							tmp106_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp106_AST);
							match(LBRACKET);
							{
							expression();
							astFactory.addASTChild(currentAST, returnAST);
							}
							ASTWithOffsetInfos tmp107_AST = null;
							tmp107_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp107_AST);
							match(RBRACKET);
						}
						else {
							if ( _cnt47>=1 ) { break _loop47; } else {throw new NoViableAltException(LT(1), getFilename());}
						}
						
						_cnt47++;
					} while (true);
					}
				}
				else {
					break _loop48;
				}
				
			} while (true);
			}
			arrayDeclaration_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_28);
		}
		returnAST = arrayDeclaration_AST;
	}
	
	public final void expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos expression_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_29.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				orExpr();
				astFactory.addASTChild(currentAST, returnAST);
				expression_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_31.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_33.member(LA(4)))) {
				orExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp108_AST = null;
				tmp108_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp108_AST);
				match(QUESTION);
				orExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp109_AST = null;
				tmp109_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp109_AST);
				match(COLON);
				orExpr();
				astFactory.addASTChild(currentAST, returnAST);
				expression_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_34);
		}
		returnAST = expression_AST;
	}
	
	public final void arguments() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos arguments_AST = null;
		
		try {      // for error handling
			{
			_loop58:
			do {
				if ((_tokenSet_8.member(LA(1)))) {
					type();
					astFactory.addASTChild(currentAST, returnAST);
					ASTWithOffsetInfos tmp110_AST = null;
					tmp110_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp110_AST);
					match(ID);
				}
				else {
					break _loop58;
				}
				
			} while (true);
			}
			arguments_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_35);
		}
		returnAST = arguments_AST;
	}
	
	public final void body() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos body_AST = null;
		
		try {      // for error handling
			{
			_loop62:
			do {
				if ((_tokenSet_12.member(LA(1))) && (_tokenSet_36.member(LA(2))) && (_tokenSet_14.member(LA(3))) && (_tokenSet_15.member(LA(4)))) {
					sequentialProcess();
				}
				else if ((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2))) && (_tokenSet_2.member(LA(3))) && (_tokenSet_37.member(LA(4)))) {
					declaration();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop62;
				}
				
			} while (true);
			}
			body_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_38);
		}
		returnAST = body_AST;
	}
	
	public final void type() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos type_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_int:
			{
				ASTWithOffsetInfos tmp111_AST = null;
				tmp111_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp111_AST);
				match(LITERAL_int);
				type_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_float:
			{
				ASTWithOffsetInfos tmp112_AST = null;
				tmp112_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp112_AST);
				match(LITERAL_float);
				type_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_clock:
			{
				ASTWithOffsetInfos tmp113_AST = null;
				tmp113_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp113_AST);
				match(LITERAL_clock);
				type_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_action:
			{
				ASTWithOffsetInfos tmp114_AST = null;
				tmp114_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp114_AST);
				match(LITERAL_action);
				type_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_bool:
			{
				ASTWithOffsetInfos tmp115_AST = null;
				tmp115_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp115_AST);
				match(LITERAL_bool);
				type_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case ID:
			{
				ASTWithOffsetInfos tmp116_AST = null;
				tmp116_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp116_AST);
				match(ID);
				type_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_39);
		}
		returnAST = type_AST;
	}
	
	public final void orExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos orExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_40.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				andExpr();
				astFactory.addASTChild(currentAST, returnAST);
				orExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_41.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				andExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp117_AST = null;
				tmp117_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp117_AST);
				match(OROR);
				orExpr();
				astFactory.addASTChild(currentAST, returnAST);
				orExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_43);
		}
		returnAST = orExpr_AST;
	}
	
	public final void andExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos andExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_44.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				bitOrExpr();
				astFactory.addASTChild(currentAST, returnAST);
				andExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_45.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				bitOrExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp118_AST = null;
				tmp118_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp118_AST);
				match(ANDAND);
				andExpr();
				astFactory.addASTChild(currentAST, returnAST);
				andExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_46);
		}
		returnAST = andExpr_AST;
	}
	
	public final void bitOrExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos bitOrExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_47.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				bitExclOrExpr();
				astFactory.addASTChild(currentAST, returnAST);
				bitOrExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_48.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				bitExclOrExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp119_AST = null;
				tmp119_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp119_AST);
				match(OR);
				bitOrExpr();
				astFactory.addASTChild(currentAST, returnAST);
				bitOrExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_49);
		}
		returnAST = bitOrExpr_AST;
	}
	
	public final void bitExclOrExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos bitExclOrExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_50.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				bitAndExpr();
				astFactory.addASTChild(currentAST, returnAST);
				bitExclOrExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_51.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				bitAndExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp120_AST = null;
				tmp120_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp120_AST);
				match(XOR);
				bitExclOrExpr();
				astFactory.addASTChild(currentAST, returnAST);
				bitExclOrExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_52);
		}
		returnAST = bitExclOrExpr_AST;
	}
	
	public final void bitAndExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos bitAndExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_53.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				equalityExpr();
				astFactory.addASTChild(currentAST, returnAST);
				bitAndExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_54.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				equalityExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp121_AST = null;
				tmp121_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp121_AST);
				match(AND);
				bitAndExpr();
				astFactory.addASTChild(currentAST, returnAST);
				bitAndExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_55);
		}
		returnAST = bitAndExpr_AST;
	}
	
	public final void equalityExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos equalityExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_56.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				relExpr();
				astFactory.addASTChild(currentAST, returnAST);
				equalityExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_57.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				relExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp122_AST = null;
				tmp122_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp122_AST);
				match(EQUALEQUAL);
				equalityExpr();
				astFactory.addASTChild(currentAST, returnAST);
				equalityExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_58.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				relExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp123_AST = null;
				tmp123_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp123_AST);
				match(NOT_EQUAL);
				equalityExpr();
				astFactory.addASTChild(currentAST, returnAST);
				equalityExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_59);
		}
		returnAST = equalityExpr_AST;
	}
	
	public final void relExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos relExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_60.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				relExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_61.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp124_AST = null;
				tmp124_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp124_AST);
				match(GT);
				relExpr();
				astFactory.addASTChild(currentAST, returnAST);
				relExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_62.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp125_AST = null;
				tmp125_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp125_AST);
				match(LT);
				relExpr();
				astFactory.addASTChild(currentAST, returnAST);
				relExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_63.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp126_AST = null;
				tmp126_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp126_AST);
				match(GTE);
				relExpr();
				astFactory.addASTChild(currentAST, returnAST);
				relExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_64.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp127_AST = null;
				tmp127_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp127_AST);
				match(LTE);
				relExpr();
				astFactory.addASTChild(currentAST, returnAST);
				relExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_65);
		}
		returnAST = relExpr_AST;
	}
	
	public final void shiftExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos shiftExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_66.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				shiftExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_67.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp128_AST = null;
				tmp128_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp128_AST);
				match(LEFTSHIFT);
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				shiftExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_68.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp129_AST = null;
				tmp129_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp129_AST);
				match(RIGHTSHIFT);
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				shiftExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_69.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp130_AST = null;
				tmp130_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp130_AST);
				match(ULEFTSHIFT);
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				shiftExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_70.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp131_AST = null;
				tmp131_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp131_AST);
				match(URIGHTSHIFT);
				shiftExpr();
				astFactory.addASTChild(currentAST, returnAST);
				shiftExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_71);
		}
		returnAST = shiftExpr_AST;
	}
	
	public final void additiveExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos additiveExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_72.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_73.member(LA(4)))) {
				multExpr();
				astFactory.addASTChild(currentAST, returnAST);
				additiveExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_74.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				multExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp132_AST = null;
				tmp132_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp132_AST);
				match(PLUS);
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				additiveExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_74.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				multExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp133_AST = null;
				tmp133_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp133_AST);
				match(MINUS);
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				additiveExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_75);
		}
		returnAST = additiveExpr_AST;
	}
	
	public final void multExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos multExpr_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_21.member(LA(1))) && (_tokenSet_76.member(LA(2))) && (_tokenSet_30.member(LA(3))) && (_tokenSet_73.member(LA(4)))) {
				unaryExpr();
				astFactory.addASTChild(currentAST, returnAST);
				multExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_77.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				unaryExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp134_AST = null;
				tmp134_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp134_AST);
				match(TIMES);
				multExpr();
				astFactory.addASTChild(currentAST, returnAST);
				multExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_78.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				unaryExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp135_AST = null;
				tmp135_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp135_AST);
				match(DIV);
				multExpr();
				astFactory.addASTChild(currentAST, returnAST);
				multExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_79.member(LA(2))) && (_tokenSet_32.member(LA(3))) && (_tokenSet_42.member(LA(4)))) {
				unaryExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp136_AST = null;
				tmp136_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp136_AST);
				match(REMAINDER);
				multExpr();
				astFactory.addASTChild(currentAST, returnAST);
				multExpr_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_80);
		}
		returnAST = multExpr_AST;
	}
	
	public final void unaryExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos unaryExpr_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case PLUS:
			{
				ASTWithOffsetInfos tmp137_AST = null;
				tmp137_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp137_AST);
				match(PLUS);
				baseExpr();
				astFactory.addASTChild(currentAST, returnAST);
				unaryExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case MINUS:
			{
				ASTWithOffsetInfos tmp138_AST = null;
				tmp138_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp138_AST);
				match(MINUS);
				baseExpr();
				astFactory.addASTChild(currentAST, returnAST);
				unaryExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case NOT:
			{
				ASTWithOffsetInfos tmp139_AST = null;
				tmp139_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp139_AST);
				match(NOT);
				baseExpr();
				astFactory.addASTChild(currentAST, returnAST);
				unaryExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LBRACE:
			case ID:
			case FLOAT:
			case INT:
			case LITERAL_true:
			case LITERAL_false:
			case LBRACKET:
			case LPAR:
			{
				baseExpr();
				astFactory.addASTChild(currentAST, returnAST);
				unaryExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_81);
		}
		returnAST = unaryExpr_AST;
	}
	
	public final void baseExpr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos baseExpr_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case INT:
			{
				ASTWithOffsetInfos tmp140_AST = null;
				tmp140_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp140_AST);
				match(INT);
				baseExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case FLOAT:
			{
				ASTWithOffsetInfos tmp141_AST = null;
				tmp141_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp141_AST);
				match(FLOAT);
				baseExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LPAR:
			{
				ASTWithOffsetInfos tmp142_AST = null;
				tmp142_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp142_AST);
				match(LPAR);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp143_AST = null;
				tmp143_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp143_AST);
				match(RPAR);
				baseExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LBRACE:
			{
				set();
				astFactory.addASTChild(currentAST, returnAST);
				baseExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LBRACKET:
			{
				range();
				astFactory.addASTChild(currentAST, returnAST);
				baseExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_true:
			{
				ASTWithOffsetInfos tmp144_AST = null;
				tmp144_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp144_AST);
				match(LITERAL_true);
				baseExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_false:
			{
				ASTWithOffsetInfos tmp145_AST = null;
				tmp145_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp145_AST);
				match(LITERAL_false);
				baseExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case ID:
			{
				ASTWithOffsetInfos tmp146_AST = null;
				tmp146_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp146_AST);
				match(ID);
				baseExpr_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_81);
		}
		returnAST = baseExpr_AST;
	}
	
	public final void set() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos set_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp147_AST = null;
			tmp147_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp147_AST);
			match(LBRACE);
			setElement();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop78:
			do {
				if ((LA(1)==COMMA)) {
					ASTWithOffsetInfos tmp148_AST = null;
					tmp148_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp148_AST);
					match(COMMA);
					setElement();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop78;
				}
				
			} while (true);
			}
			ASTWithOffsetInfos tmp149_AST = null;
			tmp149_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp149_AST);
			match(RBRACE);
			set_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_82);
		}
		returnAST = set_AST;
	}
	
	public final void range() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos range_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp150_AST = null;
			tmp150_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp150_AST);
			match(LBRACKET);
			{
			if ((_tokenSet_20.member(LA(1))) && (LA(2)==RBRACKET)) {
				qType();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_83.member(LA(2)))) {
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp151_AST = null;
				tmp151_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp151_AST);
				match(DOTDOT);
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			ASTWithOffsetInfos tmp152_AST = null;
			tmp152_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp152_AST);
			match(RBRACKET);
			range_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_81);
		}
		returnAST = range_AST;
	}
	
	public final void setElement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos setElement_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case INT:
			{
				ASTWithOffsetInfos tmp153_AST = null;
				tmp153_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp153_AST);
				match(INT);
				setElement_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LBRACKET:
			{
				range();
				astFactory.addASTChild(currentAST, returnAST);
				setElement_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LBRACE:
			{
				ASTWithOffsetInfos tmp154_AST = null;
				tmp154_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp154_AST);
				match(LBRACE);
				qID();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp155_AST = null;
				tmp155_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp155_AST);
				match(RBRACE);
				setElement_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
				if ((LA(1)==ID) && (LA(2)==RBRACE||LA(2)==COMMA) && (_tokenSet_84.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
					ASTWithOffsetInfos tmp156_AST = null;
					tmp156_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp156_AST);
					match(ID);
					setElement_AST = (ASTWithOffsetInfos)currentAST.root;
				}
				else if ((_tokenSet_20.member(LA(1))) && (LA(2)==RBRACE||LA(2)==COMMA) && (_tokenSet_84.member(LA(3))) && (_tokenSet_30.member(LA(4)))) {
					qType();
					astFactory.addASTChild(currentAST, returnAST);
					setElement_AST = (ASTWithOffsetInfos)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_85);
		}
		returnAST = setElement_AST;
	}
	
	public final void qID() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos qID_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp157_AST = null;
			tmp157_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp157_AST);
			match(ID);
			{
			_loop83:
			do {
				switch ( LA(1)) {
				case DOT:
				{
					ASTWithOffsetInfos tmp158_AST = null;
					tmp158_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp158_AST);
					match(DOT);
					ASTWithOffsetInfos tmp159_AST = null;
					tmp159_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp159_AST);
					match(ID);
					break;
				}
				case LBRACKET:
				{
					ASTWithOffsetInfos tmp160_AST = null;
					tmp160_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp160_AST);
					match(LBRACKET);
					expression();
					astFactory.addASTChild(currentAST, returnAST);
					ASTWithOffsetInfos tmp161_AST = null;
					tmp161_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp161_AST);
					match(RBRACKET);
					break;
				}
				default:
				{
					break _loop83;
				}
				}
			} while (true);
			}
			qID_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_38);
		}
		returnAST = qID_AST;
	}
	
	public final void tryBlock() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos tryBlock_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp162_AST = null;
			tmp162_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp162_AST);
			match(LITERAL_try);
			ASTWithOffsetInfos tmp163_AST = null;
			tmp163_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp163_AST);
			match(LBRACE);
			body();
			astFactory.addASTChild(currentAST, returnAST);
			ASTWithOffsetInfos tmp164_AST = null;
			tmp164_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp164_AST);
			match(RBRACE);
			{
			int _cnt88=0;
			_loop88:
			do {
				if ((LA(1)==LITERAL_catch)) {
					ASTWithOffsetInfos tmp165_AST = null;
					tmp165_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp165_AST);
					match(LITERAL_catch);
					ASTWithOffsetInfos tmp166_AST = null;
					tmp166_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp166_AST);
					match(LPAR);
					ASTWithOffsetInfos tmp167_AST = null;
					tmp167_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp167_AST);
					match(ID);
					ASTWithOffsetInfos tmp168_AST = null;
					tmp168_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp168_AST);
					match(RPAR);
					ASTWithOffsetInfos tmp169_AST = null;
					tmp169_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp169_AST);
					match(LBRACE);
					body();
					astFactory.addASTChild(currentAST, returnAST);
					ASTWithOffsetInfos tmp170_AST = null;
					tmp170_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp170_AST);
					match(RBRACE);
				}
				else {
					if ( _cnt88>=1 ) { break _loop88; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt88++;
			} while (true);
			}
			tryBlock_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = tryBlock_AST;
	}
	
	public final void guardedProcess() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos guardedProcess_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_when:
			{
				ASTWithOffsetInfos tmp171_AST = null;
				tmp171_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp171_AST);
				match(LITERAL_when);
				ASTWithOffsetInfos tmp172_AST = null;
				tmp172_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp172_AST);
				match(LPAR);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp173_AST = null;
				tmp173_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp173_AST);
				match(RPAR);
				localProcess();
				astFactory.addASTChild(currentAST, returnAST);
				guardedProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_urgent:
			{
				ASTWithOffsetInfos tmp174_AST = null;
				tmp174_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp174_AST);
				match(LITERAL_urgent);
				ASTWithOffsetInfos tmp175_AST = null;
				tmp175_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp175_AST);
				match(LPAR);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp176_AST = null;
				tmp176_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp176_AST);
				match(RPAR);
				localProcess();
				astFactory.addASTChild(currentAST, returnAST);
				guardedProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = guardedProcess_AST;
	}
	
	public final void localProcess() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos localProcess_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_break:
			{
				ASTWithOffsetInfos tmp177_AST = null;
				tmp177_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp177_AST);
				match(LITERAL_break);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_return:
			{
				ASTWithOffsetInfos tmp178_AST = null;
				tmp178_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp178_AST);
				match(LITERAL_return);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_throw:
			{
				ASTWithOffsetInfos tmp179_AST = null;
				tmp179_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp179_AST);
				match(LITERAL_throw);
				ASTWithOffsetInfos tmp180_AST = null;
				tmp180_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp180_AST);
				match(LPAR);
				ASTWithOffsetInfos tmp181_AST = null;
				tmp181_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp181_AST);
				match(ID);
				ASTWithOffsetInfos tmp182_AST = null;
				tmp182_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp182_AST);
				match(RPAR);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_try:
			{
				tryBlock();
				astFactory.addASTChild(currentAST, returnAST);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_alt:
			{
				altStatement();
				astFactory.addASTChild(currentAST, returnAST);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_do:
			{
				loopStatement();
				astFactory.addASTChild(currentAST, returnAST);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_par:
			{
				parallelComposition();
				astFactory.addASTChild(currentAST, returnAST);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_hide:
			case LITERAL_relabel:
			case LITERAL_extend:
			case LITERAL_prefix:
			{
				labelModification();
				astFactory.addASTChild(currentAST, returnAST);
				localProcess();
				astFactory.addASTChild(currentAST, returnAST);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_urgent:
			case LITERAL_when:
			{
				guardedProcess();
				astFactory.addASTChild(currentAST, returnAST);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LBRACE:
			{
				ASTWithOffsetInfos tmp183_AST = null;
				tmp183_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp183_AST);
				match(LBRACE);
				localProcess();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp184_AST = null;
				tmp184_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp184_AST);
				match(RBRACE);
				localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
				if ((LA(1)==ID) && (_tokenSet_87.member(LA(2)))) {
					assignement();
					astFactory.addASTChild(currentAST, returnAST);
					localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				}
				else if ((LA(1)==ID) && (LA(2)==LPAR)) {
					paramObject();
					astFactory.addASTChild(currentAST, returnAST);
					localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				}
				else if ((LA(1)==ID) && (_tokenSet_88.member(LA(2)))) {
					performAction();
					astFactory.addASTChild(currentAST, returnAST);
					localProcess_AST = (ASTWithOffsetInfos)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = localProcess_AST;
	}
	
	public final void altStatement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos altStatement_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp185_AST = null;
			tmp185_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp185_AST);
			match(LITERAL_alt);
			ASTWithOffsetInfos tmp186_AST = null;
			tmp186_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp186_AST);
			match(LBRACE);
			alternative();
			astFactory.addASTChild(currentAST, returnAST);
			ASTWithOffsetInfos tmp187_AST = null;
			tmp187_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp187_AST);
			match(RBRACE);
			altStatement_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = altStatement_AST;
	}
	
	public final void alternative() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos alternative_AST = null;
		
		try {      // for error handling
			{
			int _cnt93=0;
			_loop93:
			do {
				if ((LA(1)==COLON)) {
					ASTWithOffsetInfos tmp188_AST = null;
					tmp188_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp188_AST);
					match(COLON);
					ASTWithOffsetInfos tmp189_AST = null;
					tmp189_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp189_AST);
					match(COLON);
					sequentialProcess();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt93>=1 ) { break _loop93; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt93++;
			} while (true);
			}
			alternative_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_38);
		}
		returnAST = alternative_AST;
	}
	
	public final void loopStatement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos loopStatement_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp190_AST = null;
			tmp190_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp190_AST);
			match(LITERAL_do);
			ASTWithOffsetInfos tmp191_AST = null;
			tmp191_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp191_AST);
			match(LBRACE);
			alternative();
			astFactory.addASTChild(currentAST, returnAST);
			ASTWithOffsetInfos tmp192_AST = null;
			tmp192_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp192_AST);
			match(RBRACE);
			loopStatement_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = loopStatement_AST;
	}
	
	public final void parallelComposition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos parallelComposition_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp193_AST = null;
			tmp193_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp193_AST);
			match(LITERAL_par);
			ASTWithOffsetInfos tmp194_AST = null;
			tmp194_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp194_AST);
			match(LBRACE);
			alternative();
			astFactory.addASTChild(currentAST, returnAST);
			ASTWithOffsetInfos tmp195_AST = null;
			tmp195_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp195_AST);
			match(RBRACE);
			parallelComposition_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = parallelComposition_AST;
	}
	
	public final void labelModification() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos labelModification_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_hide:
			{
				ASTWithOffsetInfos tmp196_AST = null;
				tmp196_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp196_AST);
				match(LITERAL_hide);
				label();
				astFactory.addASTChild(currentAST, returnAST);
				labelModification_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_relabel:
			{
				ASTWithOffsetInfos tmp197_AST = null;
				tmp197_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp197_AST);
				match(LITERAL_relabel);
				label();
				astFactory.addASTChild(currentAST, returnAST);
				labelModification_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_extend:
			{
				ASTWithOffsetInfos tmp198_AST = null;
				tmp198_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp198_AST);
				match(LITERAL_extend);
				label();
				astFactory.addASTChild(currentAST, returnAST);
				labelModification_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LITERAL_prefix:
			{
				ASTWithOffsetInfos tmp199_AST = null;
				tmp199_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp199_AST);
				match(LITERAL_prefix);
				label();
				astFactory.addASTChild(currentAST, returnAST);
				labelModification_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_12);
		}
		returnAST = labelModification_AST;
	}
	
	public final void label() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos label_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LBRACE:
			{
				set();
				astFactory.addASTChild(currentAST, returnAST);
				label_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case ID:
			{
				ASTWithOffsetInfos tmp200_AST = null;
				tmp200_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp200_AST);
				match(ID);
				label_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_89);
		}
		returnAST = label_AST;
	}
	
	public final void labelsByLabels() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos labelsByLabels_AST = null;
		
		try {      // for error handling
			label();
			astFactory.addASTChild(currentAST, returnAST);
			ASTWithOffsetInfos tmp201_AST = null;
			tmp201_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp201_AST);
			match(LITERAL_by);
			label();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop100:
			do {
				if ((LA(1)==COMMA)) {
					ASTWithOffsetInfos tmp202_AST = null;
					tmp202_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp202_AST);
					match(COMMA);
					label();
					astFactory.addASTChild(currentAST, returnAST);
					ASTWithOffsetInfos tmp203_AST = null;
					tmp203_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp203_AST);
					match(LITERAL_by);
					label();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop100;
				}
				
			} while (true);
			}
			labelsByLabels_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_4);
		}
		returnAST = labelsByLabels_AST;
	}
	
	public final void assignement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos assignement_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp204_AST = null;
			tmp204_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp204_AST);
			match(ID);
			assiOp();
			astFactory.addASTChild(currentAST, returnAST);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			assignement_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_90);
		}
		returnAST = assignement_AST;
	}
	
	public final void assiOp() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos assiOp_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case EQUAL:
			{
				ASTWithOffsetInfos tmp205_AST = null;
				tmp205_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp205_AST);
				match(EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case PLUS_EQUAL:
			{
				ASTWithOffsetInfos tmp206_AST = null;
				tmp206_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp206_AST);
				match(PLUS_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case MINUS_EQUAL:
			{
				ASTWithOffsetInfos tmp207_AST = null;
				tmp207_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp207_AST);
				match(MINUS_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case TIME_EQUAL:
			{
				ASTWithOffsetInfos tmp208_AST = null;
				tmp208_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp208_AST);
				match(TIME_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case DIV_EQUAL:
			{
				ASTWithOffsetInfos tmp209_AST = null;
				tmp209_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp209_AST);
				match(DIV_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case REMAINDER_EQUAL:
			{
				ASTWithOffsetInfos tmp210_AST = null;
				tmp210_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp210_AST);
				match(REMAINDER_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case LSHIFT_EQUAL:
			{
				ASTWithOffsetInfos tmp211_AST = null;
				tmp211_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp211_AST);
				match(LSHIFT_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case RSHIFT_EQUAL:
			{
				ASTWithOffsetInfos tmp212_AST = null;
				tmp212_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp212_AST);
				match(RSHIFT_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case AND_EQUAL:
			{
				ASTWithOffsetInfos tmp213_AST = null;
				tmp213_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp213_AST);
				match(AND_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case OR_EQUAL:
			{
				ASTWithOffsetInfos tmp214_AST = null;
				tmp214_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp214_AST);
				match(OR_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case XOR_EQUAL:
			{
				ASTWithOffsetInfos tmp215_AST = null;
				tmp215_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp215_AST);
				match(XOR_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case ULSHIFT_EQUAL:
			{
				ASTWithOffsetInfos tmp216_AST = null;
				tmp216_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp216_AST);
				match(ULSHIFT_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case URSHIFT_EQUAL:
			{
				ASTWithOffsetInfos tmp217_AST = null;
				tmp217_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp217_AST);
				match(URSHIFT_EQUAL);
				assiOp_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_21);
		}
		returnAST = assiOp_AST;
	}
	
	public final void paramObject() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos paramObject_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp218_AST = null;
			tmp218_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp218_AST);
			match(ID);
			ASTWithOffsetInfos tmp219_AST = null;
			tmp219_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp219_AST);
			match(LPAR);
			params();
			astFactory.addASTChild(currentAST, returnAST);
			ASTWithOffsetInfos tmp220_AST = null;
			tmp220_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp220_AST);
			match(RPAR);
			paramObject_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = paramObject_AST;
	}
	
	public final void params() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos params_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LBRACE:
			case ID:
			case FLOAT:
			case INT:
			case LITERAL_true:
			case LITERAL_false:
			case LBRACKET:
			case LPAR:
			case PLUS:
			case MINUS:
			case NOT:
			{
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop106:
				do {
					if ((LA(1)==COMMA)) {
						ASTWithOffsetInfos tmp221_AST = null;
						tmp221_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp221_AST);
						match(COMMA);
						expression();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop106;
					}
					
				} while (true);
				}
				params_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			case RPAR:
			{
				params_AST = (ASTWithOffsetInfos)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_35);
		}
		returnAST = params_AST;
	}
	
	public final void performAction() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos performAction_AST = null;
		
		try {      // for error handling
			if ((LA(1)==ID) && (_tokenSet_86.member(LA(2))) && (_tokenSet_91.member(LA(3))) && (_tokenSet_92.member(LA(4)))) {
				ASTWithOffsetInfos tmp222_AST = null;
				tmp222_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp222_AST);
				match(ID);
				performAction_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==ID) && (LA(2)==LITERAL_palt)) {
				ASTWithOffsetInfos tmp223_AST = null;
				tmp223_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp223_AST);
				match(ID);
				paltStatement();
				astFactory.addASTChild(currentAST, returnAST);
				performAction_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==ID) && (LA(2)==LBRACE) && (LA(3)==EQUAL) && (LA(4)==ID)) {
				ASTWithOffsetInfos tmp224_AST = null;
				tmp224_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp224_AST);
				match(ID);
				assiBlock();
				astFactory.addASTChild(currentAST, returnAST);
				performAction_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = performAction_AST;
	}
	
	public final void paltStatement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos paltStatement_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp225_AST = null;
			tmp225_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp225_AST);
			match(LITERAL_palt);
			ASTWithOffsetInfos tmp226_AST = null;
			tmp226_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp226_AST);
			match(LBRACE);
			{
			_loop110:
			do {
				if ((LA(1)==COLON)) {
					pAlternative();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop110;
				}
				
			} while (true);
			}
			ASTWithOffsetInfos tmp227_AST = null;
			tmp227_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp227_AST);
			match(RBRACE);
			paltStatement_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = paltStatement_AST;
	}
	
	public final void assiBlock() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos assiBlock_AST = null;
		
		try {      // for error handling
			ASTWithOffsetInfos tmp228_AST = null;
			tmp228_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp228_AST);
			match(LBRACE);
			ASTWithOffsetInfos tmp229_AST = null;
			tmp229_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp229_AST);
			match(EQUAL);
			assignement();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop114:
			do {
				if ((LA(1)==COMMA)) {
					ASTWithOffsetInfos tmp230_AST = null;
					tmp230_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp230_AST);
					match(COMMA);
					assignement();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop114;
				}
				
			} while (true);
			}
			ASTWithOffsetInfos tmp231_AST = null;
			tmp231_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp231_AST);
			match(EQUAL);
			ASTWithOffsetInfos tmp232_AST = null;
			tmp232_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp232_AST);
			match(RBRACE);
			assiBlock_AST = (ASTWithOffsetInfos)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_86);
		}
		returnAST = assiBlock_AST;
	}
	
	public final void pAlternative() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos pAlternative_AST = null;
		
		try {      // for error handling
			if ((LA(1)==COLON) && (_tokenSet_93.member(LA(2))) && (_tokenSet_94.member(LA(3))) && (_tokenSet_95.member(LA(4)))) {
				weight();
				astFactory.addASTChild(currentAST, returnAST);
				assiBlock();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp233_AST = null;
				tmp233_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp233_AST);
				match(SEMI);
				sequentialProcess();
				astFactory.addASTChild(currentAST, returnAST);
				pAlternative_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==COLON) && (_tokenSet_93.member(LA(2))) && (_tokenSet_94.member(LA(3))) && (_tokenSet_95.member(LA(4)))) {
				weight();
				astFactory.addASTChild(currentAST, returnAST);
				assiBlock();
				astFactory.addASTChild(currentAST, returnAST);
				pAlternative_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==COLON) && (_tokenSet_93.member(LA(2))) && (_tokenSet_96.member(LA(3))) && (_tokenSet_97.member(LA(4)))) {
				weight();
				astFactory.addASTChild(currentAST, returnAST);
				sequentialProcess();
				astFactory.addASTChild(currentAST, returnAST);
				pAlternative_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_98);
		}
		returnAST = pAlternative_AST;
	}
	
	public final void weight() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ASTWithOffsetInfos weight_AST = null;
		
		try {      // for error handling
			if ((LA(1)==COLON) && (LA(2)==COLON)) {
				ASTWithOffsetInfos tmp234_AST = null;
				tmp234_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp234_AST);
				match(COLON);
				ASTWithOffsetInfos tmp235_AST = null;
				tmp235_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp235_AST);
				match(COLON);
				weight_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else if ((LA(1)==COLON) && (_tokenSet_21.member(LA(2)))) {
				ASTWithOffsetInfos tmp236_AST = null;
				tmp236_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp236_AST);
				match(COLON);
				additiveExpr();
				astFactory.addASTChild(currentAST, returnAST);
				ASTWithOffsetInfos tmp237_AST = null;
				tmp237_AST = (ASTWithOffsetInfos)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp237_AST);
				match(COLON);
				weight_AST = (ASTWithOffsetInfos)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_12);
		}
		returnAST = weight_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"defaults\"",
		"'{'",
		"\"actions\"",
		"'='",
		"\"patient\"",
		"\"impatient\"",
		"';'",
		"\"guards\"",
		"\"urgent\"",
		"\"not_urgent\"",
		"'}'",
		"\"action\"",
		"an identifier",
		"','",
		"\"float\"",
		"FLOAT",
		"\"int\"",
		"INT",
		"\"bool\"",
		"\"true\"",
		"\"false\"",
		"\"clock\"",
		"\"const\"",
		"\"extern\"",
		"'['",
		"']'",
		"\"exception\"",
		"\"typedef\"",
		"\"struct\"",
		"\"set\"",
		"\"range\"",
		"'..'",
		"\"process\"",
		"'('",
		"')'",
		"'?'",
		"':'",
		"'||'",
		"'&&'",
		"'|'",
		"'^'",
		"AND",
		"'=='",
		"'!='",
		"'>'",
		"'<'",
		"'>='",
		"'<='",
		"LEFTSHIFT",
		"RIGHTSHIFT",
		"ULEFTSHIFT",
		"URIGHTSHIFT",
		"'+'",
		"'-'",
		"'*'",
		"'/'",
		"'%'",
		"'!'",
		"'.'",
		"\"try\"",
		"\"catch\"",
		"\"when\"",
		"\"alt\"",
		"\"do\"",
		"\"par\"",
		"\"hide\"",
		"\"relabel\"",
		"\"extend\"",
		"\"prefix\"",
		"\"by\"",
		"PLUS_EQUAL",
		"MINUS_EQUAL",
		"TIME_EQUAL",
		"DIV_EQUAL",
		"REMAINDER_EQUAL",
		"LSHIFT_EQUAL",
		"RSHIFT_EQUAL",
		"AND_EQUAL",
		"OR_EQUAL",
		"XOR_EQUAL",
		"ULSHIFT_EQUAL",
		"URSHIFT_EQUAL",
		"\"palt\"",
		"\"break\"",
		"\"return\"",
		"\"throw\"",
		"EXPONENT_PART",
		"FLOAT_SUFFIX",
		"NUMERIC",
		"a whitespace character",
		"COMMENT",
		"ML_COMMENT",
		"CHAR",
		"STRING",
		"'~'",
		"'--'",
		"'++'",
		"TIMES_EQUAL"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 72181187328L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 30103928832L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 137707586720L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { -6701355760732891232L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { -9223371964673584352L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { -9223371964673435872L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 240484352L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 39157760L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 268633216L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { -6701356035610781792L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { -9223371964673567968L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { -9223372036854706144L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { -6701354936099286110L, 67108350L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { -4611686053324138590L, 67108351L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { -4611686018427398238L, 67108351L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	private static final long[] mk_tokenSet_16() {
		long[] data = { -6701356107792051040L, 67108350L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
	private static final long[] mk_tokenSet_17() {
		long[] data = { -4611686083388909664L, 67108350L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
	private static final long[] mk_tokenSet_18() {
		long[] data = { -9223370865161940190L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_18 = new BitSet(mk_tokenSet_18());
	private static final long[] mk_tokenSet_19() {
		long[] data = { 236290048L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_19 = new BitSet(mk_tokenSet_19());
	private static final long[] mk_tokenSet_20() {
		long[] data = { 34963456L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_20 = new BitSet(mk_tokenSet_20());
	private static final long[] mk_tokenSet_21() {
		long[] data = { 2522015929062719520L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_21 = new BitSet(mk_tokenSet_21());
	private static final long[] mk_tokenSet_22() {
		long[] data = { 197760L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_22 = new BitSet(mk_tokenSet_22());
	private static final long[] mk_tokenSet_23() {
		long[] data = { -9223371964672911456L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_23 = new BitSet(mk_tokenSet_23());
	private static final long[] mk_tokenSet_24() {
		long[] data = { -9223371964671338592L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_24 = new BitSet(mk_tokenSet_24());
	private static final long[] mk_tokenSet_25() {
		long[] data = { -9223371964648269920L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_25 = new BitSet(mk_tokenSet_25());
	private static final long[] mk_tokenSet_26() {
		long[] data = { 17408L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_26 = new BitSet(mk_tokenSet_26());
	private static final long[] mk_tokenSet_27() {
		long[] data = { 537083904L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_27 = new BitSet(mk_tokenSet_27());
	private static final long[] mk_tokenSet_28() {
		long[] data = { 1024L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_28 = new BitSet(mk_tokenSet_28());
	private static final long[] mk_tokenSet_29() {
		long[] data = { -4611686632607721566L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_29 = new BitSet(mk_tokenSet_29());
	private static final long[] mk_tokenSet_30() {
		long[] data = { -10334L, 67108351L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_30 = new BitSet(mk_tokenSet_30());
	private static final long[] mk_tokenSet_31() {
		long[] data = { 4611684506930085920L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_31 = new BitSet(mk_tokenSet_31());
	private static final long[] mk_tokenSet_32() {
		long[] data = { 4611684816704749600L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_32 = new BitSet(mk_tokenSet_32());
	private static final long[] mk_tokenSet_33() {
		long[] data = { 9223371934643765280L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_33 = new BitSet(mk_tokenSet_33());
	private static final long[] mk_tokenSet_34() {
		long[] data = { -9223370589747030110L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_34 = new BitSet(mk_tokenSet_34());
	private static final long[] mk_tokenSet_35() {
		long[] data = { 274877906944L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_35 = new BitSet(mk_tokenSet_35());
	private static final long[] mk_tokenSet_36() {
		long[] data = { -6701356035610912864L, 67108350L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_36 = new BitSet(mk_tokenSet_36());
	private static final long[] mk_tokenSet_37() {
		long[] data = { -6701355760732874848L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_37 = new BitSet(mk_tokenSet_37());
	private static final long[] mk_tokenSet_38() {
		long[] data = { 16384L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_38 = new BitSet(mk_tokenSet_38());
	private static final long[] mk_tokenSet_39() {
		long[] data = { 65536L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_39 = new BitSet(mk_tokenSet_39());
	private static final long[] mk_tokenSet_40() {
		long[] data = { -4611688281875163230L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_40 = new BitSet(mk_tokenSet_40());
	private static final long[] mk_tokenSet_41() {
		long[] data = { 4611683957174272032L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_41 = new BitSet(mk_tokenSet_41());
	private static final long[] mk_tokenSet_42() {
		long[] data = { -30064781406L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_42 = new BitSet(mk_tokenSet_42());
	private static final long[] mk_tokenSet_43() {
		long[] data = { -9223370039991216222L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_43 = new BitSet(mk_tokenSet_43());
	private static final long[] mk_tokenSet_44() {
		long[] data = { -4611690480898418782L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_44 = new BitSet(mk_tokenSet_44());
	private static final long[] mk_tokenSet_45() {
		long[] data = { 4611681758151016480L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_45 = new BitSet(mk_tokenSet_45());
	private static final long[] mk_tokenSet_46() {
		long[] data = { -9223367840967960670L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_46 = new BitSet(mk_tokenSet_46());
	private static final long[] mk_tokenSet_47() {
		long[] data = { -4611694878944929886L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_47 = new BitSet(mk_tokenSet_47());
	private static final long[] mk_tokenSet_48() {
		long[] data = { 4611677360104505376L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_48 = new BitSet(mk_tokenSet_48());
	private static final long[] mk_tokenSet_49() {
		long[] data = { -9223363442921449566L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_49 = new BitSet(mk_tokenSet_49());
	private static final long[] mk_tokenSet_50() {
		long[] data = { -4611703675037952094L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_50 = new BitSet(mk_tokenSet_50());
	private static final long[] mk_tokenSet_51() {
		long[] data = { 4611668564011483168L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_51 = new BitSet(mk_tokenSet_51());
	private static final long[] mk_tokenSet_52() {
		long[] data = { -9223354646828427358L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_52 = new BitSet(mk_tokenSet_52());
	private static final long[] mk_tokenSet_53() {
		long[] data = { -4611721267223996510L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_53 = new BitSet(mk_tokenSet_53());
	private static final long[] mk_tokenSet_54() {
		long[] data = { 4611650971825438752L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_54 = new BitSet(mk_tokenSet_54());
	private static final long[] mk_tokenSet_55() {
		long[] data = { -9223337054642382942L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_55 = new BitSet(mk_tokenSet_55());
	private static final long[] mk_tokenSet_56() {
		long[] data = { -4611897189084440670L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_56 = new BitSet(mk_tokenSet_56());
	private static final long[] mk_tokenSet_57() {
		long[] data = { 4611475049964994592L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_57 = new BitSet(mk_tokenSet_57());
	private static final long[] mk_tokenSet_58() {
		long[] data = { 4611545418709172256L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_58 = new BitSet(mk_tokenSet_58());
	private static final long[] mk_tokenSet_59() {
		long[] data = { -9223301870270294110L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_59 = new BitSet(mk_tokenSet_59());
	private static final long[] mk_tokenSet_60() {
		long[] data = { -4615908207502567518L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_60 = new BitSet(mk_tokenSet_60());
	private static final long[] mk_tokenSet_61() {
		long[] data = { 4607464031546867744L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_61 = new BitSet(mk_tokenSet_61());
	private static final long[] mk_tokenSet_62() {
		long[] data = { 4607745506523578400L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_62 = new BitSet(mk_tokenSet_62());
	private static final long[] mk_tokenSet_63() {
		long[] data = { 4608308456476999712L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_63 = new BitSet(mk_tokenSet_63());
	private static final long[] mk_tokenSet_64() {
		long[] data = { 4609434356383842336L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_64 = new BitSet(mk_tokenSet_64());
	private static final long[] mk_tokenSet_65() {
		long[] data = { -9223090764037761118L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_65 = new BitSet(mk_tokenSet_65());
	private static final long[] mk_tokenSet_66() {
		long[] data = { -4679240077262465118L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_66 = new BitSet(mk_tokenSet_66());
	private static final long[] mk_tokenSet_67() {
		long[] data = { 4544132161786970144L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_67 = new BitSet(mk_tokenSet_67());
	private static final long[] mk_tokenSet_68() {
		long[] data = { 4548635761414340640L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_68 = new BitSet(mk_tokenSet_68());
	private static final long[] mk_tokenSet_69() {
		long[] data = { 4557642960669081632L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_69 = new BitSet(mk_tokenSet_69());
	private static final long[] mk_tokenSet_70() {
		long[] data = { 4575657359178563616L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_70 = new BitSet(mk_tokenSet_70());
	private static final long[] mk_tokenSet_71() {
		long[] data = { -9218868639387101278L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_71 = new BitSet(mk_tokenSet_71());
	private static final long[] mk_tokenSet_72() {
		long[] data = { -4611686048492169310L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_72 = new BitSet(mk_tokenSet_72());
	private static final long[] mk_tokenSet_73() {
		long[] data = { -10334L, 67108863L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_73 = new BitSet(mk_tokenSet_73());
	private static final long[] mk_tokenSet_74() {
		long[] data = { 4539628562159599648L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_74 = new BitSet(mk_tokenSet_74());
	private static final long[] mk_tokenSet_75() {
		long[] data = { -9151314610616805470L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_75 = new BitSet(mk_tokenSet_75());
	private static final long[] mk_tokenSet_76() {
		long[] data = { -6629298681554151518L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_76 = new BitSet(mk_tokenSet_76());
	private static final long[] mk_tokenSet_77() {
		long[] data = { 2810246305249329184L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_77 = new BitSet(mk_tokenSet_77());
	private static final long[] mk_tokenSet_78() {
		long[] data = { 3098476681401040928L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_78 = new BitSet(mk_tokenSet_78());
	private static final long[] mk_tokenSet_79() {
		long[] data = { 3674937433704464416L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_79 = new BitSet(mk_tokenSet_79());
	private static final long[] mk_tokenSet_80() {
		long[] data = { -8935141828503021662L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_80 = new BitSet(mk_tokenSet_80());
	private static final long[] mk_tokenSet_81() {
		long[] data = { -6917529195441039454L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_81 = new BitSet(mk_tokenSet_81());
	private static final long[] mk_tokenSet_82() {
		long[] data = { -6917529195441039454L, 58721278L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_82 = new BitSet(mk_tokenSet_82());
	private static final long[] mk_tokenSet_83() {
		long[] data = { 4539628596519338016L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_83 = new BitSet(mk_tokenSet_83());
	private static final long[] mk_tokenSet_84() {
		long[] data = { -6917529195170506846L, 58721278L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_84 = new BitSet(mk_tokenSet_84());
	private static final long[] mk_tokenSet_85() {
		long[] data = { 147456L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_85 = new BitSet(mk_tokenSet_85());
	private static final long[] mk_tokenSet_86() {
		long[] data = { -9223370865161939166L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_86 = new BitSet(mk_tokenSet_86());
	private static final long[] mk_tokenSet_87() {
		long[] data = { 128L, 4193280L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_87 = new BitSet(mk_tokenSet_87());
	private static final long[] mk_tokenSet_88() {
		long[] data = { -9223370865161939166L, 62915070L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_88 = new BitSet(mk_tokenSet_88());
	private static final long[] mk_tokenSet_89() {
		long[] data = { -9223372036854575070L, 58721278L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_89 = new BitSet(mk_tokenSet_89());
	private static final long[] mk_tokenSet_90() {
		long[] data = { -9223370865161807966L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_90 = new BitSet(mk_tokenSet_90());
	private static final long[] mk_tokenSet_91() {
		long[] data = { -6701354906034514014L, 67108351L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_91 = new BitSet(mk_tokenSet_91());
	private static final long[] mk_tokenSet_92() {
		long[] data = { -4611686053324007518L, 67108351L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_92 = new BitSet(mk_tokenSet_92());
	private static final long[] mk_tokenSet_93() {
		long[] data = { 2522017028574347296L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_93 = new BitSet(mk_tokenSet_93());
	private static final long[] mk_tokenSet_94() {
		long[] data = { 4539629661671227424L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_94 = new BitSet(mk_tokenSet_94());
	private static final long[] mk_tokenSet_95() {
		long[] data = { 4611685916216377504L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_95 = new BitSet(mk_tokenSet_95());
	private static final long[] mk_tokenSet_96() {
		long[] data = { -4683742375183544288L, 58720766L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_96 = new BitSet(mk_tokenSet_96());
	private static final long[] mk_tokenSet_97() {
		long[] data = { -4611686120638393184L, 67108350L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_97 = new BitSet(mk_tokenSet_97());
	private static final long[] mk_tokenSet_98() {
		long[] data = { 1099511644160L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_98 = new BitSet(mk_tokenSet_98());
	
	}
