// $ANTLR 2.7.7 (20061129): "parser.g" -> "ModestParserNew.java"$

package modesteditor.core.antlrparser;

import modesteditor.core.ModestEditor;
    
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream; 
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.jface.text.IDocument; 
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.Region;

import antlr.CommonAST;  
import antlr.RecognitionException;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class ModestParserNew extends antlr.LLkParser       implements parserModestVocab_TokenTypes
 {

	// Define some methods and variables to use in the generated parser.

  // Define a main
  public static void main(String[] args) {
    // Use a try/catch block for parser exceptions
    try {
      // if we have at least one command-line argument
      if (args.length > 0 ) {
        //System.err.println("Parsing...");

        // for each directory/file specified on the command line
        for(int i=0; i< args.length;i++){
        	//System.err.println("Doing file: " + args[i]);
        	doFile(new File(args[i])); // parse it
        	
          	}
      }
      else
        System.err.println("Usage: java ModestParser <directory name>");

    }
    catch(Exception e) {
      System.err.println("exception: "+e);
      e.printStackTrace(System.err);   // so we can get stack trace
    }
  }


  // This method decides what action to take based on the type of
  //   file we are looking at
  public static void doFile(File f) throws Exception {
    // If this is a directory, walk each file/dir in that directory
    if (f.isDirectory()) {
      String files[] = f.list();
      for(int i=0; i < files.length; i++)
        doFile(new File(f, files[i]));
    }

    // otherwise, if this is a MoDeST file, parse it!
    else {
      //System.err.println("-------------------------------------------");
      //System.err.println(f.getAbsolutePath());
      parseFile(new FileInputStream(f));
    }
  }

  // Here's where we do the real work...
  public static void parseFile(InputStream s) throws Exception {
    try {
      // Create a scanner that reads from the input stream passed to us
      ModestLexerNew lexer = new ModestLexerNew(s);

      // Create a parser that reads from the scanner
      ModestParserNew parser = new ModestParserNew(lexer);

      // start parsing at the compilationUnit rule
      parser.start();
      System.out.println(parser.getAST().toStringList());
    }
    catch (EndOfFileException e) {
    	//System.err.println("Finished parsing!");
    	
    }
    catch (Exception e) {
      System.err.println("parser exception: "+e);
      e.printStackTrace();   // so we can get stack trace		
    }
  }

	protected long numTryCatch = 0;
	protected int numErrors = 0;
 	protected int procLevel = 0;
	protected boolean defActionsPatient;
	protected boolean defGuardsUrgent;
	protected static final int MOD_NONE = 0;
	protected static final int MOD_EXTERN = 1;
	protected static final int MOD_CONST = 2;
	protected static final int MOD_PATIENT = 4;
	protected static final int MOD_IMPATIENT = 8;
	private String[] builtInTypes =  { "type", // used to define types
		"int",
		"bool",
		"action",
		"clock",
		"float",
		"exception",
		"process",
		"set",
		"struct" };
	protected ArrayList<String> types = new ArrayList<String>();
	protected ArrayList<Symbol> vars = new ArrayList<Symbol>();
	protected ArrayList<Symbol> excs = new ArrayList<Symbol>();
	protected ArrayList<String> processes = new ArrayList<String>();
	protected HashMap<String, Symbol> unUsedVars = new HashMap<String, Symbol>();
	
	public HashMap<String, Symbol> getUnUsedVars(){
		return unUsedVars;
	}
	
	private void fillTypes() {
		for (int i = 0; i < builtInTypes.length; i++) {
			types.add(builtInTypes[i]);
		}
	}
	
	public ArrayList<String> getVars() {
		ArrayList<String> variables = new ArrayList<String>();
		for (int i = 0; i < vars.size(); i++) {
			variables.add(vars.get(i).getName());
		}
		for (int i = 0; i < excs.size(); i++) {
			variables.add(excs.get(i).getName());
		}	
		return variables;
	}
	
	public ArrayList<String> getProcesses() {
		return processes;
	}
	
	public int getErrorCount() {
			return numErrors;
	}
	
	public String findType(String s) {
		if (types.contains(s)) 
			return s;
		else return null;
	}
	
	public boolean addType(String s) {
		if (!types.contains(s))
			return types.add(s);
		else return false;
	}
	
	public ArrayList<IRegion> problems;
	
	/*public void setActualDocumentOffset(int offset){
	  actualDocOffset=offset;
  	}*/
  
  public void reportError(RecognitionException ex){
	
	try {
		ModestEditor editor = ModestEditor.getEditor();
		IDocument document = editor.getDocumentProvider().getDocument(editor.getEditorInput());
		
		/*int actualLine = document.getLineOfOffset(actualDocOffset);
		System.err.println("Syntax error at line " + (ex.getLine()+actualLine) + ": " + ex.getMessage());
		
		
		int lineOffset = document.getLineOffset(ex.getLine()-1+actualLine);
		int nextLineOffset = document.getLineOffset(ex.getLine()+actualLine);*/
		
		int lineOffset = document.getLineOffset(ex.getLine()-1);
		int nextLineOffset = document.getLineOffset(ex.getLine());
		
		problems.add(new Region(lineOffset,nextLineOffset-lineOffset-1));
	} catch (BadLocationException e) {
		System.err.println("Bad line offset for the erroneous element.");
	}
  }
	
	/** Utility to gerenerate a piece of parse tree with an IDENTIFIER_AST
 * referencing a tau.
 * @todo make the filename point to something sensible
 */
ModestAST create_tau_ast( int line, int column ) 
{ 
	ModestAST tau = /*ModestAST*/((ModestAST)astFactory.create(IDENTIFIER,"tau")); // maybe new
	tau.setLine(line);
	tau.setColumn(column);
	//tau->setSymbol(SymData->get_tau_symbol());
	tau.setSymbol(new Symbol("tau", "action"));

	return tau;
}
	

protected ModestParserNew(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public ModestParserNew(TokenBuffer tokenBuf) {
  this(tokenBuf,3);
}

protected ModestParserNew(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public ModestParserNew(TokenStream lexer) {
  this(lexer,3);
}

public ModestParserNew(ParserSharedInputState state) {
  super(state,3);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

/** Start rule for grammar */
	public final void start() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST start_AST = null;
		ModestAST d_AST = null;
		
		try {      // for error handling
			if ( inputState.guessing==0 ) {
				
					astFactory.setASTNodeClass(ModestAST.class);
					fillTypes();
					problems = new ArrayList<IRegion>();
					Symbol tauAction = new Symbol("tau", "action");
					vars.add(tauAction);
					Symbol trueBoolean = new Symbol("true", "bool");
					vars.add(trueBoolean);
					Symbol falseBoolean = new Symbol("false", "bool");
					vars.add(falseBoolean);
					//System.err.println("Getting started");
				
			}
			{
			switch ( LA(1)) {
			case DEFAULTS:
			{
				defaults_section();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case TYPEDEF:
			case MCONST:
			case MEXTERN:
			case PATIENT:
			case IMPATIENT:
			case STOP:
			case ALT:
			case PALT:
			case WHEN:
			case URGENT:
			case DO:
			case BREAK:
			case IF:
			case PAR:
			case TRY:
			case THROW:
			case PROCESS:
			case RELABEL:
			case HIDE:
			case EXTEND:
			case LCURL:
			case ASSIGN_START:
			case IDENTIFIER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			description();
			d_AST = (ModestAST)returnAST;
			astFactory.addASTChild(currentAST, returnAST);
			match(Token.EOF_TYPE);
			start_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = start_AST;
	}
	
/** Rule to take care of defaults section
 */
	public final void defaults_section() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST defaults_section_AST = null;
		Token  setting = null;
		ModestAST setting_AST = null;
		Token  value = null;
		ModestAST value_AST = null;
		
		try {      // for error handling
			ModestAST tmp2_AST = null;
			tmp2_AST = (ModestAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp2_AST);
			match(DEFAULTS);
			match(LCURL);
			{
			int _cnt100=0;
			_loop100:
			do {
				if ((LA(1)==IDENTIFIER)) {
					setting = LT(1);
					setting_AST = (ModestAST)astFactory.create(setting);
					astFactory.addASTChild(currentAST, setting_AST);
					match(IDENTIFIER);
					ModestAST tmp4_AST = null;
					tmp4_AST = (ModestAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp4_AST);
					match(ASSIGN);
					value = LT(1);
					value_AST = (ModestAST)astFactory.create(value);
					astFactory.addASTChild(currentAST, value_AST);
					match(IDENTIFIER);
					match(SEMICOLON);
					if ( inputState.guessing==0 ) {
						/*{{{*/
								if( setting.getText() == "actions" )
								{
									if( value.getText() == "patient" )
										defActionsPatient = true;
									else if( value.getText() == "impatient" )
										defActionsPatient = false;
									else
									{
										
										String error = "Illegal value specified for default '" + setting.getText() + "'";
										System.err.println(error);
										throw new SemanticException(error, this.getFilename(),
																				 setting.getLine(), setting.getColumn());
									}
								}
								else if( setting.getText() == "guards" )
								{
									if( value.getText() == "urgent" )
										defGuardsUrgent = true;
									else if( value.getText() == "not_urgent" )
										defGuardsUrgent = false;
									else
									{
										String error = "Illegal value specified for default '" + setting.getText() + "'";
										System.err.println(error);
										throw new SemanticException(error, this.getFilename(),
																				 setting.getLine(), setting.getColumn());
									}
								}
								else
								{
									String error = "Unknown default: '" + setting.getText() + "'";
									System.err.println(error);
									throw new SemanticException(error, this.getFilename(),
																			 setting.getLine(), setting.getColumn());
								}
								/*}}}*/
							
					}
				}
				else {
					if ( _cnt100>=1 ) { break _loop100; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt100++;
			} while (true);
			}
			match(RCURL);
			defaults_section_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = defaults_section_AST;
	}
	
/** Grammar rule for descriptions
 * @todo rework description rule
 * - localprocess should be different for functions and processes
 * @param proc the process symbol the description belongs to.
 */
	public final void description() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST description_AST = null;
		ModestAST decl_AST = null;
		ModestAST stmnt_AST = null;
		
		try {      // for error handling
			{
			_loop103:
			do {
				if ((_tokenSet_2.member(LA(1))) && (_tokenSet_3.member(LA(2))) && (_tokenSet_4.member(LA(3)))) {
					declarative_stmnt();
					decl_AST = (ModestAST)returnAST;
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop103;
				}
				
			} while (true);
			}
			sequential_processes();
			stmnt_AST = (ModestAST)returnAST;
			astFactory.addASTChild(currentAST, returnAST);
			description_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = description_AST;
	}
	
/** Declarations of types/processes/functions/variables
 * @param assignments ASTVector used to collect initializations of variables
 */
	public final void declarative_stmnt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST declarative_stmnt_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TYPEDEF:
			{
				type_definition();
				astFactory.addASTChild(currentAST, returnAST);
				declarative_stmnt_AST = (ModestAST)currentAST.root;
				break;
			}
			case PROCESS:
			{
				process_definition();
				astFactory.addASTChild(currentAST, returnAST);
				declarative_stmnt_AST = (ModestAST)currentAST.root;
				break;
			}
			case MCONST:
			case MEXTERN:
			case PATIENT:
			case IMPATIENT:
			case IDENTIFIER:
			{
				variable_declaration(false);
				astFactory.addASTChild(currentAST, returnAST);
				declarative_stmnt_AST = (ModestAST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = declarative_stmnt_AST;
	}
	
/** sequential composition or action prefixing
 */
	public final void sequential_processes() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST sequential_processes_AST = null;
		
		try {      // for error handling
			local_process();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop125:
			do {
				if ((LA(1)==SEMICOLON)) {
					match(SEMICOLON);
					local_process();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop125;
				}
				
			} while (true);
			}
			sequential_processes_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_6);
			} else {
			  throw ex;
			}
		}
		returnAST = sequential_processes_AST;
	}
	
/** Type definition
 * define a new type
 * - a set (mostly implemented)
 * - a struct (mostly unimplemented)
 * - a range (mostly unimplemented)
 */
	public final void type_definition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST type_definition_AST = null;
		Token  td = null;
		ModestAST td_AST = null;
		Token  set_keyword = null;
		ModestAST set_keyword_AST = null;
		ModestAST set_AST = null;
		Token  range_keyword = null;
		ModestAST range_keyword_AST = null;
		ModestAST r_AST = null;
		Token  struct_keyword = null;
		ModestAST struct_keyword_AST = null;
		ModestAST s_AST = null;
		Token  type_name = null;
		ModestAST type_name_AST = null;
		
			//System.err.println("in type_definition");
			/*const Symbol_type *range_type = 0;
			ASTVector asgn;
			Symbol_struct* struct_sym; // we need this one early*/
			String rangeType = "";
			Symbol struct_sym;
			String typeKind = "";
		
		
		try {      // for error handling
			td = LT(1);
			td_AST = (ModestAST)astFactory.create(td);
			match(TYPEDEF);
			{
			switch ( LA(1)) {
			case SET:
			{
				set_keyword = LT(1);
				set_keyword_AST = (ModestAST)astFactory.create(set_keyword);
				match(SET);
				set();
				set_AST = (ModestAST)returnAST;
				if ( inputState.guessing==0 ) {
					typeKind = "set";
				}
				break;
			}
			case RANGE:
			{
				range_keyword = LT(1);
				range_keyword_AST = (ModestAST)astFactory.create(range_keyword);
				match(RANGE);
				rangeType=range();
				r_AST = (ModestAST)returnAST;
				if ( inputState.guessing==0 ) {
					typeKind = "range";
				}
				break;
			}
			case STRUCT:
			{
				struct_keyword = LT(1);
				struct_keyword_AST = (ModestAST)astFactory.create(struct_keyword);
				match(STRUCT);
				if ( inputState.guessing==0 ) {
					typeKind = "struct";
				}
				if ( inputState.guessing==0 ) {
					
								//the new symbol
								/*struct_sym =
								new Symbol( this.getFilename(),
															 struct_keyword.getLine(),
															 struct_keyword.getColumn());*/
									/*new Symbol_struct( this->getFilename().c_str(),
															 struct_keyword->getLine(),
															 struct_keyword->getColumn(),
															 SymData,
															 SymData->get_current_scope(),
															 SymData->get_current_namespace()
															 );*/
								// make the new scope introduced by this struct.
								// All new variables go in here.
								// this scope is owned by the struct
								//SymData->set_current_scope(SymData->get_current_scope()->add_struct(struct_sym));
							
				}
				astruct();
				s_AST = (ModestAST)returnAST;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			type_name = LT(1);
			type_name_AST = (ModestAST)astFactory.create(type_name);
			match(IDENTIFIER);
			match(SEMICOLON);
			if ( inputState.guessing==0 ) {
				type_definition_AST = (ModestAST)currentAST.root;
				// Make symbol table entry, precalc some stuff & add TYPE_DEFINITION_AST as top 
						//Symbol_type *tp = 0;
						Symbol tp = null;
						/*if ( struct_keyword != null  )
						{	
							// the struct now knows which scope it owns and its name
							//struct_sym->setInfo(type_name->getText(),SymData->get_current_scope());
							// return to the original namespace
							//SymData->set_current_scope(SymData->get_current_scope()->get_parent());
				
							tp = struct_sym;
							
						}
						else if ( set_keyword != null )					// dealing with set definition?
						{ 
							if( set_keyword.getText() != "set" )
							{
								//std::ostringstream error;
								String error = "expecting set got '" + set_keyword.getText() + "'";
								throw new SemanticException(error, this.getFilename(),
													 set_keyword.getLine(), set_keyword.getLine());
							}
							//Symbol_symset *set_sym =
							Symbol set_sym =
								new Symbol(type_name.getText(),
														this.getFilename(),
														type_name.getLine(), type_name.getColumn());
														
								new Symbol_symset(type_name->getText(),
														this->getFilename().c_str(),
														type_name->getLine(), type_name->getColumn(),
														SymData,
														SymData->get_current_scope(),
														SymData->get_current_namespace() );
				//			print_tree<RefModest_AST,Modest_Parser> pr(*this);
				//			pr.pr_tree(#set);
				
							CalcSet walk( SymData, set_sym, false );
							walk.tree(#set);
				
							if( walk.OK() )
								tp = set_sym;
							else
							{
								std::ostringstream error;
								error << "set specification invalid in definiton of type '"
									<< type_name->getText() << "' (" << walk.error() << ")";
								throw antlr::SemanticException(error.str(), this->getFilename(),
																		 type_name->getLine(), type_name->getColumn());
							}
							
							//tp = set_sym;
							
						}
						else*/ if( range_keyword != null)		// dealing with range definition?
						{ 
							if( rangeType != "int" )
							{
								//std::ostringstream error;
								String error = "range types of non-integers are not supported";
								throw new SemanticException(error, this.getFilename(),
																		 range_keyword.getLine(), range_keyword.getLine());
							}
							// dissect range..
							/*CalcStaticRange walk( SymData, false );
							walk.tree(#r);
				
							if( ! walk.OK() )
							{
				//				print_tree<RefModest_AST,Modest_Parser> pr(*this);
				//				pr.pr_tree(#set);
								std::ostringstream error;
								error
									<< "definition of range in typedef is incorrect ("
									<< walk.error() << ")";
								throw antlr::SemanticException(error.str(), this->getFilename(),
																		 range_keyword->getLine(),range_keyword->getColumn());
							}
							const Bound& range = walk.get_bounds();*/
				
							// things seem ok.. now make symbol...
							//Symbol_range *range_sym =
							/*Symbol range_sym = 
								new Symbol(type_name.getText(),type_name.getLine(), type_name.getColumn());*/
								/*new Symbol_range(type_name->getText(),
													  range,
													  range_type,
													  this->getFilename().c_str(),
													  type_name->getLine(), type_name->getColumn(),
													  SymData->get_current_scope(),
													  SymData->get_current_namespace() );*/
							//tp = range_sym;
							
						}
				
						/*if( tp == null )
						{
							//std::ostringstream error;
							String error = "could not define type '" + type_name.getText() + "'";
							throw SemanticException(error, this.getFilename(),
																		 td.getLine(), td.getColumn());
						}*/
						//add_type( tp );
						addType(type_name.getText());
				
						type_definition_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add((ModestAST)astFactory.create(TYPE_DEFINITION_AST,"typedef")).add(type_definition_AST));
						//#type_definition.setSymbolType(tp);
						type_definition_AST.setSymbolType(type_name.getText());
						type_definition_AST.setLine(type_name.getLine());
						type_definition_AST.setColumn(type_name.getColumn());
						type_definition_AST.setTypeKind(typeKind);
						
					
				currentAST.root = type_definition_AST;
				currentAST.child = type_definition_AST!=null &&type_definition_AST.getFirstChild()!=null ?
					type_definition_AST.getFirstChild() : type_definition_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = type_definition_AST;
	}
	
/** Process definition
 * Define a process.
 */
	public final void process_definition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST process_definition_AST = null;
		Token  name = null;
		ModestAST name_AST = null;
		ModestAST pdef_AST = null;
		ModestAST pbody_AST = null;
		
			ArrayList<Symbol> params = null;	
		
		
		try {      // for error handling
			if ( inputState.guessing==0 ) {
				
						if( procLevel > 0 )
						{
							//std::ostringstream error;
							String error = "nested processes are not supported";
							throw new SemanticException(error,
																	 this.getFilename(),
																	 LT(1).getLine(), LT(1).getColumn());
						}
					
			}
			match(PROCESS);
			name = LT(1);
			name_AST = (ModestAST)astFactory.create(name);
			match(IDENTIFIER);
			if ( inputState.guessing==0 ) {
				
						Symbol process = new Symbol(name.getText(), "process");
						process.setLine(name.getLine());
						process.setColumn(name.getColumn());
						unUsedVars.put(name.getText(), process);
						processes.add(name.getText());
					
			}
			params=param_definition(name.getText());
			pdef_AST = (ModestAST)returnAST;
			if ( inputState.guessing==0 ) {
				vars.addAll(params);
			}
			{
			switch ( LA(1)) {
			case SEMICOLON:
			{
				match(SEMICOLON);
				break;
			}
			case LCURL:
			{
				if ( inputState.guessing==0 ) {
					procLevel++;
				}
				process_body();
				pbody_AST = (ModestAST)returnAST;
				if ( inputState.guessing==0 ) {
					procLevel--;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				process_definition_AST = (ModestAST)currentAST.root;
				
						// restore the scope..
						// cout << "Scope #" << SymData->get_current_scope()->get_id() << ": size = " << SymData->get_current_scope()->get_size() << endl;
						process_definition_AST = (ModestAST)astFactory.make( (new ASTArray(3)).add((ModestAST)astFactory.create(PROCESS_DEFINITION_AST,"proc_def")).add(pdef_AST).add(pbody_AST));
						//##->setSymbol(sp);
						//##->setScope(SymData->get_current_scope());
						process_definition_AST.setLine(name.getLine());
						process_definition_AST.setColumn(name.getColumn());
						// in the case of no pbody -> forward declaration
						/*sp->set_declaration_state( (#pbody == 0) ?
								Symbol_parameterized::FORWARD : Symbol_parameterized::COMPLETE );*/
						//sp->setAST( ## );
						//SymData->set_current_scope( prev_scope );
						process_definition_AST.setProcName(name.getText());
						for (int i = 0; i < params.size(); i++) {
							vars.remove(params.get(i));
						}
					
				currentAST.root = process_definition_AST;
				currentAST.child = process_definition_AST!=null &&process_definition_AST.getFirstChild()!=null ?
					process_definition_AST.getFirstChild() : process_definition_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = process_definition_AST;
	}
	
/** Modifiers
 * used in variable declarations to specify externness, constness
 * and (im)patience.
 * @note no tree built for this rule.
 */
	public final int  modifier() throws RecognitionException, TokenStreamException {
		int mask = 0;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST modifier_AST = null;
		
		try {      // for error handling
			{
			int _cnt110=0;
			_loop110:
			do {
				switch ( LA(1)) {
				case MEXTERN:
				{
					ModestAST tmp11_AST = null;
					tmp11_AST = (ModestAST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp11_AST);
					match(MEXTERN);
					if ( inputState.guessing==0 ) {
						mask =(mask+1)%2;
					}
					break;
				}
				case MCONST:
				{
					ModestAST tmp12_AST = null;
					tmp12_AST = (ModestAST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp12_AST);
					match(MCONST);
					if ( inputState.guessing==0 ) {
						mask =(mask+2)%4;
					}
					break;
				}
				case PATIENT:
				{
					ModestAST tmp13_AST = null;
					tmp13_AST = (ModestAST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp13_AST);
					match(PATIENT);
					if ( inputState.guessing==0 ) {
						mask =(mask+4)%8;
					}
					break;
				}
				case IMPATIENT:
				{
					ModestAST tmp14_AST = null;
					tmp14_AST = (ModestAST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp14_AST);
					match(IMPATIENT);
					if ( inputState.guessing==0 ) {
						mask =(mask+8)%16;
					}
					break;
				}
				default:
				{
					if ( _cnt110>=1 ) { break _loop110; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				}
				_cnt110++;
			} while (true);
			}
			modifier_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = modifier_AST;
		return mask;
	}
	
/** Qualified type
 * type with optional namespace qualification
 * @note The default errorhandler is turned of so that this rule behaves
 * as if it's one token. This prevents it returning type = 0 without throwing
 * an error (e.g. the erorr is handled inside this rule and a zero type is
 * returned and that's not quite what we want... no?)
 */
	public final String  qualified_type() throws RecognitionException, TokenStreamException {
		String type;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST qualified_type_AST = null;
		Token  tp = null;
		ModestAST tp_AST = null;
		type = findType(LT(1).getText());
		
		try {      // for error handling
			if (!( type!=null ))
			  throw new SemanticException(" type!=null ");
			tp = LT(1);
			tp_AST = (ModestAST)astFactory.create(tp);
			astFactory.addASTChild(currentAST, tp_AST);
			match(IDENTIFIER);
			if ( inputState.guessing==0 ) {
				qualified_type_AST = (ModestAST)currentAST.root;
				
						if( type == null )
						{
							String error = "invalid type '" + tp.getText() + "'";
							System.err.println(error);
							throw new SemanticException(error, this.getFilename(),
																		 tp.getLine(), tp.getColumn());
						}
						// increase reference count..
						//type->inc_refcount();
						/* condense the complete AST for this rule into one handy imaginary AST node
						 * with all the info needed.
						 */
						qualified_type_AST = (ModestAST)astFactory.make( (new ASTArray(1)).add((ModestAST)astFactory.create(TYPE_AST,type)));
						//##->setSymbolType(type);
						qualified_type_AST.setLine(tp.getLine());
						qualified_type_AST.setColumn(tp.getColumn());
					
				currentAST.root = qualified_type_AST;
				currentAST.child = qualified_type_AST!=null &&qualified_type_AST.getFirstChild()!=null ?
					qualified_type_AST.getFirstChild() : qualified_type_AST;
				currentAST.advanceChildToEnd();
			}
			qualified_type_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		returnAST = qualified_type_AST;
		return type;
	}
	
/** Variable declarations
 * define a variable for later use.
 * @todo verify that tree is built as declaration and split initialization
 *       out to separate assignment..
 * NOTE: a lot of the expressive power of previous versions was curbed
 */
	public final void variable_declaration(
		boolean inStruct
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST variable_declaration_AST = null;
		ModestAST type_AST = null;
		ModestAST id1_AST = null;
		ModestAST asn1_AST = null;
		ModestAST id2_AST = null;
		ModestAST asn2_AST = null;
		
			int modifiers = 0;
			//Symbol_type *tp;
			Symbol sym;
			String tp;
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case MCONST:
			case MEXTERN:
			case PATIENT:
			case IMPATIENT:
			{
				modifiers=modifier();
				break;
			}
			case IDENTIFIER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			tp=qualified_type();
			type_AST = (ModestAST)returnAST;
			if ( inputState.guessing==0 ) {
				variable_declaration_AST = (ModestAST)currentAST.root;
				variable_declaration_AST = type_AST;
				currentAST.root = variable_declaration_AST;
				currentAST.child = variable_declaration_AST!=null &&variable_declaration_AST.getFirstChild()!=null ?
					variable_declaration_AST.getFirstChild() : variable_declaration_AST;
				currentAST.advanceChildToEnd();
			}
			{
			identifier_or_array_decl(tp,modifiers,inStruct);
			id1_AST = (ModestAST)returnAST;
			if ( inputState.guessing==0 ) {
				variable_declaration_AST = (ModestAST)currentAST.root;
				
							variable_declaration_AST.addChild(id1_AST);
					      	//vars.add(new Symbol(id1.getText(), tp));//type.getText()); 
					      	//System.err.println("vars size: " + vars.size()+ " added: " + id1.getText());
					
			}
			{
			switch ( LA(1)) {
			case ASSIGN:
			{
				vardecl_assign(modifiers/*,sym*/,id1_AST);
				asn1_AST = (ModestAST)returnAST;
				break;
			}
			case COMMA:
			case SEMICOLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			}
			{
			_loop122:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					{
					identifier_or_array_decl(tp,modifiers,inStruct);
					id2_AST = (ModestAST)returnAST;
					if ( inputState.guessing==0 ) {
						variable_declaration_AST = (ModestAST)currentAST.root;
						
									variable_declaration_AST.addChild(id2_AST);
							      	//vars.add(new Symbol(id2.getText(), tp));
							      	//System.err.println("vars size: " + vars.size()+ " added: " + id2.getText()); 
							
					}
					{
					switch ( LA(1)) {
					case ASSIGN:
					{
						vardecl_assign(modifiers,/*sym,*/id2_AST);
						asn2_AST = (ModestAST)returnAST;
						break;
					}
					case COMMA:
					case SEMICOLON:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					}
				}
				else {
					break _loop122;
				}
				
			} while (true);
			}
			match(SEMICOLON);
			if ( inputState.guessing==0 ) {
				variable_declaration_AST = (ModestAST)currentAST.root;
				//{{{ Add top node and generate palt's for initializations 
						// add a VARIABLE_DECLARATION_AST node as top...
						variable_declaration_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add((ModestAST)astFactory.create(VARIABLE_DECLARATION_AST,"var_decl")).add(variable_declaration_AST));
						variable_declaration_AST.setLine(type_AST.getLine());
						variable_declaration_AST.setColumn(type_AST.getColumn());
						//}}}
					
				currentAST.root = variable_declaration_AST;
				currentAST.child = variable_declaration_AST!=null &&variable_declaration_AST.getFirstChild()!=null ?
					variable_declaration_AST.getFirstChild() : variable_declaration_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		returnAST = variable_declaration_AST;
	}
	
/** Set definition
 * @todo finish last bits of set implementation see comment before.
 */
	public final void set() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST set_AST = null;
		
		try {      // for error handling
			ModestAST tmp17_AST = null;
			tmp17_AST = (ModestAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp17_AST);
			match(LCURL);
			set_element();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop244:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					set_element();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop244;
				}
				
			} while (true);
			}
			match(RCURL);
			set_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = set_AST;
	}
	
/** specify a range [a_range_type] or [<numeral>..<numeral>]
 */
	public final String  range() throws RecognitionException, TokenStreamException {
		String returnType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST range_AST = null;
		Token  dots = null;
		ModestAST dots_AST = null;
		
			//const Symbol_type *type1 = 0, *type2 = 0;
			String type1 = "", type2 ="";
		
		
		try {      // for error handling
			match(LBRACKET);
			{
			boolean synPredMatched251 = false;
			if (((LA(1)==IDENTIFIER) && (LA(2)==RBRACKET))) {
				int _m251 = mark();
				synPredMatched251 = true;
				inputState.guessing++;
				try {
					{
					qualified_type();
					}
				}
				catch (RecognitionException pe) {
					synPredMatched251 = false;
				}
				rewind(_m251);
inputState.guessing--;
			}
			if ( synPredMatched251 ) {
				returnType=qualified_type();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else if ((_tokenSet_11.member(LA(1))) && (_tokenSet_12.member(LA(2)))) {
				{
				type1=simple_expression();
				astFactory.addASTChild(currentAST, returnAST);
				dots = LT(1);
				dots_AST = (ModestAST)astFactory.create(dots);
				astFactory.makeASTRoot(currentAST, dots_AST);
				match(DOTDOT);
				type2=simple_expression();
				astFactory.addASTChild(currentAST, returnAST);
				if ( inputState.guessing==0 ) {
					
								if( type1 != type2 )
								{
									//std::ostringstream error;
									String error = "range expressions not compatible";
									throw new SemanticException(error, this.getFilename(),
																			 dots.getLine(),
																			 dots.getColumn());
								}
								/*if( !SymData->is_int(type1) || !SymData->is_int(type2) )
								{
									std::ostringstream error;
									error << "range expression(s) should be integers";
									throw antlr::SemanticException(error.str(), this->getFilename(),
																			 dots->getLine(),
																			 dots->getColumn());
								}*/
								// finaly set return type...
								returnType = type1;
							
				}
				}
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			match(RBRACKET);
			range_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = range_AST;
		return returnType;
	}
	
/** Struct definition
 */
	public final void astruct() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST astruct_AST = null;
		
		try {      // for error handling
			ModestAST tmp22_AST = null;
			tmp22_AST = (ModestAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp22_AST);
			match(LCURL);
			{
			int _cnt255=0;
			_loop255:
			do {
				if ((_tokenSet_13.member(LA(1)))) {
					variable_declaration(true);
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt255>=1 ) { break _loop255; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt255++;
			} while (true);
			}
			match(RCURL);
			astruct_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = astruct_AST;
	}
	
	public final void vardecl_assign(
		int modifiers, /*Symbol *sym,*/ ModestAST id
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST vardecl_assign_AST = null;
		Token  asgn = null;
		ModestAST asgn_AST = null;
		ModestAST expr_AST = null;
		
			//const Symbol_type* expr_type = 0;
			String exprType = "";
		
		
		try {      // for error handling
			asgn = LT(1);
			asgn_AST = (ModestAST)astFactory.create(asgn);
			match(ASSIGN);
			exprType=expression();
			expr_AST = (ModestAST)returnAST;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_14);
			} else {
			  throw ex;
			}
		}
		returnAST = vardecl_assign_AST;
	}
	
	public final String  expression() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST expression_AST = null;
		Token  op = null;
		ModestAST op_AST = null;
		
			//const Symbol_type *opt1 = 0, *opt2 = 0;
			String opt1 = null, opt2 = null;
		
		
		try {      // for error handling
			resultType=or_expr();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case QUESTION:
			{
				op = LT(1);
				op_AST = (ModestAST)astFactory.create(op);
				astFactory.makeASTRoot(currentAST, op_AST);
				match(QUESTION);
				opt1=or_expr();
				astFactory.addASTChild(currentAST, returnAST);
				match(COLON);
				opt2=or_expr();
				astFactory.addASTChild(currentAST, returnAST);
				if ( inputState.guessing==0 ) {
					resultType = opt1;
				}
				break;
			}
			case EOF:
			case ELSE:
			case RBRACE:
			case RBRACKET:
			case RCURL:
			case ASSIGN_END:
			case COMMA:
			case DCOLON:
			case COLON:
			case SEMICOLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			expression_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_15);
			} else {
			  throw ex;
			}
		}
		returnAST = expression_AST;
		return resultType;
	}
	
/** normal variable or array declaration
 * @todo fix some range handling issues in this rule
 */
	public final void identifier_or_array_decl(
		/*Symbol_type *type,*/  String sType, int modifiers, boolean inStruct
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST identifier_or_array_decl_AST = null;
		Token  id1 = null;
		ModestAST id1_AST = null;
		ModestAST i_AST = null;
		
			//std::deque<Bound*> idxs;
			//std::string var_name;
			//String varName ="";
			//const Symbol_type *idx_type;
			String type = "";
			boolean isArray = false;
		
		
		try {      // for error handling
			id1 = LT(1);
			id1_AST = (ModestAST)astFactory.create(id1);
			match(IDENTIFIER);
			{
			_loop150:
			do {
				if ((LA(1)==LBRACKET)) {
					{
					match(LBRACKET);
					type=expression();
					i_AST = (ModestAST)returnAST;
					match(RBRACKET);
					if ( inputState.guessing==0 ) {
						isArray = true;
					}
					}
				}
				else {
					break _loop150;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				identifier_or_array_decl_AST = (ModestAST)currentAST.root;
				/*
						//{{{ Add the found variable declaration to the symbol table 
						// first check modifiers (int/float/action... )
						if( SymData->is_int(type) || SymData->is_float(type) )
						{
							check_modifiers_for_int( modifiers, var_name, id1->getLine(),
															 id1->getColumn() );
						}
						if( SymData->is_action(type) )
						{
							check_modifiers_for_action( modifiers, var_name, id1->getLine(),
																 id1->getColumn() );
						}
						/// @todo: modifier checks for other types
				
						if( idxs.size() != 0 && (modifiers & (MOD_CONST+MOD_EXTERN)))
						{
							const char* ext = (modifiers & MOD_EXTERN) ? "extern ":"";
							const char* cst = (modifiers & MOD_CONST) ? "constant ":"";
				
							std::ostringstream error;
							error << ext << cst << " variables are not supported for arrays in definition of '"
									<< var_name << "'";
							throw antlr::SemanticException(error.str(),
																	 this->getFilename(),
																	 id1->getLine(),
																	 id1->getColumn()
																	 );
						}
				
						// handle const definition and model parameters
						if( modifiers & MOD_CONST )
						{
							if( (modifiers & MOD_CONST) || (modifiers & MOD_EXTERN) )
							{
								Symbol_const* t;
								if( SymData->is_float(type) )
									ret_sym = t = new Symbol_const(var_name,
																			 type, 0.0,
																			 this->getFilename().c_str(),
																			 id1->getLine(), id1->getColumn(),
																			 SymData->get_current_scope(),
																			 SymData->get_current_namespace());
								else	// must be int
									ret_sym = t = new Symbol_const(var_name,
																			 type, 0,
																			 this->getFilename().c_str(),
																			 id1->getLine(), id1->getColumn(),
																			 SymData->get_current_scope(),
																			 SymData->get_current_namespace());
				
								if( modifiers & MOD_EXTERN )
									t->setParameter(true);
							}
						}
						else  // not a constant or model parameter -> array or normal var
						{
							if( idxs.size() != 0 )
							{
								// we're dealing with an array take care of defining the
								 // types for it.
								 //
								if( ! type->supports_struct( STRUCT_ARRAY ) )
								{
									std::ostringstream error;
									error << "type '" << type->get_name()
										<< "' supports no arrays in definition of '"
										<< var_name << "'";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 id1->getLine(),
																			 id1->getColumn()
																			 );
								}
								// the arrays are build using a linked list now.
								  //the real underlying type of an array is obtained by
								  //recursively doing a get_prototype on them untill you get to
								 // a prototype that's not symbol_array.
								 //
								 // int md[10][10]
								 //
								 // md.type = int[10][20]
								 // md[1].type = int[10]
								 // md[1][1].type = int
								 ///
								std::deque<Bound*>::reverse_iterator i = idxs.rbegin();
								const Symbol_type* cur_type = type;
				
								std::ostringstream typeName;
								typeName << cur_type->get_name();
								//					std::cerr << "Array type: " << typeName.str() << std::endl;
								while( i != idxs.rend() )
								{
									Bound* bound = *i;
				
									typeName << "[" << bound->get_size() << "]";
				
									// see if it's been declared ?
									const Symbol_array* array_type =
										dynamic_cast<const Symbol_array*>
										(SymData->find_type(typeName.str()));
				
									if( array_type == 0 )
									{
										// there was no type yet for this type of array
										// make it and insert into symbol table
										Symbol_array* new_arr = new
											Symbol_array( typeName.str().c_str(),
															  this->getFilename().c_str(),
															  id1->getLine(), id1->getColumn(),
															  SymData->get_current_scope(),
															  SymData->get_current_namespace()
															  );
										// set bound
										new_arr->set_bound(bound);
										// and the underlying type
										new_arr->set_prototype(cur_type);
				
										try   { SymData->add_type(new_arr); }
										catch ( SymbolTableException& ex ) {
											// rethrow
											std::ostringstream error;
											error << "Internal error failed to build prototype for array '"
												<< var_name << "' error: '" << ex.get_message() << "'";
											throw antlr::SemanticException(error.str(),
																					 this->getFilename(),
																					 ex.get_line(),
																					 ex.get_column() );
										}
										array_type = new_arr;
									}
									cur_type = array_type;
									++i;
								}
								// here all the array mess should be handled types and subtypes
								// should be inserted into symtab now define the symbol
								// with the newly constructed type (or old found one)
								//
								ret_sym = new Symbol( var_name,
															 cur_type,
															 this->getFilename().c_str(),
															 id1->getLine(), id1->getColumn(),
															 SymData->get_current_scope(),
															 SymData->get_current_namespace()
															 );
							}
							else // not an array...
							{
								if( SymData->is_action(type) )	// actions need different class.
								{
									bool patient = def_actions_patient;	// take default...
									if (modifiers & MOD_PATIENT)			// and update if requested..
										patient = true;
									if (modifiers & MOD_IMPATIENT)
										patient = false;
				
									if( SymData->get_current_scope() != SymData->get_global_scope() )
									{
										std::ostringstream error;
										error << "cannot declare action '" << var_name
											<< "' local (only global scope supported for actions)";
										throw antlr::SemanticException(error.str(),
																				 this->getFilename(),
																				 id1->getLine(),
																				 id1->getColumn()
																				 );
									}
				
									ret_sym = new Symbol_action(var_name,
																		 type,
																		 patient,
																		 this->getFilename().c_str(),
																		 id1->getLine(), id1->getColumn(),
																		 SymData->get_current_scope(),
																		 SymData->get_current_namespace());
								}
								else // make a generic symbol
									ret_sym = new Symbol( var_name, type,
																 this->getFilename().c_str(),
																 id1->getLine(), id1->getColumn(),
																 SymData->get_current_scope(),
																 SymData->get_current_namespace());
							}
						}
				
						try {
							// And finalyy add the thing to the symtab...
							SymData->add(ret_sym);
						}
						catch( SymbolTableException& ex )
						{
							// Rethrow the beast as something the parser understands...
							throw antlr::SemanticException(ex.get_message(),
																	 this->getFilename(),
																	 ex.get_line(), ex.get_column() );
						}
				//		cout << "Defined symbol: " << *ret_sym << endl;
				//		cout << "Defined symbol type: " << *(ret_sym->get_type()) << endl;
				
				//		cout << "PARSER: current scope: " << SymData->get_current_namespace()
				//			<< " sym: " << ret_sym->get_name()
				//			<< endl;
						// and add symbol to the scope it's in
						SymData->get_current_scope()->add_symbol(ret_sym);
						
						*/
						if (isArray) sType = sType + "_array";
						Symbol varSymbol = new Symbol(id1.getText(), sType);
						varSymbol.setLine(id1.getLine());
						varSymbol.setColumn(id1.getColumn());
						if (!inStruct){
							if (sType.equals("exception"))
								excs.add(varSymbol);
							else vars.add(varSymbol);
							unUsedVars.put(id1.getText(), varSymbol);	
						}
				
						identifier_or_array_decl_AST = (ModestAST)astFactory.make( (new ASTArray(1)).add((ModestAST)astFactory.create(IDENTIFIER,id1.getText())));
						identifier_or_array_decl_AST.setSymbol(new Symbol(id1.getText(), sType));
						identifier_or_array_decl_AST.setLine(id1.getLine());
						identifier_or_array_decl_AST.setColumn(id1.getColumn());
						
					
				currentAST.root = identifier_or_array_decl_AST;
				currentAST.child = identifier_or_array_decl_AST!=null &&identifier_or_array_decl_AST.getFirstChild()!=null ?
					identifier_or_array_decl_AST.getFirstChild() : identifier_or_array_decl_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_16);
			} else {
			  throw ex;
			}
		}
		returnAST = identifier_or_array_decl_AST;
	}
	
/** Local process
 * work horse practically any statement.
 */
	public final void local_process() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST local_process_AST = null;
		Token  stop = null;
		ModestAST stop_AST = null;
		Token  brk = null;
		ModestAST brk_AST = null;
		Token  t = null;
		ModestAST t_AST = null;
		Token  id = null;
		ModestAST id_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case STOP:
			{
				stop = LT(1);
				stop_AST = (ModestAST)astFactory.create(stop);
				astFactory.addASTChild(currentAST, stop_AST);
				match(STOP);
				break;
			}
			case BREAK:
			{
				brk = LT(1);
				brk_AST = (ModestAST)astFactory.create(brk);
				astFactory.addASTChild(currentAST, brk_AST);
				match(BREAK);
				break;
			}
			case THROW:
			{
				t = LT(1);
				t_AST = (ModestAST)astFactory.create(t);
				astFactory.makeASTRoot(currentAST, t_AST);
				match(THROW);
				id = LT(1);
				id_AST = (ModestAST)astFactory.create(id);
				astFactory.addASTChild(currentAST, id_AST);
				match(IDENTIFIER);
				if ( inputState.guessing==0 ) {
					
								Symbol sym = null;
								for (Iterator iter = vars.iterator(); iter.hasNext();)
								{
									Symbol var = (Symbol)iter.next();
									if (id.getText().equals(var.getName()))
										sym = var;
								}
								for (Iterator iter = excs.iterator(); iter.hasNext();)
								{
									Symbol exc = (Symbol)iter.next();
									if (id.getText().equals(exc.getName()))
										sym = exc;
									
								}
								if( sym != null )
								{
									if( ! excs.contains(sym) )
									{
										//std::ostringstream error;
										String error = "can only throw exception typed identifiers";
										throw new SemanticException(error,
																				 this.getFilename(),
																				 id_AST.getLine(), id_AST.getColumn());
									}
									//#id->setSymbol(sym);
									//#t->setSymbol(sym);
									if (unUsedVars.containsValue(sym))
										unUsedVars.remove(sym.getName());
								}
								else
								{
									//std::ostringstream error;
									String error = "undefined symbol '" + id.getText() + "'";
									throw new SemanticException(error, this.getFilename(),
																			 id.getLine(), id.getColumn());
								}
							
				}
				break;
			}
			case TRY:
			{
				try_block();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case IF:
			{
				if_stmnt();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case ALT:
			{
				alt_stmnt();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case DO:
			{
				loop_stmnt();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case PAR:
			{
				parallel_composition();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case RELABEL:
			case HIDE:
			case EXTEND:
			{
				label_modification();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case WHEN:
			case URGENT:
			{
				guarded_process();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case LCURL:
			{
				process_body();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			default:
				boolean synPredMatched129 = false;
				if (((LA(1)==IDENTIFIER) && (_tokenSet_17.member(LA(2))) && (_tokenSet_11.member(LA(3))))) {
					int _m129 = mark();
					synPredMatched129 = true;
					inputState.guessing++;
					try {
						{
						assignment(true);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched129 = false;
					}
					rewind(_m129);
inputState.guessing--;
				}
				if ( synPredMatched129 ) {
					assignment(true);
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					boolean synPredMatched131 = false;
					if (((LA(1)==IDENTIFIER) && (LA(2)==LBRACE))) {
						int _m131 = mark();
						synPredMatched131 = true;
						inputState.guessing++;
						try {
							{
							parameterized_object();
							}
						}
						catch (RecognitionException pe) {
							synPredMatched131 = false;
						}
						rewind(_m131);
inputState.guessing--;
					}
					if ( synPredMatched131 ) {
						parameterized_object();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else if ((LA(1)==PALT||LA(1)==ASSIGN_START||LA(1)==IDENTIFIER) && (_tokenSet_18.member(LA(2))) && (_tokenSet_19.member(LA(3)))) {
						perform_action();
						astFactory.addASTChild(currentAST, returnAST);
					}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}}
				}
				local_process_AST = (ModestAST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_20);
				} else {
				  throw ex;
				}
			}
			returnAST = local_process_AST;
		}
		
/** Try .. throw .. catch ..
 * exception handling
 * @todo check type checking on exceptions
 */
	public final void try_block() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST try_block_AST = null;
		Token  catcher = null;
		ModestAST catcher_AST = null;
		Token  id = null;
		ModestAST id_AST = null;
		ModestAST pbody_AST = null;
		
		try {      // for error handling
			ModestAST tmp27_AST = null;
			tmp27_AST = (ModestAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp27_AST);
			match(TRY);
			process_body();
			astFactory.addASTChild(currentAST, returnAST);
			{
			int _cnt139=0;
			_loop139:
			do {
				if ((LA(1)==CATCH)) {
					catcher = LT(1);
					catcher_AST = (ModestAST)astFactory.create(catcher);
					match(CATCH);
					match(LBRACE);
					id = LT(1);
					id_AST = (ModestAST)astFactory.create(id);
					match(IDENTIFIER);
					match(RBRACE);
					if ( inputState.guessing==0 ) {
						
								Symbol sym = null;
								for (Iterator iter = vars.iterator(); iter.hasNext();)
								{
									Symbol var = (Symbol)iter.next();
									if (id.getText().equals(var.getName()))
										sym = var;
								}
								for (Iterator iter = excs.iterator(); iter.hasNext();)
								{
									Symbol exc = (Symbol)iter.next();
									if (id.getText().equals(exc.getName()))
										sym = exc;
									
								}
								if( sym != null )
								{
									if( ! excs.contains(sym) )
									{
										//std::ostringstream error;
										String error = "can only throw exception typed identifiers";
										throw new SemanticException(error,
																				 this.getFilename(),
																				 id_AST.getLine(), id_AST.getColumn());
									}
									//#id->setSymbol(sym);
									//#t->setSymbol(sym);
								}
								else
								{
									//std::ostringstream error;
									String error = "undefined symbol '" + id.getText() + "'";
									throw new SemanticException(error, this.getFilename(),
																			 id.getLine(), id.getColumn());
								}
							
					}
					process_body();
					pbody_AST = (ModestAST)returnAST;
					if ( inputState.guessing==0 ) {
						try_block_AST = (ModestAST)currentAST.root;
						
								// build AST
								//RefModest_AST cdef 
								ModestAST cdef = (ModestAST)astFactory.make( (new ASTArray(3)).add((ModestAST)astFactory.create(CATCH_DEFINITION_AST,"catch_def")).add(id_AST).add(pbody_AST));
								//cdef->setSymbol(sym);
								cdef.setLine(id_AST.getLine());
								cdef.setColumn(id_AST.getColumn());
								// and add it as a child..
								try_block_AST.addChild(cdef);
							
					}
				}
				else {
					if ( _cnt139>=1 ) { break _loop139; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt139++;
			} while (true);
			}
			try_block_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = try_block_AST;
	}
	
/** If statement
 * this is a static construct
 * NOTE: probably not used anymore due to disabling of forall
 */
	public final void if_stmnt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST if_stmnt_AST = null;
		
		try {      // for error handling
			ModestAST tmp30_AST = null;
			tmp30_AST = (ModestAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp30_AST);
			match(IF);
			match(LBRACE);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(RBRACE);
			local_process();
			astFactory.addASTChild(currentAST, returnAST);
			{
			if ((LA(1)==ELSE) && (_tokenSet_21.member(LA(2))) && (_tokenSet_22.member(LA(3)))) {
				ModestAST tmp33_AST = null;
				tmp33_AST = (ModestAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp33_AST);
				match(ELSE);
				local_process();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else if ((_tokenSet_20.member(LA(1))) && (_tokenSet_23.member(LA(2))) && (_tokenSet_24.member(LA(3)))) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			if_stmnt_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = if_stmnt_AST;
	}
	
/** Alt statement
 */
	public final void alt_stmnt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST alt_stmnt_AST = null;
		Token  alt = null;
		ModestAST alt_AST = null;
		
		try {      // for error handling
			alt = LT(1);
			alt_AST = (ModestAST)astFactory.create(alt);
			astFactory.makeASTRoot(currentAST, alt_AST);
			match(ALT);
			match(LCURL);
			{
			int _cnt164=0;
			_loop164:
			do {
				if ((LA(1)==DCOLON)) {
					alternative();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt164>=1 ) { break _loop164; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt164++;
			} while (true);
			}
			match(RCURL);
			alt_stmnt_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = alt_stmnt_AST;
	}
	
/** Loop statement
 */
	public final void loop_stmnt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST loop_stmnt_AST = null;
		
		try {      // for error handling
			ModestAST tmp36_AST = null;
			tmp36_AST = (ModestAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp36_AST);
			match(DO);
			match(LCURL);
			{
			int _cnt167=0;
			_loop167:
			do {
				if ((LA(1)==DCOLON)) {
					alternative();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt167>=1 ) { break _loop167; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt167++;
			} while (true);
			}
			match(RCURL);
			loop_stmnt_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = loop_stmnt_AST;
	}
	
/** Parallel composition
 */
	public final void parallel_composition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST parallel_composition_AST = null;
		Token  par = null;
		ModestAST par_AST = null;
		
		try {      // for error handling
			par = LT(1);
			par_AST = (ModestAST)astFactory.create(par);
			astFactory.makeASTRoot(currentAST, par_AST);
			match(PAR);
			match(LCURL);
			{
			int _cnt161=0;
			_loop161:
			do {
				if ((LA(1)==DCOLON)) {
					alternative();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt161>=1 ) { break _loop161; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt161++;
			} while (true);
			}
			match(RCURL);
			parallel_composition_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = parallel_composition_AST;
	}
	
/** Labeling modifiers
 */
	public final void label_modification() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST label_modification_AST = null;
		Token  h = null;
		ModestAST h_AST = null;
		Token  r = null;
		ModestAST r_AST = null;
		Token  e = null;
		ModestAST e_AST = null;
		ModestAST expr1_AST = null;
		
			/*RefModest_AST key;
			Relabeling::relabel_type type;
			const char* what;
			const Symbol_type* dummy;*/
			ModestAST key;
			String what;
			String dummy = "";
			
			//System.err.println("in label_modification"); 
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case HIDE:
			{
				h = LT(1);
				h_AST = (ModestAST)astFactory.create(h);
				astFactory.makeASTRoot(currentAST, h_AST);
				match(HIDE);
				if ( inputState.guessing==0 ) {
					key = h_AST; /*type = Relabeling::HIDE;*/ what = "hide";
				}
				dummy=simple_expression();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case RELABEL:
			{
				r = LT(1);
				r_AST = (ModestAST)astFactory.create(r);
				astFactory.makeASTRoot(currentAST, r_AST);
				match(RELABEL);
				if ( inputState.guessing==0 ) {
					key = r_AST; /*type = Relabeling::RELABEL;*/ what = "relabel";
				}
				labels_by_labels();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case EXTEND:
			{
				e = LT(1);
				e_AST = (ModestAST)astFactory.create(e);
				astFactory.makeASTRoot(currentAST, e_AST);
				match(EXTEND);
				if ( inputState.guessing==0 ) {
					key = e_AST; /*type = Relabeling::EXTEND;*/ what = "extend";
				}
				dummy=simple_expression();
				expr1_AST = (ModestAST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			local_process();
			astFactory.addASTChild(currentAST, returnAST);
			label_modification_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = label_modification_AST;
	}
	
/** Guarded process
 */
	public final void guarded_process() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST guarded_process_AST = null;
		Token  w = null;
		ModestAST w_AST = null;
		Token  u = null;
		ModestAST u_AST = null;
		ModestAST expr_AST = null;
		ModestAST lp_AST = null;
		
			//const Symbol_type *tp = 0;
			String tp = "";
			boolean isUrgent = false;
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case WHEN:
			{
				w = LT(1);
				w_AST = (ModestAST)astFactory.create(w);
				match(WHEN);
				break;
			}
			case URGENT:
			{
				u = LT(1);
				u_AST = (ModestAST)astFactory.create(u);
				match(URGENT);
				if ( inputState.guessing==0 ) {
					isUrgent = true;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LBRACE);
			tp=expression();
			expr_AST = (ModestAST)returnAST;
			match(RBRACE);
			local_process();
			lp_AST = (ModestAST)returnAST;
			if ( inputState.guessing==0 ) {
				guarded_process_AST = (ModestAST)currentAST.root;
				
						if( w == null )	// play a little dirty..
							w = u;	// set unused RefToken w == u
				
						/*if( !tp || ! SymData->is_bool(tp) )
						{
							std::ostringstream error;
							error << "guard expression must be boolean";
							// do not use #expr since it may be NULL
							throw antlr::SemanticException(error.str(),
																	 this->getFilename(),
																	 w->getLine(), w->getColumn());
						}*/
				
						guarded_process_AST = (ModestAST)astFactory.make( (new ASTArray(3)).add((ModestAST)astFactory.create(GUARD_AST,w.getText())).add(expr_AST).add(lp_AST));
						guarded_process_AST.setLine(w.getLine());
						guarded_process_AST.setColumn(w.getColumn());
						guarded_process_AST.setGuardType(isUrgent);
						//#guarded_process->setScope(SymData->get_current_scope());
					
				currentAST.root = guarded_process_AST;
				currentAST.child = guarded_process_AST!=null &&guarded_process_AST.getFirstChild()!=null ?
					guarded_process_AST.getFirstChild() : guarded_process_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = guarded_process_AST;
	}
	
/** Process body
 * used as process body and as function body.
 */
	public final void process_body() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST process_body_AST = null;
		
		try {      // for error handling
			match(LCURL);
			description();
			astFactory.addASTChild(currentAST, returnAST);
			match(RCURL);
			process_body_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_25);
			} else {
			  throw ex;
			}
		}
		returnAST = process_body_AST;
	}
	
/** Assignment rule. The parameter controls wether a 'tau PALT AST' needs to be
 * inserted in front of the assignment
 */
	public final void assignment(
		boolean need_palt
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST assignment_AST = null;
		ModestAST id_AST = null;
		ModestAST oper_AST = null;
		ModestAST e_AST = null;
		
			//const Symbol_type* expr_type = 0, *lhs_type = 0;
			String expr_type = "", lhs_type="";
			Token op;
		
		
		try {      // for error handling
			lhs_type=qualified_identifier(false);
			id_AST = (ModestAST)returnAST;
			op=assignment_op();
			oper_AST = (ModestAST)returnAST;
			expr_type=expression();
			e_AST = (ModestAST)returnAST;
			if ( inputState.guessing==0 ) {
				assignment_AST = (ModestAST)currentAST.root;
				
				//		cout << "Assignment ------------\n";
				//		print_tree<RefModest_AST,Modest_Parser> pr(*this);
				//		pr.pr_tree(#id);
				//		cout << "--\n";
				//		pr.pr_tree(#oper);
				//		cout << "--\n";
				//		pr.pr_tree(#e);
				//		cout << "Assignment ------------\n";
				
						// tag the local scope on the assignment operator
						/*#oper->setScope(SymData->get_current_scope());
				
						if( ! lhs_type )
						{
							std::ostringstream error;
							int line, column;
				
							if( op )
							{
								error << "invalid left hand side symbol in '" << op->getText()
									<< "' expression";
								line = op->getLine();
								column = op->getColumn();
							}
							else
							{
								error << "invalid left hand side symbol in assignment (near this line)";
								// these may be off some value due to guessing
								line = this->getLine();
								column = this->getColumn();
							}
							throw antlr::SemanticException(error.str(), this->getFilename(),
																	 line, column);
						}
						if( ! #e || !types_compatible_for_assignment( lhs_type, expr_type ) )
						{
							std::ostringstream error;
							error << "incompatible types used in "
								<< op->getText() << " expression";
							throw antlr::SemanticException(error.str(),
																	 this->getFilename(),
																	 op->getLine(), op->getColumn());
						}
						// have to do special check on clocks, hope the id->getSymbol is ok..
						if( SymData->is_clock(lhs_type) )
							check_clock_assignment( #id->getSymbol(), #e );*/
				
						if( need_palt )
						{
							// reportWarning(op, "inserting synthetic tau palt { .. } for assignment");
				
							ModestAST tau = create_tau_ast(op.getLine(), op.getColumn());
							ModestAST assign = ((ModestAST)astFactory.create(ASSIGN_START,"{="));
							//assign->setScope(SymData->get_current_scope());
						    ModestAST weight = ((ModestAST)astFactory.create(WEIGHT_AST,"::"));
						    weight.setWeight((double)1);
				
							assignment_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add(tau).add((ModestAST)astFactory.make( (new ASTArray(2)).add((ModestAST)astFactory.create(PALT,"palt")).add((ModestAST)astFactory.make( (new ASTArray(2)).add(weight).add((ModestAST)astFactory.make( (new ASTArray(2)).add(assign).add((ModestAST)astFactory.make( (new ASTArray(3)).add(oper_AST).add(id_AST).add(e_AST))))))))));
						}
						else
						{
							assignment_AST = (ModestAST)astFactory.make( (new ASTArray(3)).add(oper_AST).add(id_AST).add(e_AST));
						}
					
				currentAST.root = assignment_AST;
				currentAST.child = assignment_AST!=null &&assignment_AST.getFirstChild()!=null ?
					assignment_AST.getFirstChild() : assignment_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch ( RecognitionException ex ) {
			if (inputState.guessing==0) {
				
						// the default errorhandler has a tendency to eat one token too many
						// when recovering from an error. Make sure to eat up stuff till the
						// $FOLLOW set.
						if( inputState.guessing == 0 ) {
							reportError(ex);
							consumeUntil(_tokenSet_26);
						} else {
							//throw;
						}
					
			} else {
				throw ex ;
			}
		}
		returnAST = assignment_AST;
	}
	
/** Function invocation or process instantiation
 */
	public final String  parameterized_object() throws RecognitionException, TokenStreamException {
		String resultType ="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST parameterized_object_AST = null;
		Token  id = null;
		ModestAST id_AST = null;
		ModestAST args_AST = null;
		
			//Symbol_process* proc = 0;
			//Symbol_function* func = 0;
			boolean process = false; //See if we want to check somewhere if it is a func or a proc
			boolean function = false;
		
		
		try {      // for error handling
			id = LT(1);
			id_AST = (ModestAST)astFactory.create(id);
			match(IDENTIFIER);
			if ( inputState.guessing==0 ) {
				
						if (id.getText().equals("Normal") || id.getText().equals("Uniform") || id.getText().equals("Exponential"))
							function = true;
						else process = true;
						if (unUsedVars.containsKey(id.getText()))
									unUsedVars.remove(id.getText());
						/*if( Symbol* sym = SymData->find( id->getText().c_str() ) )
						{
							// see if it's a function/process
							if( (proc = dynamic_cast<Symbol_process*>(sym)) == 0 )
								func = dynamic_cast<Symbol_function*>(sym);*/
				
							//if ( processMap.containsKey(id.getText()) ) process = true;
				
							// if not bomb out...
							//if( proc == 0 && func == 0 )
							/*if ( !process && !function )
							{
								//std::ostringstream error;
								String error = "attempting to call/instantiate non function/process";
								throw new SemanticException(error, this.getFilename(),
																		 id.getLine(), id.getColumn());
							}*/
							//#id->setSymbol(sym);
						/*}
						else
						{
							std::ostringstream error;
							error << "undefined symbol '" << id->getText() << "'";
							throw antlr::SemanticException(error.str(), this->getFilename(),
																	 id->getLine(), id->getColumn());
						}*/
						
					
			}
			arguments();
			args_AST = (ModestAST)returnAST;
			if ( inputState.guessing==0 ) {
				parameterized_object_AST = (ModestAST)currentAST.root;
				
						if( process )
						{
							parameterized_object_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add((ModestAST)astFactory.create(PROCESS_INSTANTIATION_AST,id.getText())).add(args_AST));
							//##->setSymbol(proc);
							parameterized_object_AST.setLine(id.getLine());
							parameterized_object_AST.setColumn(id.getColumn());
							//##->setScope(SymData->get_current_scope());
						}
						else if ( function )
						{
							parameterized_object_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add((ModestAST)astFactory.create(FUNCTION_CALL_AST,id.getText())).add(args_AST));
							//##->setSymbol(func);
							parameterized_object_AST.setLine(id.getLine());
							parameterized_object_AST.setColumn(id.getColumn());
							//##->setScope(SymData->get_current_scope());
							resultType = "float"; //func->get_type();
							// Check out how to find the result type of the function ;)
						}
						
					
				currentAST.root = parameterized_object_AST;
				currentAST.child = parameterized_object_AST!=null &&parameterized_object_AST.getFirstChild()!=null ?
					parameterized_object_AST.getFirstChild() : parameterized_object_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = parameterized_object_AST;
		return resultType;
	}
	
	public final void perform_action() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST perform_action_AST = null;
		ModestAST p1_AST = null;
		ModestAST qi1_AST = null;
		ModestAST p2_AST = null;
		ModestAST asgn1_AST = null;
		ModestAST qi2_AST = null;
		ModestAST asgn2_AST = null;
		ModestAST qi3_AST = null;
		
			//const Symbol_type* tp = 0;
			String tp = null;
			//System.err.println("in perform_action");
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case PALT:
			{
				palt_stmnt();
				p1_AST = (ModestAST)returnAST;
				if ( inputState.guessing==0 ) {
					perform_action_AST = (ModestAST)currentAST.root;
					
					// This one triggers a bug in antlr's codegen.
					//		#perform_action = #( create_tau_ast(#p1->getLine(),#p1->getColumn()), #p1 );
							// reportWarning(#p1, "inserting synthetic 'tau' for palt without leading action");
							ModestAST tau = create_tau_ast(p1_AST.getLine(),p1_AST.getColumn());
							perform_action_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add(tau).add(p1_AST));
						
					currentAST.root = perform_action_AST;
					currentAST.child = perform_action_AST!=null &&perform_action_AST.getFirstChild()!=null ?
						perform_action_AST.getFirstChild() : perform_action_AST;
					currentAST.advanceChildToEnd();
				}
				break;
			}
			case ASSIGN_START:
			{
				assignment_block();
				asgn1_AST = (ModestAST)returnAST;
				if ( inputState.guessing==0 ) {
					perform_action_AST = (ModestAST)currentAST.root;
					
							ModestAST tau = create_tau_ast(asgn1_AST.getLine(),asgn1_AST.getColumn());
							ModestAST weight = ((ModestAST)astFactory.create(WEIGHT_AST,"::"));
							weight.setWeight((double)1);
					
							perform_action_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add(tau).add((ModestAST)astFactory.make( (new ASTArray(2)).add((ModestAST)astFactory.create(PALT,"palt")).add((ModestAST)astFactory.make( (new ASTArray(2)).add(weight).add(asgn1_AST))))));
						
					currentAST.root = perform_action_AST;
					currentAST.child = perform_action_AST!=null &&perform_action_AST.getFirstChild()!=null ?
						perform_action_AST.getFirstChild() : perform_action_AST;
					currentAST.advanceChildToEnd();
				}
				break;
			}
			default:
				boolean synPredMatched134 = false;
				if (((LA(1)==IDENTIFIER) && (LA(2)==PALT||LA(2)==LBRACKET||LA(2)==DOT) && (_tokenSet_11.member(LA(3))))) {
					int _m134 = mark();
					synPredMatched134 = true;
					inputState.guessing++;
					try {
						{
						qualified_identifier(false);
						match(PALT);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched134 = false;
					}
					rewind(_m134);
inputState.guessing--;
				}
				if ( synPredMatched134 ) {
					tp=qualified_identifier(false);
					qi1_AST = (ModestAST)returnAST;
					palt_stmnt();
					p2_AST = (ModestAST)returnAST;
					if ( inputState.guessing==0 ) {
						perform_action_AST = (ModestAST)currentAST.root;
						
								/*if( !tp || !SymData->is_action(tp) )
								{
									std::ostringstream error;
									error << "identifier leading up to palt must be of type 'action'";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 #qi1->getLine(), #qi1->getColumn());
								}*/
								perform_action_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add(qi1_AST).add(p2_AST));
							
						currentAST.root = perform_action_AST;
						currentAST.child = perform_action_AST!=null &&perform_action_AST.getFirstChild()!=null ?
							perform_action_AST.getFirstChild() : perform_action_AST;
						currentAST.advanceChildToEnd();
					}
				}
				else {
					boolean synPredMatched136 = false;
					if (((LA(1)==IDENTIFIER) && (LA(2)==LBRACKET||LA(2)==ASSIGN_START||LA(2)==DOT) && (_tokenSet_11.member(LA(3))))) {
						int _m136 = mark();
						synPredMatched136 = true;
						inputState.guessing++;
						try {
							{
							qualified_identifier(false);
							match(ASSIGN_START);
							}
						}
						catch (RecognitionException pe) {
							synPredMatched136 = false;
						}
						rewind(_m136);
inputState.guessing--;
					}
					if ( synPredMatched136 ) {
						tp=qualified_identifier(false);
						qi2_AST = (ModestAST)returnAST;
						assignment_block();
						asgn2_AST = (ModestAST)returnAST;
						if ( inputState.guessing==0 ) {
							perform_action_AST = (ModestAST)currentAST.root;
							
									/*if( !tp || !SymData->is_action(tp) )
									{
										std::ostringstream error;
										error << "identifier leading up to palt must be of type 'action'";
										throw antlr::SemanticException(error.str(),
																				 this->getFilename(),
																				 #qi2->getLine(), #qi2->getColumn());
									}*/
									ModestAST weight = ((ModestAST)astFactory.create(WEIGHT_AST,"::"));
									weight.setWeight(1);
							
									perform_action_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add(qi2_AST).add((ModestAST)astFactory.make( (new ASTArray(2)).add((ModestAST)astFactory.create(PALT,"palt")).add((ModestAST)astFactory.make( (new ASTArray(2)).add(weight).add(asgn2_AST))))));
								
							currentAST.root = perform_action_AST;
							currentAST.child = perform_action_AST!=null &&perform_action_AST.getFirstChild()!=null ?
								perform_action_AST.getFirstChild() : perform_action_AST;
							currentAST.advanceChildToEnd();
						}
					}
					else if ((LA(1)==IDENTIFIER) && (_tokenSet_27.member(LA(2))) && (_tokenSet_23.member(LA(3)))) {
						tp=qualified_identifier(false);
						qi3_AST = (ModestAST)returnAST;
						if ( inputState.guessing==0 ) {
							perform_action_AST = (ModestAST)currentAST.root;
							
									if(!tp.equals("action"))//( !tp || !SymData->is_action(tp) )
									{
										String error = "Trying to use non action as action";
										System.err.println(error);
										throw new SemanticException(error, this.getFilename(),
																	qi3_AST.getLine(), qi3_AST.getColumn());
									}
									perform_action_AST = qi3_AST;
								
							currentAST.root = perform_action_AST;
							currentAST.child = perform_action_AST!=null &&perform_action_AST.getFirstChild()!=null ?
								perform_action_AST.getFirstChild() : perform_action_AST;
							currentAST.advanceChildToEnd();
						}
					}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_20);
				} else {
				  throw ex;
				}
			}
			returnAST = perform_action_AST;
		}
		
	public final void palt_stmnt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST palt_stmnt_AST = null;
		Token  p = null;
		ModestAST p_AST = null;
		ModestAST alt_AST = null;
		
		try {      // for error handling
			p = LT(1);
			p_AST = (ModestAST)astFactory.create(p);
			match(PALT);
			ModestAST tmp45_AST = null;
			tmp45_AST = (ModestAST)astFactory.create(LT(1));
			match(LCURL);
			if ( inputState.guessing==0 ) {
				palt_stmnt_AST = (ModestAST)currentAST.root;
				palt_stmnt_AST = p_AST;
				currentAST.root = palt_stmnt_AST;
				currentAST.child = palt_stmnt_AST!=null &&palt_stmnt_AST.getFirstChild()!=null ?
					palt_stmnt_AST.getFirstChild() : palt_stmnt_AST;
				currentAST.advanceChildToEnd();
			}
			{
			int _cnt183=0;
			_loop183:
			do {
				if ((LA(1)==COLON)) {
					palt_alternative();
					alt_AST = (ModestAST)returnAST;
					if ( inputState.guessing==0 ) {
						palt_stmnt_AST = (ModestAST)currentAST.root;
						palt_stmnt_AST.addChild(alt_AST);
					}
				}
				else {
					if ( _cnt183>=1 ) { break _loop183; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt183++;
			} while (true);
			}
			ModestAST tmp46_AST = null;
			tmp46_AST = (ModestAST)astFactory.create(LT(1));
			match(RCURL);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = palt_stmnt_AST;
	}
	
/** Qualified identifier
 * 'normal' identifier reference with optional namespace specification
 * @return a Symbol_type * for the qualified id.
 * or throw semantic exception if id not found.
 * this rule is only used to referenced things that should be
 * defined on beforehand.
 * @note The default errorhandler is turned of so that this rule behaves
 * as if it's one thing. This prevents it returning sym = 0 without throwing
 * an error.
 */
	public final String  qualified_identifier(
		boolean allow_single_id
	) throws RecognitionException, TokenStreamException {
		String type = null;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST qualified_identifier_AST = null;
		Token  base = null;
		ModestAST base_AST = null;
		Token  dot = null;
		ModestAST dot_AST = null;
		Token  member = null;
		ModestAST member_AST = null;
		Token  index = null;
		ModestAST index_AST = null;
		ModestAST expr_AST = null;
		
				//Namespace *ns = ns = SymData->get_current_namespace();
				boolean id_only = false;
				//std::string mem_parent;
				//Symbol *sym = 0;
				Symbol sym = null;
				//System.err.println("in qualified id");
			
		
		try {      // for error handling
			base = LT(1);
			base_AST = (ModestAST)astFactory.create(base);
			astFactory.addASTChild(currentAST, base_AST);
			match(IDENTIFIER);
			if ( inputState.guessing==0 ) {
					
								
						/*{{{ look up the base name and do some preliminary sorting out... */
				
						// there's a catch...
						// in certain cases we need to match a single IDENTIFIER (for sets)
						// selecting between a defined symbol and a thing that should be added
						// to a set cannot be done with antlr guessing (since in guessing mode
						// no actions are executed).
						//
						// So now we change the return AST in a few cases.
				
						//sym = SymData->find(base->getText().c_str() );
						
						for (Iterator iter = vars.iterator(); iter.hasNext();)
							{
								Symbol var = (Symbol)iter.next();
								//System.err.println("Act Var: " + var.getName());
								//System.err.println("name of action: " + base.getText());
								if (base.getText().equals(var.getName()))
								//{
									//System.err.println("matched the action to a known declaration");
									sym = var;
								//}
							}
						if( sym == null )
						{
							int la = LA(1);
				
							if( allow_single_id && (la != LBRACE && la != DOT))
								id_only = true;
							else
							{
								String error = "undefined symbol '" + base.getText() + "'";
								//System.err.println(error);
								throw new SemanticException(error, this.getFilename(),
																		 base.getLine(), base.getColumn());
							}
						}
						else
						{
							if (unUsedVars.containsValue(sym))
									unUsedVars.remove(sym.getName());
							
							
							type = sym.getType();
							base_AST.setSymbol(sym);
						}
						/*}}}*/
					
			}
			{
			_loop155:
			do {
				switch ( LA(1)) {
				case DOT:
				{
					{
					dot = LT(1);
					dot_AST = (ModestAST)astFactory.create(dot);
					astFactory.makeASTRoot(currentAST, dot_AST);
					match(DOT);
					member = LT(1);
					member_AST = (ModestAST)astFactory.create(member);
					astFactory.addASTChild(currentAST, member_AST);
					match(IDENTIFIER);
					}
					break;
				}
				case LBRACKET:
				{
					{
					/*const Symbol_type *idx_type = 0;*/ String idx_type = "";
					index = LT(1);
					index_AST = (ModestAST)astFactory.create(index);
					astFactory.makeASTRoot(currentAST, index_AST);
					match(LBRACKET);
					idx_type=expression();
					expr_AST = (ModestAST)returnAST;
					astFactory.addASTChild(currentAST, returnAST);
					match(RBRACKET);
					}
					break;
				}
				default:
				{
					break _loop155;
				}
				}
			} while (true);
			}
			qualified_identifier_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_28);
			} else {
			  throw ex;
			}
		}
		returnAST = qualified_identifier_AST;
		return type;
	}
	
/** Atomic assignment block
 * used in palt statement
 */
	public final void assignment_block() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST assignment_block_AST = null;
		Token  top = null;
		ModestAST top_AST = null;
		
		try {      // for error handling
			top = LT(1);
			top_AST = (ModestAST)astFactory.create(top);
			astFactory.makeASTRoot(currentAST, top_AST);
			match(ASSIGN_START);
			assignments();
			astFactory.addASTChild(currentAST, returnAST);
			match(ASSIGN_END);
			assignment_block_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = assignment_block_AST;
	}
	
	public final String  simple_expression() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST simple_expression_AST = null;
		
		try {      // for error handling
			resultType=additive_expr();
			astFactory.addASTChild(currentAST, returnAST);
			simple_expression_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_29);
			} else {
			  throw ex;
			}
		}
		returnAST = simple_expression_AST;
		return resultType;
	}
	
	public final void labels_by_labels() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST labels_by_labels_AST = null;
		
			//const Symbol_type *dummy = 0;
			String dummy;
		
		
		try {      // for error handling
			dummy=simple_expression();
			astFactory.addASTChild(currentAST, returnAST);
			ModestAST tmp49_AST = null;
			tmp49_AST = (ModestAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp49_AST);
			match(BY);
			dummy=simple_expression();
			astFactory.addASTChild(currentAST, returnAST);
			labels_by_labels_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_21);
			} else {
			  throw ex;
			}
		}
		returnAST = labels_by_labels_AST;
	}
	
/** Parameter list for definition of functions/processes
 */
	public final ArrayList<Symbol>  param_definition(
		String function
	) throws RecognitionException, TokenStreamException {
		ArrayList<Symbol> params = new ArrayList<Symbol>();
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST param_definition_AST = null;
		Token  t = null;
		ModestAST t_AST = null;
		ModestAST p1_AST = null;
		ModestAST pn_AST = null;
		/*unsigned*/ int cnt = 0;
			Symbol p = null;
			Symbol p2 = null;
		
		
		try {      // for error handling
			t = LT(1);
			t_AST = (ModestAST)astFactory.create(t);
			match(LBRACE);
			if ( inputState.guessing==0 ) {
				param_definition_AST = (ModestAST)currentAST.root;
				
						param_definition_AST = (ModestAST)astFactory.make( (new ASTArray(1)).add((ModestAST)astFactory.create(PARAMETER_LIST_AST,"params")));
						param_definition_AST.setLine(t.getLine());
						param_definition_AST.setColumn(t.getColumn());
					
				currentAST.root = param_definition_AST;
				currentAST.child = param_definition_AST!=null &&param_definition_AST.getFirstChild()!=null ?
					param_definition_AST.getFirstChild() : param_definition_AST;
				currentAST.advanceChildToEnd();
			}
			{
			switch ( LA(1)) {
			case MCONST:
			case MEXTERN:
			case PATIENT:
			case IMPATIENT:
			case IDENTIFIER:
			{
				if ( inputState.guessing==0 ) {
					++cnt;
				}
				p=parameter( function, cnt );
				p1_AST = (ModestAST)returnAST;
				if ( inputState.guessing==0 ) {
					param_definition_AST = (ModestAST)currentAST.root;
					param_definition_AST.addChild(p1_AST); if (p!=null) params.add(p);
				}
				{
				_loop191:
				do {
					if ((LA(1)==COMMA)) {
						match(COMMA);
						if ( inputState.guessing==0 ) {
							++cnt;
						}
						p2=parameter( function, cnt );
						pn_AST = (ModestAST)returnAST;
						if ( inputState.guessing==0 ) {
							param_definition_AST = (ModestAST)currentAST.root;
							param_definition_AST.addChild(pn_AST); if (p2!=null) params.add(p2);
						}
					}
					else {
						break _loop191;
					}
					
				} while (true);
				}
				break;
			}
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RBRACE);
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_30);
			} else {
			  throw ex;
			}
		}
		returnAST = param_definition_AST;
		return params;
	}
	
	public final void alternative() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST alternative_AST = null;
		
		try {      // for error handling
			ModestAST tmp52_AST = null;
			tmp52_AST = (ModestAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp52_AST);
			match(DCOLON);
			sequential_processes();
			astFactory.addASTChild(currentAST, returnAST);
			alternative_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_31);
			} else {
			  throw ex;
			}
		}
		returnAST = alternative_AST;
	}
	
/** Normal assignment
 */
	public final Token  assignment_op() throws RecognitionException, TokenStreamException {
		Token tok = new Token();
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST assignment_op_AST = null;
		Token  a1 = null;
		ModestAST a1_AST = null;
		Token  a2 = null;
		ModestAST a2_AST = null;
		Token  a3 = null;
		ModestAST a3_AST = null;
		Token  a4 = null;
		ModestAST a4_AST = null;
		Token  a5 = null;
		ModestAST a5_AST = null;
		Token  a6 = null;
		ModestAST a6_AST = null;
		Token  a7 = null;
		ModestAST a7_AST = null;
		Token  a8 = null;
		ModestAST a8_AST = null;
		Token  a9 = null;
		ModestAST a9_AST = null;
		Token  a10 = null;
		ModestAST a10_AST = null;
		Token  a11 = null;
		ModestAST a11_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case ASSIGN:
			{
				a1 = LT(1);
				a1_AST = (ModestAST)astFactory.create(a1);
				astFactory.addASTChild(currentAST, a1_AST);
				match(ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a1;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case PLUS_ASSIGN:
			{
				a2 = LT(1);
				a2_AST = (ModestAST)astFactory.create(a2);
				astFactory.addASTChild(currentAST, a2_AST);
				match(PLUS_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a2;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case MINUS_ASSIGN:
			{
				a3 = LT(1);
				a3_AST = (ModestAST)astFactory.create(a3);
				astFactory.addASTChild(currentAST, a3_AST);
				match(MINUS_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a3;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case MULT_ASSIGN:
			{
				a4 = LT(1);
				a4_AST = (ModestAST)astFactory.create(a4);
				astFactory.addASTChild(currentAST, a4_AST);
				match(MULT_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a4;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case DIV_ASSIGN:
			{
				a5 = LT(1);
				a5_AST = (ModestAST)astFactory.create(a5);
				astFactory.addASTChild(currentAST, a5_AST);
				match(DIV_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a5;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case MOD_ASSIGN:
			{
				a6 = LT(1);
				a6_AST = (ModestAST)astFactory.create(a6);
				astFactory.addASTChild(currentAST, a6_AST);
				match(MOD_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a6;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case SR_ASSIGN:
			{
				a7 = LT(1);
				a7_AST = (ModestAST)astFactory.create(a7);
				astFactory.addASTChild(currentAST, a7_AST);
				match(SR_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a7;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case SL_ASSIGN:
			{
				a8 = LT(1);
				a8_AST = (ModestAST)astFactory.create(a8);
				astFactory.addASTChild(currentAST, a8_AST);
				match(SL_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a8;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case BAND_ASSIGN:
			{
				a9 = LT(1);
				a9_AST = (ModestAST)astFactory.create(a9);
				astFactory.addASTChild(currentAST, a9_AST);
				match(BAND_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a9;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case BXOR_ASSIGN:
			{
				a10 = LT(1);
				a10_AST = (ModestAST)astFactory.create(a10);
				astFactory.addASTChild(currentAST, a10_AST);
				match(BXOR_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a10;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			case BOR_ASSIGN:
			{
				a11 = LT(1);
				a11_AST = (ModestAST)astFactory.create(a11);
				astFactory.addASTChild(currentAST, a11_AST);
				match(BOR_ASSIGN);
				if ( inputState.guessing==0 ) {
					tok = a11;
				}
				assignment_op_AST = (ModestAST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = assignment_op_AST;
		return tok;
	}
	
	public final void assignments() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST assignments_AST = null;
		
		try {      // for error handling
			assignment(false);
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop173:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					assignment(false);
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop173;
				}
				
			} while (true);
			}
			assignments_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_32);
			} else {
			  throw ex;
			}
		}
		returnAST = assignments_AST;
	}
	
/** Note: Alternative :: treated as :1:
 * @todo fix this for the change of weights to floats
 */
	public final void weight() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST weight_AST = null;
		Token  c = null;
		ModestAST c_AST = null;
		ModestAST expr_AST = null;
		
			//const Symbol_type *tp = 0;
			String tp = "";
		
		
		try {      // for error handling
			{
			c = LT(1);
			c_AST = (ModestAST)astFactory.create(c);
			match(COLON);
			{
			switch ( LA(1)) {
			case NOT_OP:
			case PLUS:
			case MINUS:
			case LBRACE:
			case LBRACKET:
			case LCURL:
			case HASH:
			case INT:
			case FLOAT:
			case IDENTIFIER:
			{
				tp=simple_expression();
				expr_AST = (ModestAST)returnAST;
				break;
			}
			case COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(COLON);
			}
			if ( inputState.guessing==0 ) {
				weight_AST = (ModestAST)currentAST.root;
				
					if( expr_AST != null )
					{
				// we do not forbid floats anymore                
				/*if( ! (SymData->is_int(tp) || SymData->is_float(tp)))
						{
							std::ostringstream error;
							error << "weight should be an integer or a float";
							throw antlr::SemanticException(error.str(), this->getFilename(),
																	 #expr->getLine(),
																	 #expr->getColumn() );
						}
				
						CalcStaticExpr walk( SymData, false );
						Value v = walk(#expr);
				
						if( ! walk.OK() || ! v.gt_zero() )
						{
							std::ostringstream error;
							error << "weight should be constant and >= 0 ("
								<< walk.error() << ")";
							throw antlr::SemanticException(error.str(), this->getFilename(),
																	 c->getLine(),
																	 c->getColumn() );
						}*/
						weight_AST = (ModestAST)astFactory.make( (new ASTArray(1)).add((ModestAST)astFactory.create(WEIGHT_AST,"::")));
						/*if( v.is_int() )
							#weight->setWeight( v.i );
						else
							#weight->setWeight( v.f );*/
						weight_AST.setLine(c.getLine());
						weight_AST.setColumn(c.getColumn());
						weight_AST.setWeight(Double.valueOf(expr_AST.getText()));
					}
					else
					{
						weight_AST = (ModestAST)astFactory.make( (new ASTArray(1)).add((ModestAST)astFactory.create(WEIGHT_AST,"::")));
						weight_AST.setWeight( (double)1 );
						weight_AST.setLine(c.getLine());
						weight_AST.setColumn(c.getColumn());
					}
				
				currentAST.root = weight_AST;
				currentAST.child = weight_AST!=null &&weight_AST.getFirstChild()!=null ?
					weight_AST.getFirstChild() : weight_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_21);
			} else {
			  throw ex;
			}
		}
		returnAST = weight_AST;
	}
	
	public final void palt_alternative() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST palt_alternative_AST = null;
		ModestAST w_AST = null;
		ModestAST asgn_AST = null;
		ModestAST seq_AST = null;
		ModestAST seq2_AST = null;
		
		try {      // for error handling
			weight();
			w_AST = (ModestAST)returnAST;
			if ( inputState.guessing==0 ) {
				palt_alternative_AST = (ModestAST)currentAST.root;
				palt_alternative_AST = w_AST;	
				currentAST.root = palt_alternative_AST;
				currentAST.child = palt_alternative_AST!=null &&palt_alternative_AST.getFirstChild()!=null ?
					palt_alternative_AST.getFirstChild() : palt_alternative_AST;
				currentAST.advanceChildToEnd();
			}
			{
			if ((LA(1)==ASSIGN_START) && (LA(2)==IDENTIFIER) && (_tokenSet_17.member(LA(3)))) {
				assignment_block();
				asgn_AST = (ModestAST)returnAST;
				if ( inputState.guessing==0 ) {
					palt_alternative_AST = (ModestAST)currentAST.root;
					palt_alternative_AST.addChild(asgn_AST);
				}
				{
				switch ( LA(1)) {
				case SEMICOLON:
				{
					match(SEMICOLON);
					sequential_processes();
					seq_AST = (ModestAST)returnAST;
					if ( inputState.guessing==0 ) {
						palt_alternative_AST = (ModestAST)currentAST.root;
						palt_alternative_AST.addChild(seq_AST);
					}
					break;
				}
				case RCURL:
				case COLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
			}
			else if ((_tokenSet_21.member(LA(1))) && (_tokenSet_33.member(LA(2))) && (_tokenSet_34.member(LA(3)))) {
				sequential_processes();
				seq2_AST = (ModestAST)returnAST;
				if ( inputState.guessing==0 ) {
					palt_alternative_AST = (ModestAST)currentAST.root;
					palt_alternative_AST.addChild(seq2_AST);
				}
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_35);
			} else {
			  throw ex;
			}
		}
		returnAST = palt_alternative_AST;
	}
	
/** Parameter list for invocation of functions or instantiation of processes
 */
	public final void arguments() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST arguments_AST = null;
		Token  arg_start = null;
		ModestAST arg_start_AST = null;
		ModestAST expr1_AST = null;
		Token  comma = null;
		ModestAST comma_AST = null;
		ModestAST expr2_AST = null;
		
			//Symbol_parameterized::const_iterator param_i;
			/*unsigned*/ int param_count = 0;
			//const Symbol_type *tp;
			String tp = "";
		
		
		try {      // for error handling
			arg_start = LT(1);
			arg_start_AST = (ModestAST)astFactory.create(arg_start);
			match(LBRACE);
			{
			switch ( LA(1)) {
			case NOT_OP:
			case PLUS:
			case MINUS:
			case LBRACE:
			case LBRACKET:
			case LCURL:
			case HASH:
			case INT:
			case FLOAT:
			case IDENTIFIER:
			{
				tp=expression();
				expr1_AST = (ModestAST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				if ( inputState.guessing==0 ) {
					
							param_count++;
							/*param_i = function->param_begin();
					
							// make sure we have something to getLine/Column from
							if( !#expr1 )
								#expr1 = #arg_start;
					
							if( param_i == function->param_end() )
							{
								std::ostringstream error;
								error << "too many parameters passed to '" << function->get_name() << "'";
								throw antlr::SemanticException(error.str(), this->getFilename(),
																	 #expr1->getLine(),
																	 #expr1->getColumn());
							}
					
					//		if( tp != (*param_i)->get_type() )
							if( !types_compatible_for_assignment( (*param_i)->get_type(), tp ) )
							{
								std::ostringstream error;
								error << "'" << function->get_name() << "' expects '"
									<< (*param_i)->get_type()->get_name() << "' parameter at position " << param_count;
								throw antlr::SemanticException(error.str(), this->getFilename(),
																	 #expr1->getLine(),
																	 #expr1->getColumn());
							}
					
							param_i++;*/
						
				}
				{
				_loop187:
				do {
					if ((LA(1)==COMMA)) {
						comma = LT(1);
						comma_AST = (ModestAST)astFactory.create(comma);
						match(COMMA);
						tp=expression();
						expr2_AST = (ModestAST)returnAST;
						astFactory.addASTChild(currentAST, returnAST);
						if ( inputState.guessing==0 ) {
							
									param_count++;
							
									// make sure we have something to getLine/Column from
									/*if( !#expr2 )
										#expr2 = #comma;
							
									if( param_i == function->param_end() )
									{
										std::ostringstream error;
										error << "too many parameters passed to '" << function->get_name() << "'";
										throw antlr::SemanticException(error.str(), this->getFilename(),
																			 #expr2->getLine(),
																			 #expr2->getColumn());
									}
							
							//		if( tp != (*param_i)->get_type() )
									if( !types_compatible_for_assignment( (*param_i)->get_type(), tp ) )
									{
										std::ostringstream error;
										error << "'" << function->get_name() << "' expects '"
											<< (*param_i)->get_type()->get_name() << "' parameter at position " << param_count;
										throw antlr::SemanticException(error.str(), this->getFilename(),
																			 #expr2->getLine(),
																			 #expr2->getColumn());
									}
							
									param_i++;*/
								
						}
					}
					else {
						break _loop187;
					}
					
				} while (true);
				}
				break;
			}
			case RBRACE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RBRACE);
			arguments_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = arguments_AST;
	}
	
	public final Symbol  parameter(
		 /*Symbol_parameterized* function,*/ String function, int cnt 
	) throws RecognitionException, TokenStreamException {
		Symbol param=null;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST parameter_AST = null;
		ModestAST type_AST = null;
		Token  id = null;
		ModestAST id_AST = null;
		
			int modifiers = MOD_NONE;
			String tp = "";
			/*Symbol_type *tp;
			Symbol *sym = 0;*/
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case MCONST:
			case MEXTERN:
			case PATIENT:
			case IMPATIENT:
			{
				modifiers=modifier();
				break;
			}
			case IDENTIFIER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			tp=qualified_type();
			type_AST = (ModestAST)returnAST;
			id = LT(1);
			id_AST = (ModestAST)astFactory.create(id);
			match(IDENTIFIER);
			if ( inputState.guessing==0 ) {
				parameter_AST = (ModestAST)currentAST.root;
				
					if( tp == "" )
					{
						//std::ostringstream error;
						String error = "invalid type in parameter " + cnt + " of '" + function + "'";
						throw new SemanticException(error, this.getFilename(),
																 id.getLine(),
																 id.getColumn());
					} else {
							param = new Symbol(id.getText(), tp);
					}
					// in the case of forward declarations we check the prototype against
					/*// what we got here..
					if( function->get_declaration_state() == Symbol_parameterized::FORWARD )
					{
						Symbol* checksym = function->get_param(cnt);
				
						if( checksym == 0 || (checksym && checksym->get_type() != tp))
						{
							std::ostringstream error;
							error << "definition does not match prototype for '" << function->get_name() << "' parameter " << cnt;
							throw antlr::SemanticException(error.str(), this->getFilename(),
																	 function->get_line(),
																	 function->get_column());
						}
						sym = checksym;
					}
					else
					{
						// in the other case we just define the mutha..
						if( modifiers & MOD_CONST )
						{
							std::ostringstream error;
							error << "const modifier supported for parameters in declaration of '" << id->getText() << "'";
							throw antlr::SemanticException(error.str(),
																	 this->getFilename(),
																	 id->getLine(), id->getColumn() );
						}
						else
						{
							sym = new Symbol(id->getText().c_str(),
												  tp,
												  this->getFilename().c_str(),
												  id->getLine(), id->getColumn(),
												  SymData->get_current_scope(),
												  SymData->get_current_namespace());
						}
						try {
							SymData->add(sym);
						}
						catch ( SymbolTableException& ex ) {
							throw antlr::SemanticException(ex.get_message(),
																	 this->getFilename(),
																	 ex.get_line(), ex.get_column() );
						}
				
						// and add it to the parameter list of the function/process
						function->add_parameter( sym );
					}*/
				
					// and add symbol to the scope it's in
					//SymData->get_current_scope()->add_symbol(sym);
				
					// add a VARIABLE_DECLARATION_AST node as top...
					parameter_AST = (ModestAST)astFactory.make( (new ASTArray(1)).add((ModestAST)astFactory.create(VARIABLE_DECLARATION_AST,id.getText())));
				/*#if 0
					// AST nodes do not have a symbol (anymore) but a symbol-reference.
					// In order to get a symbol make a symbolreference.
					if (sym)
						#parameter->setSymbolReference(sym->make_reference(this->getFilename(),id->getLine(),id->getColumn()));
					else
						#parameter->setSymbolReference(0);
				#else
					#parameter->setSymbol(sym);
				#endif*/
					parameter_AST.setLine(id.getLine());
					parameter_AST.setColumn(id.getColumn());
				
				currentAST.root = parameter_AST;
				currentAST.child = parameter_AST!=null &&parameter_AST.getFirstChild()!=null ?
					parameter_AST.getFirstChild() : parameter_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_36);
			} else {
			  throw ex;
			}
		}
		returnAST = parameter_AST;
		return param;
	}
	
	public final String  additive_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST additive_expr_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
			Token op;
			
			//System.err.println("in additive_expr"); 
		
		
		try {      // for error handling
			lhs=multiplicative_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop227:
			do {
				if ((LA(1)==PLUS||LA(1)==MINUS)) {
					op=additive_op();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						astFactory.makeASTRoot(currentAST, astFactory.create(op));
					}
					rhs=multiplicative_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
								/*if((resultType = get_resultType_for_op( op->getType(), lhs, rhs)) == 0 )
								{
									std::ostringstream error;
									error << "incompatible types in " << op->getText() << " expression";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 op->getLine(), op->getColumn() );
								}*/
						
								resultType = rhs;
								lhs = rhs;	// prev right hand becomes left hand side.
							
					}
				}
				else {
					break _loop227;
				}
				
			} while (true);
			}
			additive_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_37);
			} else {
			  throw ex;
			}
		}
		returnAST = additive_expr_AST;
		return resultType;
	}
	
	public final String  or_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST or_expr_AST = null;
		Token  op = null;
		ModestAST op_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
		
		
		try {      // for error handling
			lhs=and_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize result_type */
			}
			{
			_loop199:
			do {
				if ((LA(1)==OR_OP)) {
					op = LT(1);
					op_AST = (ModestAST)astFactory.create(op);
					astFactory.makeASTRoot(currentAST, op_AST);
					match(OR_OP);
					rhs=and_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
									/*if( (!lhs || !rhs) || (! SymData->is_bool(lhs) && !SymData->is_bool(rhs)) )
									{
										std::ostringstream error;
										error << "incompatible types in || expression";
										throw antlr::SemanticException(error.str(),
																				 this->getFilename(),
																				 op->getLine(), op->getColumn());
									}*/
						
									resultType = lhs;
									lhs = rhs;	// prev right hand becomes left hand side.
								
					}
				}
				else {
					break _loop199;
				}
				
			} while (true);
			}
			or_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_38);
			} else {
			  throw ex;
			}
		}
		returnAST = or_expr_AST;
		return resultType;
	}
	
	public final String  and_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST and_expr_AST = null;
		Token  op = null;
		ModestAST op_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
		
		
		try {      // for error handling
			lhs=bitor_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop202:
			do {
				if ((LA(1)==AND_OP)) {
					op = LT(1);
					op_AST = (ModestAST)astFactory.create(op);
					astFactory.makeASTRoot(currentAST, op_AST);
					match(AND_OP);
					rhs=bitor_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
									/*if( (!lhs || !rhs) || (! SymData->is_bool(lhs) && !SymData->is_bool(rhs)) )
									{
										std::ostringstream error;
										error << "incompatible types in && expression";
										throw antlr::SemanticException(error.str(),
																				 this->getFilename(),
																				 op->getLine(), op->getColumn());
									}*/
						
									resultType = lhs;
									lhs = rhs;	// prev right hand becomes left hand side.
								
					}
				}
				else {
					break _loop202;
				}
				
			} while (true);
			}
			and_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_39);
			} else {
			  throw ex;
			}
		}
		returnAST = and_expr_AST;
		return resultType;
	}
	
	public final String  bitor_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST bitor_expr_AST = null;
		Token  op = null;
		ModestAST op_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
		
		
		try {      // for error handling
			lhs=bitexclor_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop205:
			do {
				if ((LA(1)==BOR)) {
					op = LT(1);
					op_AST = (ModestAST)astFactory.create(op);
					astFactory.makeASTRoot(currentAST, op_AST);
					match(BOR);
					rhs=bitexclor_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
								/*if( (!lhs || !rhs) || (! SymData->is_int(lhs) && !SymData->is_int(rhs)) )
								{
									std::ostringstream error;
									error << "incompatible types in | expression";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 op->getLine(), op->getColumn());
								}*/
						
								resultType = lhs;
								lhs = rhs;	// prev right hand becomes left hand side.
							
					}
				}
				else {
					break _loop205;
				}
				
			} while (true);
			}
			bitor_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_40);
			} else {
			  throw ex;
			}
		}
		returnAST = bitor_expr_AST;
		return resultType;
	}
	
	public final String  bitexclor_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST bitexclor_expr_AST = null;
		Token  op = null;
		ModestAST op_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
		
		
		try {      // for error handling
			lhs=bitand_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop208:
			do {
				if ((LA(1)==EOR)) {
					op = LT(1);
					op_AST = (ModestAST)astFactory.create(op);
					astFactory.makeASTRoot(currentAST, op_AST);
					match(EOR);
					rhs=bitand_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
								/*if( (!lhs || !rhs) || (! SymData->is_int(lhs) && !SymData->is_int(rhs)) )
								{
									std::ostringstream error;
									error << "incompatible types in ^ expression";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 op->getLine(), op->getColumn());
								}*/
								resultType = lhs;
								lhs = rhs;	// prev right hand becomes left hand side.
							
					}
				}
				else {
					break _loop208;
				}
				
			} while (true);
			}
			bitexclor_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_41);
			} else {
			  throw ex;
			}
		}
		returnAST = bitexclor_expr_AST;
		return resultType;
	}
	
	public final String  bitand_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST bitand_expr_AST = null;
		Token  op = null;
		ModestAST op_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
		
		
		try {      // for error handling
			lhs=equality_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop211:
			do {
				if ((LA(1)==AMPERSAND)) {
					op = LT(1);
					op_AST = (ModestAST)astFactory.create(op);
					astFactory.makeASTRoot(currentAST, op_AST);
					match(AMPERSAND);
					rhs=equality_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
								/*if( (!lhs || !rhs) || (! SymData->is_int(lhs) && !SymData->is_int(rhs)) )
								{
									std::ostringstream error;
									error << "incompatible types in & expression";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 op->getLine(), op->getColumn());
								}*/
								resultType = lhs;
								lhs = rhs;	// prev right hand becomes left hand side.
							
					}
				}
				else {
					break _loop211;
				}
				
			} while (true);
			}
			bitand_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_42);
			} else {
			  throw ex;
			}
		}
		returnAST = bitand_expr_AST;
		return resultType;
	}
	
	public final String  equality_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST equality_expr_AST = null;
		ModestAST la_AST = null;
		ModestAST oa_AST = null;
		ModestAST ra_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
			Token op;
		
		
		try {      // for error handling
			lhs=relational_expr();
			la_AST = (ModestAST)returnAST;
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop215:
			do {
				if ((LA(1)==EQ_OP||LA(1)==NE_OP)) {
					op=eq_op();
					oa_AST = (ModestAST)returnAST;
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						astFactory.makeASTRoot(currentAST, astFactory.create(op));
					}
					rhs=relational_expr();
					ra_AST = (ModestAST)returnAST;
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
								/*if( ! types_compatible_for_compare(lhs,rhs) )
								{
									std::ostringstream error;
									error << "incompatible types in " << op->getText() << " expression";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 op->getLine(), op->getColumn());
								}*/
						
								resultType = "bool";//SymData->get_builtin(SymbolInformation::TP_BOOL);
								lhs = rhs;	// prev right hand becomes left hand side.
							
					}
				}
				else {
					break _loop215;
				}
				
			} while (true);
			}
			equality_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_43);
			} else {
			  throw ex;
			}
		}
		returnAST = equality_expr_AST;
		return resultType;
	}
	
	public final Token  eq_op() throws RecognitionException, TokenStreamException {
		Token tok = new Token();
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST eq_op_AST = null;
		Token  eq = null;
		ModestAST eq_AST = null;
		Token  ne = null;
		ModestAST ne_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case EQ_OP:
			{
				eq = LT(1);
				eq_AST = (ModestAST)astFactory.create(eq);
				match(EQ_OP);
				if ( inputState.guessing==0 ) {
					tok = eq;
				}
				break;
			}
			case NE_OP:
			{
				ne = LT(1);
				ne_AST = (ModestAST)astFactory.create(ne);
				match(NE_OP);
				if ( inputState.guessing==0 ) {
					tok = ne;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = eq_op_AST;
		return tok;
	}
	
	public final String  relational_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST relational_expr_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
			Token op;
		
		
		try {      // for error handling
			lhs=shift_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop219:
			do {
				if (((LA(1) >= LT_OP && LA(1) <= GE_OP))) {
					op=comp_op();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						astFactory.makeASTRoot(currentAST, astFactory.create(op));
					}
					rhs=shift_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
								/*if( ! types_compatible_for_compare(lhs,rhs) )
								{
									std::ostringstream error;
									error << "incompatible types in " << op->getText() << " expression";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 op->getLine(), op->getColumn());
								}*/
						
								resultType = "bool"; //SymData->get_builtin(SymbolInformation::TP_BOOL);
								lhs = rhs;	// prev right hand becomes left hand side.
							
					}
				}
				else {
					break _loop219;
				}
				
			} while (true);
			}
			relational_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_44);
			} else {
			  throw ex;
			}
		}
		returnAST = relational_expr_AST;
		return resultType;
	}
	
	public final Token  comp_op() throws RecognitionException, TokenStreamException {
		Token tok = new Token();
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST comp_op_AST = null;
		Token  lt = null;
		ModestAST lt_AST = null;
		Token  gt = null;
		ModestAST gt_AST = null;
		Token  ge = null;
		ModestAST ge_AST = null;
		Token  le = null;
		ModestAST le_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LT_OP:
			{
				lt = LT(1);
				lt_AST = (ModestAST)astFactory.create(lt);
				match(LT_OP);
				if ( inputState.guessing==0 ) {
					tok = lt;
				}
				break;
			}
			case GT_OP:
			{
				gt = LT(1);
				gt_AST = (ModestAST)astFactory.create(gt);
				match(GT_OP);
				if ( inputState.guessing==0 ) {
					tok = gt;
				}
				break;
			}
			case GE_OP:
			{
				ge = LT(1);
				ge_AST = (ModestAST)astFactory.create(ge);
				match(GE_OP);
				if ( inputState.guessing==0 ) {
					tok = ge;
				}
				break;
			}
			case LE_OP:
			{
				le = LT(1);
				le_AST = (ModestAST)astFactory.create(le);
				match(LE_OP);
				if ( inputState.guessing==0 ) {
					tok = le;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = comp_op_AST;
		return tok;
	}
	
	public final String  shift_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST shift_expr_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
			Token op;
		
		
		try {      // for error handling
			lhs=additive_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop223:
			do {
				if ((LA(1)==SHIFTL||LA(1)==SHIFTR)) {
					op=shift_op();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						astFactory.makeASTRoot(currentAST, astFactory.create(op));
					}
					rhs=additive_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
								/*if( (!lhs || !rhs) || (! SymData->is_int(lhs) && !SymData->is_int(rhs)) )
								{
									std::ostringstream error;
									error << "incompatible types in " << op->getText() << " expression";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 op->getLine(), op->getColumn());
								}*/
						
								resultType = lhs;
								lhs = rhs;	// prev right hand becomes left hand side.
							
					}
				}
				else {
					break _loop223;
				}
				
			} while (true);
			}
			shift_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_45);
			} else {
			  throw ex;
			}
		}
		returnAST = shift_expr_AST;
		return resultType;
	}
	
	public final Token  shift_op() throws RecognitionException, TokenStreamException {
		Token tok = new Token();
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST shift_op_AST = null;
		Token  l = null;
		ModestAST l_AST = null;
		Token  r = null;
		ModestAST r_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case SHIFTL:
			{
				l = LT(1);
				l_AST = (ModestAST)astFactory.create(l);
				match(SHIFTL);
				if ( inputState.guessing==0 ) {
					tok = l;
				}
				break;
			}
			case SHIFTR:
			{
				r = LT(1);
				r_AST = (ModestAST)astFactory.create(r);
				match(SHIFTR);
				if ( inputState.guessing==0 ) {
					tok = r;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = shift_op_AST;
		return tok;
	}
	
	public final Token  additive_op() throws RecognitionException, TokenStreamException {
		Token tok = new Token();
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST additive_op_AST = null;
		Token  p = null;
		ModestAST p_AST = null;
		Token  m = null;
		ModestAST m_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case PLUS:
			{
				p = LT(1);
				p_AST = (ModestAST)astFactory.create(p);
				match(PLUS);
				if ( inputState.guessing==0 ) {
					tok = p;
				}
				break;
			}
			case MINUS:
			{
				m = LT(1);
				m_AST = (ModestAST)astFactory.create(m);
				match(MINUS);
				if ( inputState.guessing==0 ) {
					tok = m;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = additive_op_AST;
		return tok;
	}
	
	public final String  multiplicative_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST multiplicative_expr_AST = null;
		
			//const Symbol_type *lhs = 0, *rhs = 0;
			String lhs = null, rhs = null;
			Token op;
			
			//System.err.println("in multiplicative_expr");
		
		
		try {      // for error handling
			lhs=unary_expr();
			astFactory.addASTChild(currentAST, returnAST);
			if ( inputState.guessing==0 ) {
				resultType = lhs; /* initialize resultType */
			}
			{
			_loop231:
			do {
				if (((LA(1) >= MULT && LA(1) <= MOD))) {
					op=multiplicative_op();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						astFactory.makeASTRoot(currentAST, astFactory.create(op));
					}
					rhs=unary_expr();
					astFactory.addASTChild(currentAST, returnAST);
					if ( inputState.guessing==0 ) {
						
								/*if((resultType = get_resultType_for_op( op->getType(), lhs, rhs)) == 0 )
								{
									std::ostringstream error;
									error << "incompatible types in " << op->getText() << " expression";
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 op->getLine(), op->getColumn());
								}*/
						
								resultType = lhs;
								lhs = rhs;	// prev right hand becomes left hand side.
							
					}
				}
				else {
					break _loop231;
				}
				
			} while (true);
			}
			multiplicative_expr_AST = (ModestAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_46);
			} else {
			  throw ex;
			}
		}
		returnAST = multiplicative_expr_AST;
		return resultType;
	}
	
	public final Token  multiplicative_op() throws RecognitionException, TokenStreamException {
		Token tok = new Token();
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST multiplicative_op_AST = null;
		Token  t = null;
		ModestAST t_AST = null;
		Token  d = null;
		ModestAST d_AST = null;
		Token  r = null;
		ModestAST r_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case MULT:
			{
				t = LT(1);
				t_AST = (ModestAST)astFactory.create(t);
				match(MULT);
				if ( inputState.guessing==0 ) {
					tok = t;
				}
				break;
			}
			case DIV:
			{
				d = LT(1);
				d_AST = (ModestAST)astFactory.create(d);
				match(DIV);
				if ( inputState.guessing==0 ) {
					tok = d;
				}
				break;
			}
			case MOD:
			{
				r = LT(1);
				r_AST = (ModestAST)astFactory.create(r);
				match(MOD);
				if ( inputState.guessing==0 ) {
					tok = r;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_11);
			} else {
			  throw ex;
			}
		}
		returnAST = multiplicative_op_AST;
		return tok;
	}
	
	public final String  unary_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST unary_expr_AST = null;
		Token  up = null;
		ModestAST up_AST = null;
		Token  um = null;
		ModestAST um_AST = null;
		Token  un = null;
		ModestAST un_AST = null;
		Token  uh = null;
		ModestAST uh_AST = null;
		Token  uc = null;
		ModestAST uc_AST = null;
		ModestAST expr_AST = null;
		
			//Symbol_type* cast_type = 0;
			String castType = "";
			
			//System.err.println("in unary_expr");
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case PLUS:
			{
				up = LT(1);
				up_AST = (ModestAST)astFactory.create(up);
				astFactory.makeASTRoot(currentAST, up_AST);
				match(PLUS);
				resultType=base_expr();
				astFactory.addASTChild(currentAST, returnAST);
				unary_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			case MINUS:
			{
				um = LT(1);
				um_AST = (ModestAST)astFactory.create(um);
				astFactory.makeASTRoot(currentAST, um_AST);
				match(MINUS);
				resultType=base_expr();
				astFactory.addASTChild(currentAST, returnAST);
				unary_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			case NOT_OP:
			{
				un = LT(1);
				un_AST = (ModestAST)astFactory.create(un);
				astFactory.makeASTRoot(currentAST, un_AST);
				match(NOT_OP);
				resultType=base_expr();
				astFactory.addASTChild(currentAST, returnAST);
				unary_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			case HASH:
			{
				uh = LT(1);
				uh_AST = (ModestAST)astFactory.create(uh);
				astFactory.makeASTRoot(currentAST, uh_AST);
				match(HASH);
				resultType=base_expr();
				astFactory.addASTChild(currentAST, returnAST);
				unary_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			default:
				boolean synPredMatched234 = false;
				if (((LA(1)==LBRACE) && (LA(2)==IDENTIFIER) && (LA(3)==RBRACE))) {
					int _m234 = mark();
					synPredMatched234 = true;
					inputState.guessing++;
					try {
						{
						match(LBRACE);
						qualified_type();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched234 = false;
					}
					rewind(_m234);
inputState.guessing--;
				}
				if ( synPredMatched234 ) {
					uc = LT(1);
					uc_AST = (ModestAST)astFactory.create(uc);
					match(LBRACE);
					castType=qualified_type();
					match(RBRACE);
					resultType=base_expr();
					expr_AST = (ModestAST)returnAST;
					if ( inputState.guessing==0 ) {
						unary_expr_AST = (ModestAST)currentAST.root;
						
								/*if( (resultType = get_cast_result( resultType, cast_type )) == 0 )
								{
									std::ostringstream error;
									error << "Invalid/unsupported cast from "
										<< resultType->get_name() << " to "
										<< cast_type->get_name();
									throw antlr::SemanticException(error.str(),
																			 this->getFilename(),
																			 uc->getLine(), uc->getColumn());
								}*/
								unary_expr_AST = (ModestAST)astFactory.make( (new ASTArray(2)).add((ModestAST)astFactory.create(TYPE_CAST,castType)).add(expr_AST));
								unary_expr_AST.setSymbolType(castType);
							
						currentAST.root = unary_expr_AST;
						currentAST.child = unary_expr_AST!=null &&unary_expr_AST.getFirstChild()!=null ?
							unary_expr_AST.getFirstChild() : unary_expr_AST;
						currentAST.advanceChildToEnd();
					}
				}
				else if ((_tokenSet_47.member(LA(1))) && (_tokenSet_48.member(LA(2))) && (_tokenSet_49.member(LA(3)))) {
					resultType=base_expr();
					astFactory.addASTChild(currentAST, returnAST);
					unary_expr_AST = (ModestAST)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = unary_expr_AST;
		return resultType;
	}
	
	public final String  base_expr() throws RecognitionException, TokenStreamException {
		String resultType = "";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST base_expr_AST = null;
		ModestAST set1_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case INT:
			{
				ModestAST tmp58_AST = null;
				tmp58_AST = (ModestAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp58_AST);
				match(INT);
				if ( inputState.guessing==0 ) {
					resultType = "int";
				}
				base_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			case FLOAT:
			{
				ModestAST tmp59_AST = null;
				tmp59_AST = (ModestAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp59_AST);
				match(FLOAT);
				if ( inputState.guessing==0 ) {
					resultType = "float";
				}
				base_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			case LBRACE:
			{
				match(LBRACE);
				resultType=expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RBRACE);
				base_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			case LCURL:
			{
				set();
				set1_AST = (ModestAST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				base_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			case LBRACKET:
			{
				resultType=range();
				astFactory.addASTChild(currentAST, returnAST);
				base_expr_AST = (ModestAST)currentAST.root;
				break;
			}
			default:
				boolean synPredMatched237 = false;
				if (((LA(1)==IDENTIFIER) && (LA(2)==LBRACE))) {
					int _m237 = mark();
					synPredMatched237 = true;
					inputState.guessing++;
					try {
						{
						parameterized_object();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched237 = false;
					}
					rewind(_m237);
inputState.guessing--;
				}
				if ( synPredMatched237 ) {
					resultType=parameterized_object();
					astFactory.addASTChild(currentAST, returnAST);
					base_expr_AST = (ModestAST)currentAST.root;
				}
				else {
					boolean synPredMatched239 = false;
					if (((LA(1)==IDENTIFIER) && (_tokenSet_50.member(LA(2))))) {
						int _m239 = mark();
						synPredMatched239 = true;
						inputState.guessing++;
						try {
							{
							qualified_identifier(false);
							}
						}
						catch (RecognitionException pe) {
							synPredMatched239 = false;
						}
						rewind(_m239);
inputState.guessing--;
					}
					if ( synPredMatched239 ) {
						{
						resultType=qualified_identifier(false);
						astFactory.addASTChild(currentAST, returnAST);
						}
						base_expr_AST = (ModestAST)currentAST.root;
					}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					recover(ex,_tokenSet_10);
				} else {
				  throw ex;
				}
			}
			returnAST = base_expr_AST;
			return resultType;
		}
		
	public final void set_element() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ModestAST set_element_AST = null;
		Token  i = null;
		ModestAST i_AST = null;
		ModestAST rng_AST = null;
		
			//const Symbol_type *type = 0;
			String type = null;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case INT:
			{
				i = LT(1);
				i_AST = (ModestAST)astFactory.create(i);
				astFactory.addASTChild(currentAST, i_AST);
				match(INT);
				set_element_AST = (ModestAST)currentAST.root;
				break;
			}
			case LBRACKET:
			{
				type=range();
				rng_AST = (ModestAST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				set_element_AST = (ModestAST)currentAST.root;
				break;
			}
			default:
				boolean synPredMatched247 = false;
				if (((LA(1)==IDENTIFIER) && (LA(2)==RCURL||LA(2)==COMMA) && (_tokenSet_51.member(LA(3))))) {
					int _m247 = mark();
					synPredMatched247 = true;
					inputState.guessing++;
					try {
						{
						qualified_type();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched247 = false;
					}
					rewind(_m247);
inputState.guessing--;
				}
				if ( synPredMatched247 ) {
					type=qualified_type();
					astFactory.addASTChild(currentAST, returnAST);
					set_element_AST = (ModestAST)currentAST.root;
				}
				else if ((LA(1)==IDENTIFIER) && (_tokenSet_52.member(LA(2))) && (_tokenSet_53.member(LA(3)))) {
					type=qualified_identifier(true);
					astFactory.addASTChild(currentAST, returnAST);
					set_element_AST = (ModestAST)currentAST.root;
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				recover(ex,_tokenSet_54);
			} else {
			  throw ex;
			}
		}
		returnAST = set_element_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"typedef\"",
		"\"class\"",
		"\"const\"",
		"\"extern\"",
		"\"range\"",
		"\"enum\"",
		"\"struct\"",
		"\"set\"",
		"\"patient\"",
		"\"impatient\"",
		"\"STOP\"",
		"\"ERROR\"",
		"\"forall\"",
		"\"alt\"",
		"\"palt\"",
		"\"when\"",
		"\"urgent\"",
		"\"do\"",
		"\"break\"",
		"\"if\"",
		"\"else\"",
		"\"return\"",
		"\"par\"",
		"\"try\"",
		"\"throw\"",
		"\"catch\"",
		"\"process\"",
		"\"relabel\"",
		"\"by\"",
		"\"hide\"",
		"\"expose\"",
		"\"extend\"",
		"\"rewrite\"",
		"\"prefix\"",
		"\"package\"",
		"\"import\"",
		"\"export\"",
		"\"priority\"",
		"\"defaults\"",
		"\"|\"",
		"\"&\"",
		"\"^\"",
		"\"<<\"",
		"\">>\"",
		"\"!\"",
		"\"&&\"",
		"\"||\"",
		"\"==\"",
		"\"!=\"",
		"\"<\"",
		"\">\"",
		"\"<=\"",
		"\">=\"",
		"\"+\"",
		"\"-\"",
		"\"*\"",
		"\"/\"",
		"\"%\"",
		"\"(\"",
		"\")\"",
		"\"[\"",
		"\"]\"",
		"\"{\"",
		"\"}\"",
		"\"=\"",
		"\"+=\"",
		"\"-=\"",
		"\"*=\"",
		"\"/=\"",
		"\"%=\"",
		"\">>=\"",
		"\"<<=\"",
		"\"&=\"",
		"\"^=\"",
		"\"|=\"",
		"\"{=\"",
		"\"=}\"",
		"\"..\"",
		"\".\"",
		"\",\"",
		"\"?\"",
		"\"::\"",
		"\":\"",
		"\";\"",
		"\"@\"",
		"\"#\"",
		"INT",
		"FLOAT",
		"STRING",
		"an identifier",
		"EXPONENT_PART",
		"FLOAT_SUFFIX",
		"DOT_OR_DOTDOT",
		"NUMERIC",
		"a whitespace character",
		"'C-comment'",
		"CPP_COMMENT",
		"ESCAPE",
		"SHIFTR_OR_ASGN",
		"SHIFTL_OR_ASGN",
		"INTNUMERIC",
		"HASH_OR_LINENR",
		"IDENTIFIER_AST",
		"TYPE_AST",
		"VARIABLE_DECLARATION_AST",
		"FUNCTION_DEFINITION_AST",
		"PARAMETER_LIST_AST",
		"PROCESS_DEFINITION_AST",
		"CATCH_DEFINITION_AST",
		"TYPE_DEFINITION_AST",
		"FUNCTION_CALL_AST",
		"PROCESS_INSTANTIATION_AST",
		"WEIGHT_AST",
		"GUARD_AST",
		"TYPE_CAST"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 46657335504L, 536903684L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 1073754320L, 536870912L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 15808L, 536870912L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 4611686018427400384L, 545783829L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 2L, 8L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 2L, 6291464L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 0L, 536870912L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { -9223372036854775808L, 537395210L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 46657335504L, 536903692L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { -4611976239601795070L, 553353230L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { 5044313057631666176L, 771751941L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { 9079538323755630592L, 772145157L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { 12480L, 536870912L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { 0L, 8912896L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { -9223372036837998590L, 15269898L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	private static final long[] mk_tokenSet_16() {
		long[] data = { 0L, 8912912L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
	private static final long[] mk_tokenSet_17() {
		long[] data = { 0L, 294897L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
	private static final long[] mk_tokenSet_18() {
		long[] data = { 17039362L, 551845901L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_18 = new BitSet(mk_tokenSet_18());
	private static final long[] mk_tokenSet_19() {
		long[] data = { 5044313104842649810L, 786759677L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_19 = new BitSet(mk_tokenSet_19());
	private static final long[] mk_tokenSet_20() {
		long[] data = { 16777218L, 14680072L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_20 = new BitSet(mk_tokenSet_20());
	private static final long[] mk_tokenSet_21() {
		long[] data = { 45583581184L, 536903684L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_21 = new BitSet(mk_tokenSet_21());
	private static final long[] mk_tokenSet_22() {
		long[] data = { 5044313104305778898L, 786759677L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_22 = new BitSet(mk_tokenSet_22());
	private static final long[] mk_tokenSet_23() {
		long[] data = { 5044313104842649810L, 786464781L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_23 = new BitSet(mk_tokenSet_23());
	private static final long[] mk_tokenSet_24() {
		long[] data = { 9079538370966617554L, 786759677L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_24 = new BitSet(mk_tokenSet_24());
	private static final long[] mk_tokenSet_25() {
		long[] data = { 47210983634L, 551583756L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_25 = new BitSet(mk_tokenSet_25());
	private static final long[] mk_tokenSet_26() {
		long[] data = { 16777218L, 15269896L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_26 = new BitSet(mk_tokenSet_26());
	private static final long[] mk_tokenSet_27() {
		long[] data = { 16777218L, 14942217L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_27 = new BitSet(mk_tokenSet_27());
	private static final long[] mk_tokenSet_28() {
		long[] data = { -4611976239601795070L, 553385982L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_28 = new BitSet(mk_tokenSet_28());
	private static final long[] mk_tokenSet_29() {
		long[] data = { 49878548480L, 541229062L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_29 = new BitSet(mk_tokenSet_29());
	private static final long[] mk_tokenSet_30() {
		long[] data = { 0L, 8388612L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_30 = new BitSet(mk_tokenSet_30());
	private static final long[] mk_tokenSet_31() {
		long[] data = { 0L, 2097160L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_31 = new BitSet(mk_tokenSet_31());
	private static final long[] mk_tokenSet_32() {
		long[] data = { 0L, 65536L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_32 = new BitSet(mk_tokenSet_32());
	private static final long[] mk_tokenSet_33() {
		long[] data = { 5044313104289001680L, 784662525L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_33 = new BitSet(mk_tokenSet_33());
	private static final long[] mk_tokenSet_34() {
		long[] data = { -143833662130061870L, 786759677L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_34 = new BitSet(mk_tokenSet_34());
	private static final long[] mk_tokenSet_35() {
		long[] data = { 0L, 4194312L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_35 = new BitSet(mk_tokenSet_35());
	private static final long[] mk_tokenSet_36() {
		long[] data = { -9223372036854775808L, 524288L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_36 = new BitSet(mk_tokenSet_36());
	private static final long[] mk_tokenSet_37() {
		long[] data = { -9079547069953327102L, 553353230L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_37 = new BitSet(mk_tokenSet_37());
	private static final long[] mk_tokenSet_38() {
		long[] data = { -9223372036837998590L, 16318474L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_38 = new BitSet(mk_tokenSet_38());
	private static final long[] mk_tokenSet_39() {
		long[] data = { -9222246136931155966L, 16318474L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_39 = new BitSet(mk_tokenSet_39());
	private static final long[] mk_tokenSet_40() {
		long[] data = { -9221683186977734654L, 16318474L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_40 = new BitSet(mk_tokenSet_40());
	private static final long[] mk_tokenSet_41() {
		long[] data = { -9221674390884712446L, 16318474L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_41 = new BitSet(mk_tokenSet_41());
	private static final long[] mk_tokenSet_42() {
		long[] data = { -9221639206512623614L, 16318474L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_42 = new BitSet(mk_tokenSet_42());
	private static final long[] mk_tokenSet_43() {
		long[] data = { -9221621614326579198L, 16318474L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_43 = new BitSet(mk_tokenSet_43());
	private static final long[] mk_tokenSet_44() {
		long[] data = { -9214866214885523454L, 16318474L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_44 = new BitSet(mk_tokenSet_44());
	private static final long[] mk_tokenSet_45() {
		long[] data = { -9079758226064408574L, 16318474L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_45 = new BitSet(mk_tokenSet_45());
	private static final long[] mk_tokenSet_46() {
		long[] data = { -8647201505725759486L, 553353230L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_46 = new BitSet(mk_tokenSet_46());
	private static final long[] mk_tokenSet_47() {
		long[] data = { 4611686018427387904L, 738197509L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_47 = new BitSet(mk_tokenSet_47());
	private static final long[] mk_tokenSet_48() {
		long[] data = { -8746197696510L, 788496399L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_48 = new BitSet(mk_tokenSet_48());
	private static final long[] mk_tokenSet_49() {
		long[] data = { -8744587071278L, 788529151L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_49 = new BitSet(mk_tokenSet_49());
	private static final long[] mk_tokenSet_50() {
		long[] data = { -4611976239601795070L, 553615375L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_50 = new BitSet(mk_tokenSet_50());
	private static final long[] mk_tokenSet_51() {
		long[] data = { -4611976239601795070L, 620462095L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_51 = new BitSet(mk_tokenSet_51());
	private static final long[] mk_tokenSet_52() {
		long[] data = { 0L, 786441L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_52 = new BitSet(mk_tokenSet_52());
	private static final long[] mk_tokenSet_53() {
		long[] data = { -8746197696510L, 788234255L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_53 = new BitSet(mk_tokenSet_53());
	private static final long[] mk_tokenSet_54() {
		long[] data = { 0L, 524296L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_54 = new BitSet(mk_tokenSet_54());
	
	}
