// $ANTLR 2.7.7 (20061129): "simulationTreeWalker.g" -> "ModestSimulationTreeWalker.java"$

package modesteditor.core.antlrparser;

import modesteditor.core.ModestEditor;
import modesteditor.core.stepsimulation.*;
    
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream; 
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.jface.text.IDocument; 
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.Region;

import antlr.CommonAST;  
import antlr.RecognitionException;

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


public class ModestSimulationTreeWalker extends antlr.TreeParser       implements ModestSimulationTreeWalkerTokenTypes
 {
 //Additional Methods
	protected String errorMessage = "no error message";
	protected boolean valid = true;
	protected HashMap<String, ModestAST> processMap = new HashMap<String, ModestAST>();
	//private ModestSimulationTreeWalker bodyWalker = new ModestSimulationTreeWalker();
	
	private String processName = null;
	private int line = 0;
	private int column = 0;
	
	public boolean OK() {
		return valid;
	}
	
	public String error() {
		return errorMessage;
	}
	
	public void setProcessMap(HashMap<String, ModestAST> processMap){
		this.processMap = processMap;
	}
	
	public ModestSimulationTreeWalker(String processName, int line, int column) {
		this();
		this.processName = processName;
		this.line = line;
		this.column = column;
	}
public ModestSimulationTreeWalker() {
	tokenNames = _tokenNames;
}

	public final SimulationNode  start(AST _t) throws RecognitionException {
		SimulationNode start = new SequentialProcess(0,0,null);
		
		ModestAST start_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case DEFAULTS:
			{
				AST __t3 = _t;
				ModestAST tmp1_AST_in = (ModestAST)_t;
				match(_t,DEFAULTS);
				_t = _t.getFirstChild();
				{
				_loop5:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==ASSIGN)) {
						ModestAST tmp2_AST_in = (ModestAST)_t;
						match(_t,ASSIGN);
						_t = _t.getNextSibling();
						ModestAST tmp3_AST_in = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getNextSibling();
						ModestAST tmp4_AST_in = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getNextSibling();
					}
					else {
						break _loop5;
					}
					
				} while (true);
				}
				_t = __t3;
				_t = _t.getNextSibling();
				break;
			}
			case STOP:
			case ALT:
			case DO:
			case BREAK:
			case PAR:
			case TRY:
			case THROW:
			case RELABEL:
			case HIDE:
			case EXTEND:
			case ASSIGN:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case MULT_ASSIGN:
			case DIV_ASSIGN:
			case MOD_ASSIGN:
			case SR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			case IDENTIFIER:
			case VARIABLE_DECLARATION_AST:
			case PROCESS_DEFINITION_AST:
			case TYPE_DEFINITION_AST:
			case PROCESS_INSTANTIATION_AST:
			case GUARD_AST:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			{
			start=description(_t,null);
			_t = _retTree;
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						errorMessage = "start " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return start;
	}
	
	public final SimulationNode  description(AST _t,
		SimulationNode parent
	) throws RecognitionException {
		SimulationNode des = null;
		
		ModestAST description_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			{
			_loop9:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==VARIABLE_DECLARATION_AST||_t.getType()==PROCESS_DEFINITION_AST||_t.getType()==TYPE_DEFINITION_AST)) {
					declarative_stmnt(_t);
					_t = _retTree;
				}
				else {
					break _loop9;
				}
				
			} while (true);
			}
			des=seq_process(_t, parent, "" );
			_t = _retTree;
			if ( inputState.guessing==0 ) {
				if (processName != null) ((SequentialProcess)des).setHighlightInfos(processName, line, column);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#description_in);*/
				
						errorMessage = "description " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return des;
	}
	
	public final void declarative_stmnt(AST _t) throws RecognitionException {
		
		ModestAST declarative_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST p = null;
		ModestAST d = null;
		
			Symbol exp = new Symbol("","");
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PROCESS_DEFINITION_AST:
			{
				AST __t11 = _t;
				p = _t==ASTNULL ? null :(ModestAST)_t;
				match(_t,PROCESS_DEFINITION_AST);
				_t = _t.getFirstChild();
				param_definition(_t);
				_t = _retTree;
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case STOP:
				case ALT:
				case DO:
				case BREAK:
				case PAR:
				case TRY:
				case THROW:
				case RELABEL:
				case HIDE:
				case EXTEND:
				case ASSIGN:
				case PLUS_ASSIGN:
				case MINUS_ASSIGN:
				case MULT_ASSIGN:
				case DIV_ASSIGN:
				case MOD_ASSIGN:
				case SR_ASSIGN:
				case SL_ASSIGN:
				case BAND_ASSIGN:
				case BXOR_ASSIGN:
				case BOR_ASSIGN:
				case IDENTIFIER:
				case VARIABLE_DECLARATION_AST:
				case PROCESS_DEFINITION_AST:
				case TYPE_DEFINITION_AST:
				case PROCESS_INSTANTIATION_AST:
				case GUARD_AST:
				{
					d = _t==ASTNULL ? null : (ModestAST)_t;
					description(_t,null);
					_t = _retTree;
					if ( inputState.guessing==0 ) {
						processMap.put(p.getProcName(), d);
					}
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t11;
				_t = _t.getNextSibling();
				break;
			}
			case TYPE_DEFINITION_AST:
			{
				ModestAST tmp5_AST_in = (ModestAST)_t;
				match(_t,TYPE_DEFINITION_AST);
				_t = _t.getNextSibling();
				break;
			}
			case VARIABLE_DECLARATION_AST:
			{
				AST __t13 = _t;
				ModestAST tmp6_AST_in = (ModestAST)_t;
				match(_t,VARIABLE_DECLARATION_AST);
				_t = _t.getFirstChild();
				{
				int _cnt19=0;
				_loop19:
				do {
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case TYPE_AST:
					{
						AST __t15 = _t;
						ModestAST tmp7_AST_in = (ModestAST)_t;
						match(_t,TYPE_AST);
						_t = _t.getFirstChild();
						{
						int _cnt17=0;
						_loop17:
						do {
							if (_t==null) _t=ASTNULL;
							if ((_t.getType()==IDENTIFIER)) {
								ModestAST tmp8_AST_in = (ModestAST)_t;
								match(_t,IDENTIFIER);
								_t = _t.getNextSibling();
							}
							else {
								if ( _cnt17>=1 ) { break _loop17; } else {throw new NoViableAltException(_t);}
							}
							
							_cnt17++;
						} while (true);
						}
						_t = __t15;
						_t = _t.getNextSibling();
						break;
					}
					case ASSIGN:
					{
						AST __t18 = _t;
						ModestAST tmp9_AST_in = (ModestAST)_t;
						match(_t,ASSIGN);
						_t = _t.getFirstChild();
						ModestAST tmp10_AST_in = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getNextSibling();
						exp=expression(_t);
						_t = _retTree;
						_t = __t18;
						_t = _t.getNextSibling();
						break;
					}
					default:
					{
						if ( _cnt19>=1 ) { break _loop19; } else {throw new NoViableAltException(_t);}
					}
					}
					_cnt19++;
				} while (true);
				}
				_t = __t13;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#declarative_stmnt_in);*/
				
						errorMessage = "declarative_stmnt " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final SimulationNode  seq_process(AST _t,
		SimulationNode parent, String guard
	) throws RecognitionException {
		SimulationNode proc = new SequentialProcess(0,0,parent);
		
		ModestAST seq_process_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			local_process(_t,proc, guard);
			_t = _retTree;
			{
			_loop26:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					local_process(_t,proc, "");
					_t = _retTree;
				}
				else {
					break _loop26;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#seq_process_in);*/
				
						errorMessage = "seq_process " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return proc;
	}
	
	public final void param_definition(AST _t) throws RecognitionException {
		
		ModestAST param_definition_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t21 = _t;
			ModestAST tmp11_AST_in = (ModestAST)_t;
			match(_t,PARAMETER_LIST_AST);
			_t = _t.getFirstChild();
			{
			_loop23:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==VARIABLE_DECLARATION_AST)) {
					ModestAST tmp12_AST_in = (ModestAST)_t;
					match(_t,VARIABLE_DECLARATION_AST);
					_t = _t.getNextSibling();
				}
				else {
					break _loop23;
				}
				
			} while (true);
			}
			_t = __t21;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#param_definition_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final Symbol  expression(AST _t) throws RecognitionException {
		Symbol exp = new Symbol("","");
		
		ModestAST expression_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST i = null;
		ModestAST f = null;
		ModestAST tp = null;
		ModestAST fc = null;
		ModestAST ide = null;
		ModestAST id = null;
		
			Symbol e1 = new Symbol("","");
			Symbol e2 = new Symbol("","");
			Symbol e3 = new Symbol("","");
		
		
		try {      // for error handling
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case MULT:
			{
				AST __t98 = _t;
				ModestAST tmp13_AST_in = (ModestAST)_t;
				match(_t,MULT);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" * "+e2.getName(),e1.getType());
				}
				_t = __t98;
				_t = _t.getNextSibling();
				break;
			}
			case DIV:
			{
				AST __t99 = _t;
				ModestAST tmp14_AST_in = (ModestAST)_t;
				match(_t,DIV);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" / "+e2.getName(),e1.getType());
				}
				_t = __t99;
				_t = _t.getNextSibling();
				break;
			}
			case MOD:
			{
				AST __t100 = _t;
				ModestAST tmp15_AST_in = (ModestAST)_t;
				match(_t,MOD);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" % "+e2.getName(),e1.getType());
				}
				_t = __t100;
				_t = _t.getNextSibling();
				break;
			}
			case AMPERSAND:
			{
				AST __t101 = _t;
				ModestAST tmp16_AST_in = (ModestAST)_t;
				match(_t,AMPERSAND);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" & "+e2.getName(),e1.getType());
				}
				_t = __t101;
				_t = _t.getNextSibling();
				break;
			}
			case BOR:
			{
				AST __t102 = _t;
				ModestAST tmp17_AST_in = (ModestAST)_t;
				match(_t,BOR);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" | "+e2.getName(),e1.getType());
				}
				_t = __t102;
				_t = _t.getNextSibling();
				break;
			}
			case EOR:
			{
				AST __t103 = _t;
				ModestAST tmp18_AST_in = (ModestAST)_t;
				match(_t,EOR);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" ^ "+e2.getName(),e1.getType());
				}
				_t = __t103;
				_t = _t.getNextSibling();
				break;
			}
			case SHIFTL:
			{
				AST __t104 = _t;
				ModestAST tmp19_AST_in = (ModestAST)_t;
				match(_t,SHIFTL);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" << "+e2.getName(),e1.getType());
				}
				_t = __t104;
				_t = _t.getNextSibling();
				break;
			}
			case SHIFTR:
			{
				AST __t105 = _t;
				ModestAST tmp20_AST_in = (ModestAST)_t;
				match(_t,SHIFTR);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" >> "+e2.getName(),e1.getType());
				}
				_t = __t105;
				_t = _t.getNextSibling();
				break;
			}
			case LT_OP:
			{
				AST __t106 = _t;
				ModestAST tmp21_AST_in = (ModestAST)_t;
				match(_t,LT_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" < "+e2.getName(),e1.getType());
				}
				_t = __t106;
				_t = _t.getNextSibling();
				break;
			}
			case GT_OP:
			{
				AST __t107 = _t;
				ModestAST tmp22_AST_in = (ModestAST)_t;
				match(_t,GT_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" > "+e2.getName(),e1.getType());
				}
				_t = __t107;
				_t = _t.getNextSibling();
				break;
			}
			case LE_OP:
			{
				AST __t108 = _t;
				ModestAST tmp23_AST_in = (ModestAST)_t;
				match(_t,LE_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" <= "+e2.getName(),e1.getType());
				}
				_t = __t108;
				_t = _t.getNextSibling();
				break;
			}
			case GE_OP:
			{
				AST __t109 = _t;
				ModestAST tmp24_AST_in = (ModestAST)_t;
				match(_t,GE_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" >= "+e2.getName(),e1.getType());
				}
				_t = __t109;
				_t = _t.getNextSibling();
				break;
			}
			case EQ_OP:
			{
				AST __t110 = _t;
				ModestAST tmp25_AST_in = (ModestAST)_t;
				match(_t,EQ_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" == "+e2.getName(),e1.getType());
				}
				_t = __t110;
				_t = _t.getNextSibling();
				break;
			}
			case NE_OP:
			{
				AST __t111 = _t;
				ModestAST tmp26_AST_in = (ModestAST)_t;
				match(_t,NE_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" != "+e2.getName(),e1.getType());
				}
				_t = __t111;
				_t = _t.getNextSibling();
				break;
			}
			case AND_OP:
			{
				AST __t112 = _t;
				ModestAST tmp27_AST_in = (ModestAST)_t;
				match(_t,AND_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" && "+e2.getName(),e1.getType());
				}
				_t = __t112;
				_t = _t.getNextSibling();
				break;
			}
			case OR_OP:
			{
				AST __t113 = _t;
				ModestAST tmp28_AST_in = (ModestAST)_t;
				match(_t,OR_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" || "+e2.getName(),e1.getType());
				}
				_t = __t113;
				_t = _t.getNextSibling();
				break;
			}
			case NOT_OP:
			{
				AST __t116 = _t;
				ModestAST tmp29_AST_in = (ModestAST)_t;
				match(_t,NOT_OP);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(" !"+e1.getName(),e1.getType());
				}
				_t = __t116;
				_t = _t.getNextSibling();
				break;
			}
			case HASH:
			{
				AST __t117 = _t;
				ModestAST tmp30_AST_in = (ModestAST)_t;
				match(_t,HASH);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(" #"+e1.getName(),e1.getType());
				}
				_t = __t117;
				_t = _t.getNextSibling();
				break;
			}
			case QUESTION:
			{
				AST __t118 = _t;
				ModestAST tmp31_AST_in = (ModestAST)_t;
				match(_t,QUESTION);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				e3=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+" ? "+e2.getName()+" : "+e3.getName(), e2.getType());
				}
				_t = __t118;
				_t = _t.getNextSibling();
				break;
			}
			case INT:
			{
				i = (ModestAST)_t;
				match(_t,INT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					exp = new Symbol(i.getText(), "int");
				}
				break;
			}
			case FLOAT:
			{
				f = (ModestAST)_t;
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					exp = new Symbol(f.getText(),"float");
				}
				break;
			}
			case TYPE_AST:
			{
				tp = (ModestAST)_t;
				match(_t,TYPE_AST);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					exp = new Symbol(tp.getText(), tp.getText());
				}
				break;
			}
			case FUNCTION_CALL_AST:
			{
				AST __t119 = _t;
				fc = _t==ASTNULL ? null :(ModestAST)_t;
				match(_t,FUNCTION_CALL_AST);
				_t = _t.getFirstChild();
				{
				_loop121:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_1.member(_t.getType()))) {
						expression(_t);
						_t = _retTree;
					}
					else {
						break _loop121;
					}
					
				} while (true);
				}
				_t = __t119;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					exp = new Symbol(fc.getText(), "float");
				}
				break;
			}
			case LBRACKET:
			{
				AST __t122 = _t;
				ModestAST tmp32_AST_in = (ModestAST)_t;
				match(_t,LBRACKET);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				e2=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+"["+e2.getName()+"]",e1.getType());
				}
				_t = __t122;
				_t = _t.getNextSibling();
				break;
			}
			case DOT:
			{
				AST __t123 = _t;
				ModestAST tmp33_AST_in = (ModestAST)_t;
				match(_t,DOT);
				_t = _t.getFirstChild();
				e1=expression(_t);
				_t = _retTree;
				ide = (ModestAST)_t;
				match(_t,IDENTIFIER);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					exp = new Symbol(e1.getName()+"."+ide.getText(),e1.getType());
				}
				_t = __t123;
				_t = _t.getNextSibling();
				break;
			}
			case IDENTIFIER:
			{
				id = (ModestAST)_t;
				match(_t,IDENTIFIER);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					exp = new Symbol(id.getText(),"");
				}
				break;
			}
			case LCURL:
			{
				set(_t);
				_t = _retTree;
				break;
			}
			default:
				boolean synPredMatched92 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==PLUS))) {
					AST __t92 = _t;
					synPredMatched92 = true;
					inputState.guessing++;
					try {
						{
						AST __t91 = _t;
						ModestAST tmp34_AST_in = (ModestAST)_t;
						match(_t,PLUS);
						_t = _t.getFirstChild();
						expression(_t);
						_t = _retTree;
						expression(_t);
						_t = _retTree;
						_t = __t91;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched92 = false;
					}
					_t = __t92;
inputState.guessing--;
				}
				if ( synPredMatched92 ) {
					AST __t93 = _t;
					ModestAST tmp35_AST_in = (ModestAST)_t;
					match(_t,PLUS);
					_t = _t.getFirstChild();
					e1=expression(_t);
					_t = _retTree;
					e2=expression(_t);
					_t = _retTree;
					if ( inputState.guessing==0 ) {
						exp = new Symbol(e1.getName()+" + "+e2.getName(),e1.getType());
					}
					_t = __t93;
					_t = _t.getNextSibling();
				}
				else {
					boolean synPredMatched96 = false;
					if (_t==null) _t=ASTNULL;
					if (((_t.getType()==MINUS))) {
						AST __t96 = _t;
						synPredMatched96 = true;
						inputState.guessing++;
						try {
							{
							AST __t95 = _t;
							ModestAST tmp36_AST_in = (ModestAST)_t;
							match(_t,MINUS);
							_t = _t.getFirstChild();
							expression(_t);
							_t = _retTree;
							expression(_t);
							_t = _retTree;
							_t = __t95;
							_t = _t.getNextSibling();
							}
						}
						catch (RecognitionException pe) {
							synPredMatched96 = false;
						}
						_t = __t96;
inputState.guessing--;
					}
					if ( synPredMatched96 ) {
						AST __t97 = _t;
						ModestAST tmp37_AST_in = (ModestAST)_t;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						e1=expression(_t);
						_t = _retTree;
						e2=expression(_t);
						_t = _retTree;
						if ( inputState.guessing==0 ) {
							exp = new Symbol(e1.getName()+" - "+e2.getName(),e1.getType());
						}
						_t = __t97;
						_t = _t.getNextSibling();
					}
					else if ((_t.getType()==PLUS)) {
						AST __t114 = _t;
						ModestAST tmp38_AST_in = (ModestAST)_t;
						match(_t,PLUS);
						_t = _t.getFirstChild();
						e1=expression(_t);
						_t = _retTree;
						if ( inputState.guessing==0 ) {
							exp = new Symbol(" +"+e1.getName(),e1.getType());
						}
						_t = __t114;
						_t = _t.getNextSibling();
					}
					else if ((_t.getType()==MINUS)) {
						AST __t115 = _t;
						ModestAST tmp39_AST_in = (ModestAST)_t;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						e1=expression(_t);
						_t = _retTree;
						if ( inputState.guessing==0 ) {
							exp = new Symbol(" -"+e1.getName(),e1.getType());
						}
						_t = __t115;
						_t = _t.getNextSibling();
					}
				else {
					throw new NoViableAltException(_t);
				}
				}}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					
							/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
							pr.pr_tree(#expression_in);*/
					
							errorMessage = "expression " + ex.getMessage();
							this.valid = false;
						
				} else {
					throw ex;
				}
			}
			_retTree = _t;
			return exp;
		}
		
	public final void local_process(AST _t,
		SimulationNode parent, String guard
	) throws RecognitionException {
		
		ModestAST local_process_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST s = null;
		ModestAST b = null;
		ModestAST th = null;
		ModestAST iden = null;
		ModestAST t = null;
		ModestAST ide = null;
		ModestAST idhi = null;
		ModestAST idex = null;
		ModestAST idre = null;
		ModestAST idby = null;
		ModestAST p = null;
		ModestAST id = null;
		ModestAST i = null;
		
			//{ System.err.println("in SimTW local_process");}
			SimulationNode proc = null;
			Symbol exp = new Symbol("","");
			SimulationNode catchTmp;
			ArrayList<String> labelExtension = new ArrayList<String>();
			ArrayList<String> relabel = new ArrayList<String>();
			ArrayList<String> labelby = new ArrayList<String>();
		
		
		try {      // for error handling
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case STOP:
			{
				s = (ModestAST)_t;
				match(_t,STOP);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					proc = new ActionNode("stop", s.getLine(), s.getColumn(), parent, guard);
				}
				break;
			}
			case BREAK:
			{
				b = (ModestAST)_t;
				match(_t,BREAK);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					proc = new BreakNode(b.getLine(), b.getColumn(), parent, guard);
				}
				break;
			}
			case THROW:
			{
				AST __t29 = _t;
				th = _t==ASTNULL ? null :(ModestAST)_t;
				match(_t,THROW);
				_t = _t.getFirstChild();
				iden = (ModestAST)_t;
				match(_t,IDENTIFIER);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					proc = new ThrowNode(th.getLine(), th.getColumn(), iden.getText(), parent, guard);
				}
				_t = __t29;
				_t = _t.getNextSibling();
				break;
			}
			case TRY:
			{
				AST __t30 = _t;
				t = _t==ASTNULL ? null :(ModestAST)_t;
				match(_t,TRY);
				_t = _t.getFirstChild();
				if ( inputState.guessing==0 ) {
					proc = new TryNode(t.getLine(), t.getColumn(), parent, guard);
				}
				description(_t,proc);
				_t = _retTree;
				{
				int _cnt33=0;
				_loop33:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==CATCH_DEFINITION_AST)) {
						AST __t32 = _t;
						ModestAST tmp40_AST_in = (ModestAST)_t;
						match(_t,CATCH_DEFINITION_AST);
						_t = _t.getFirstChild();
						ide = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getNextSibling();
						catchTmp=description(_t,null);
						_t = _retTree;
						if ( inputState.guessing==0 ) {
							((TryNode)proc).addCatch(catchTmp, ide.getText());
						}
						_t = __t32;
						_t = _t.getNextSibling();
					}
					else {
						if ( _cnt33>=1 ) { break _loop33; } else {throw new NoViableAltException(_t);}
					}
					
					_cnt33++;
				} while (true);
				}
				_t = __t30;
				_t = _t.getNextSibling();
				break;
			}
			case HIDE:
			{
				AST __t34 = _t;
				ModestAST tmp41_AST_in = (ModestAST)_t;
				match(_t,HIDE);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case IDENTIFIER:
				{
					idhi = (ModestAST)_t;
					match(_t,IDENTIFIER);
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						labelExtension.add(idhi.getText());
					}
					break;
				}
				case LCURL:
				{
					labelExtension=set(_t);
					_t = _retTree;
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				proc=seq_process(_t,parent, guard);
				_t = _retTree;
				_t = __t34;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					((SequentialProcess)proc).hideAlphabet(labelExtension);
				}
				break;
			}
			case EXTEND:
			{
				AST __t36 = _t;
				ModestAST tmp42_AST_in = (ModestAST)_t;
				match(_t,EXTEND);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case IDENTIFIER:
				{
					idex = (ModestAST)_t;
					match(_t,IDENTIFIER);
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						labelExtension.add(idex.getText());
					}
					break;
				}
				case LCURL:
				{
					labelExtension=set(_t);
					_t = _retTree;
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				proc=seq_process(_t,parent, guard);
				_t = _retTree;
				_t = __t36;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					((SequentialProcess)proc).extendAlphabet(labelExtension);
				}
				break;
			}
			case RELABEL:
			{
				AST __t38 = _t;
				ModestAST tmp43_AST_in = (ModestAST)_t;
				match(_t,RELABEL);
				_t = _t.getFirstChild();
				{
				AST __t40 = _t;
				ModestAST tmp44_AST_in = (ModestAST)_t;
				match(_t,BY);
				_t = _t.getFirstChild();
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case IDENTIFIER:
				{
					idre = (ModestAST)_t;
					match(_t,IDENTIFIER);
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						relabel.add(idre.getText());
					}
					break;
				}
				case LCURL:
				{
					relabel=set(_t);
					_t = _retTree;
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case IDENTIFIER:
				{
					idby = (ModestAST)_t;
					match(_t,IDENTIFIER);
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						labelby.add(idby.getText());
					}
					break;
				}
				case LCURL:
				{
					labelby=set(_t);
					_t = _retTree;
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t40;
				_t = _t.getNextSibling();
				}
				proc=seq_process(_t,parent, guard);
				_t = _retTree;
				_t = __t38;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					if (relabel.size() != labelby.size()) {
							errorMessage = "size of relabel statements doesn't match";
							this.valid = false;
						  } else		
							((SequentialProcess)proc).addRelabeling(relabel, labelby);
				}
				break;
			}
			case GUARD_AST:
			{
				AST __t43 = _t;
				ModestAST tmp45_AST_in = (ModestAST)_t;
				match(_t,GUARD_AST);
				_t = _t.getFirstChild();
				exp=expression(_t);
				_t = _retTree;
				seq_process(_t,parent, exp.getName());
				_t = _retTree;
				_t = __t43;
				_t = _t.getNextSibling();
				break;
			}
			case ALT:
			{
				alt_stmnt(_t,parent, guard);
				_t = _retTree;
				break;
			}
			case PAR:
			{
				par_stmnt(_t,parent, guard);
				_t = _retTree;
				break;
			}
			case DO:
			{
				do_stmnt(_t,parent, guard);
				_t = _retTree;
				break;
			}
			case PROCESS_INSTANTIATION_AST:
			{
				AST __t44 = _t;
				p = _t==ASTNULL ? null :(ModestAST)_t;
				match(_t,PROCESS_INSTANTIATION_AST);
				_t = _t.getFirstChild();
				{
				_loop46:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_1.member(_t.getType()))) {
						expression(_t);
						_t = _retTree;
					}
					else {
						break _loop46;
					}
					
				} while (true);
				}
				_t = __t44;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						
							ModestSimulationTreeWalker bodyWalker = new ModestSimulationTreeWalker(p.getText(), p.getLine(), p.getColumn());
							bodyWalker.setProcessMap(processMap);
							bodyWalker.description(processMap.get(p.getText()), parent); 
						
				}
				break;
			}
			case ASSIGN:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case MULT_ASSIGN:
			case DIV_ASSIGN:
			case MOD_ASSIGN:
			case SR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			{
				assignment(_t,parent, guard);
				_t = _retTree;
				break;
			}
			default:
				boolean synPredMatched49 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==IDENTIFIER))) {
					AST __t49 = _t;
					synPredMatched49 = true;
					inputState.guessing++;
					try {
						{
						AST __t48 = _t;
						id = _t==ASTNULL ? null :(ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getFirstChild();
						ModestAST tmp46_AST_in = (ModestAST)_t;
						match(_t,PALT);
						_t = _t.getNextSibling();
						_t = __t48;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched49 = false;
					}
					_t = __t49;
inputState.guessing--;
				}
				if ( synPredMatched49 ) {
					palt_stmnt(_t,parent, guard);
					_t = _retTree;
				}
				else if ((_t.getType()==IDENTIFIER)) {
					i = (ModestAST)_t;
					match(_t,IDENTIFIER);
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						proc = new ActionNode(i.getText(), i.getLine(), i.getColumn(), parent, guard);
					}
				}
			else {
				throw new NoViableAltException(_t);
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#local_process_in);*/
				
						errorMessage = "local_process " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final ArrayList<String>  set(AST _t) throws RecognitionException {
		ArrayList<String> elems = new ArrayList<String>();
		
		ModestAST set_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		String el;
		
		try {      // for error handling
			AST __t127 = _t;
			ModestAST tmp47_AST_in = (ModestAST)_t;
			match(_t,LCURL);
			_t = _t.getFirstChild();
			{
			int _cnt129=0;
			_loop129:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_2.member(_t.getType()))) {
					el=set_element(_t);
					_t = _retTree;
					if ( inputState.guessing==0 ) {
						elems.add(el);
					}
				}
				else {
					if ( _cnt129>=1 ) { break _loop129; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt129++;
			} while (true);
			}
			_t = __t127;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#set_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return elems;
	}
	
	public final void alt_stmnt(AST _t,
		SimulationNode parent, String guard
	) throws RecognitionException {
		
		ModestAST alt_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST a = null;
		ModestAST d = null;
		
			SimulationNode alt = null;
			SimulationNode alternative = null;
			SimulationNode s;
		
		
		try {      // for error handling
			AST __t51 = _t;
			a = _t==ASTNULL ? null :(ModestAST)_t;
			match(_t,ALT);
			_t = _t.getFirstChild();
			if ( inputState.guessing==0 ) {
				alt = new AltNode(a.getLine(), a.getColumn(), parent);
			}
			{
			int _cnt54=0;
			_loop54:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==DCOLON)) {
					AST __t53 = _t;
					d = _t==ASTNULL ? null :(ModestAST)_t;
					match(_t,DCOLON);
					_t = _t.getFirstChild();
					if ( inputState.guessing==0 ) {
						alternative = new Alternative(d.getLine(), d.getColumn(), alt);
					}
					s=seq_process(_t,alternative, guard);
					_t = _retTree;
					_t = __t53;
					_t = _t.getNextSibling();
				}
				else {
					if ( _cnt54>=1 ) { break _loop54; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt54++;
			} while (true);
			}
			_t = __t51;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#alt_stmnt_in);*/
				
						errorMessage = "alt_stmnt " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void par_stmnt(AST _t,
		SimulationNode parent, String guard
	) throws RecognitionException {
		
		ModestAST par_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST p = null;
		ModestAST d = null;
		
			SimulationNode par = null;
			SimulationNode alternative = null;
			SimulationNode s;
		
		
		try {      // for error handling
			AST __t56 = _t;
			p = _t==ASTNULL ? null :(ModestAST)_t;
			match(_t,PAR);
			_t = _t.getFirstChild();
			if ( inputState.guessing==0 ) {
				par = new ParNode(p.getLine(), p.getColumn(), parent);
			}
			{
			int _cnt59=0;
			_loop59:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==DCOLON)) {
					AST __t58 = _t;
					d = _t==ASTNULL ? null :(ModestAST)_t;
					match(_t,DCOLON);
					_t = _t.getFirstChild();
					if ( inputState.guessing==0 ) {
						alternative = new Alternative(d.getLine(), d.getColumn(), par);
					}
					s=seq_process(_t,alternative, guard);
					_t = _retTree;
					_t = __t58;
					_t = _t.getNextSibling();
				}
				else {
					if ( _cnt59>=1 ) { break _loop59; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt59++;
			} while (true);
			}
			_t = __t56;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#par_stmnt_in);*/
				
						errorMessage = "par_stmnt " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void do_stmnt(AST _t,
		SimulationNode parent, String guard
	) throws RecognitionException {
		
		ModestAST do_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST dn = null;
		ModestAST d = null;
		
			SimulationNode doNode = null;
			SimulationNode alternative = null;
			SimulationNode s;
		
		
		try {      // for error handling
			AST __t61 = _t;
			dn = _t==ASTNULL ? null :(ModestAST)_t;
			match(_t,DO);
			_t = _t.getFirstChild();
			if ( inputState.guessing==0 ) {
				doNode = new DoNode(dn.getLine(), dn.getColumn(), parent);
			}
			{
			int _cnt64=0;
			_loop64:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==DCOLON)) {
					AST __t63 = _t;
					d = _t==ASTNULL ? null :(ModestAST)_t;
					match(_t,DCOLON);
					_t = _t.getFirstChild();
					if ( inputState.guessing==0 ) {
						alternative = new Alternative(d.getLine(), d.getColumn(), doNode);
					}
					s=seq_process(_t,alternative, guard);
					_t = _retTree;
					_t = __t63;
					_t = _t.getNextSibling();
				}
				else {
					if ( _cnt64>=1 ) { break _loop64; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt64++;
			} while (true);
			}
			_t = __t61;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#do_stmnt_in);*/
				
						errorMessage = "do_stmnt " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final Symbol  assignment(AST _t,
		SimulationNode parent, String guard
	) throws RecognitionException {
		Symbol assi = new Symbol("","");
		
		ModestAST assignment_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
			Symbol lhs;
			Symbol rhs;
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ASSIGN:
			{
				AST __t77 = _t;
				ModestAST tmp48_AST_in = (ModestAST)_t;
				match(_t,ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" = "+rhs.getName(), lhs.getType());
				}
				_t = __t77;
				_t = _t.getNextSibling();
				break;
			}
			case PLUS_ASSIGN:
			{
				AST __t78 = _t;
				ModestAST tmp49_AST_in = (ModestAST)_t;
				match(_t,PLUS_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" += "+rhs.getName(), lhs.getType());
				}
				_t = __t78;
				_t = _t.getNextSibling();
				break;
			}
			case MINUS_ASSIGN:
			{
				AST __t79 = _t;
				ModestAST tmp50_AST_in = (ModestAST)_t;
				match(_t,MINUS_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" -= "+rhs.getName(), lhs.getType());
				}
				_t = __t79;
				_t = _t.getNextSibling();
				break;
			}
			case MULT_ASSIGN:
			{
				AST __t80 = _t;
				ModestAST tmp51_AST_in = (ModestAST)_t;
				match(_t,MULT_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" *= "+rhs.getName(), lhs.getType());
				}
				_t = __t80;
				_t = _t.getNextSibling();
				break;
			}
			case DIV_ASSIGN:
			{
				AST __t81 = _t;
				ModestAST tmp52_AST_in = (ModestAST)_t;
				match(_t,DIV_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" /= "+rhs.getName(), lhs.getType());
				}
				_t = __t81;
				_t = _t.getNextSibling();
				break;
			}
			case MOD_ASSIGN:
			{
				AST __t82 = _t;
				ModestAST tmp53_AST_in = (ModestAST)_t;
				match(_t,MOD_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" %= "+rhs.getName(), lhs.getType());
				}
				_t = __t82;
				_t = _t.getNextSibling();
				break;
			}
			case SR_ASSIGN:
			{
				AST __t83 = _t;
				ModestAST tmp54_AST_in = (ModestAST)_t;
				match(_t,SR_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" >>= "+rhs.getName(), lhs.getType());
				}
				_t = __t83;
				_t = _t.getNextSibling();
				break;
			}
			case SL_ASSIGN:
			{
				AST __t84 = _t;
				ModestAST tmp55_AST_in = (ModestAST)_t;
				match(_t,SL_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" <<= "+rhs.getName(), lhs.getType());
				}
				_t = __t84;
				_t = _t.getNextSibling();
				break;
			}
			case BAND_ASSIGN:
			{
				AST __t85 = _t;
				ModestAST tmp56_AST_in = (ModestAST)_t;
				match(_t,BAND_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" &= "+rhs.getName(), lhs.getType());
				}
				_t = __t85;
				_t = _t.getNextSibling();
				break;
			}
			case BXOR_ASSIGN:
			{
				AST __t86 = _t;
				ModestAST tmp57_AST_in = (ModestAST)_t;
				match(_t,BXOR_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" ^= "+rhs.getName(), lhs.getType());
				}
				_t = __t86;
				_t = _t.getNextSibling();
				break;
			}
			case BOR_ASSIGN:
			{
				AST __t87 = _t;
				ModestAST tmp58_AST_in = (ModestAST)_t;
				match(_t,BOR_ASSIGN);
				_t = _t.getFirstChild();
				lhs=expression(_t);
				_t = _retTree;
				rhs=expression(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					assi = new Symbol(lhs.getName()+" |= "+rhs.getName(), lhs.getType());
				}
				_t = __t87;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#assignment_in);*/
				
						errorMessage = "assignment " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return assi;
	}
	
	public final void palt_stmnt(AST _t,
		SimulationNode parent, String guard
	) throws RecognitionException {
		
		ModestAST palt_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST i = null;
		ModestAST p = null;
		ModestAST w = null;
		ModestAST a = null;
		
			ActionNode act = null;
			PaltNode palt = null;
			Alternative alt = null;
			boolean altExists = false;
			Alternative pseudoAlt = null;
			Symbol assi = null;
			String assignmentText = "";
		
		
		try {      // for error handling
			AST __t66 = _t;
			i = _t==ASTNULL ? null :(ModestAST)_t;
			match(_t,IDENTIFIER);
			_t = _t.getFirstChild();
			AST __t67 = _t;
			p = _t==ASTNULL ? null :(ModestAST)_t;
			match(_t,PALT);
			_t = _t.getFirstChild();
			if ( inputState.guessing==0 ) {
				palt = new PaltNode(p.getLine(), p.getColumn(), parent); 
									  act = new ActionNode(i.getText(), i.getLine(), i.getColumn(), palt, guard);
									  altExists=false;
									
			}
			{
			int _cnt75=0;
			_loop75:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==WEIGHT_AST)) {
					AST __t69 = _t;
					w = _t==ASTNULL ? null :(ModestAST)_t;
					match(_t,WEIGHT_AST);
					_t = _t.getFirstChild();
					{
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case ASSIGN_START:
					{
						AST __t71 = _t;
						a = _t==ASTNULL ? null :(ModestAST)_t;
						match(_t,ASSIGN_START);
						_t = _t.getFirstChild();
						{
						int _cnt73=0;
						_loop73:
						do {
							if (_t==null) _t=ASTNULL;
							if (((_t.getType() >= ASSIGN && _t.getType() <= BOR_ASSIGN))) {
								assi=assignment(_t,alt, "");
								_t = _retTree;
								if ( inputState.guessing==0 ) {
									if (assignmentText != "") assignmentText += ", " + assi.getName(); else assignmentText += assi.getName();
								}
							}
							else {
								if ( _cnt73>=1 ) { break _loop73; } else {throw new NoViableAltException(_t);}
							}
							
							_cnt73++;
						} while (true);
						}
						_t = __t71;
						_t = _t.getNextSibling();
						break;
					}
					case 3:
					case STOP:
					case ALT:
					case DO:
					case BREAK:
					case PAR:
					case TRY:
					case THROW:
					case RELABEL:
					case HIDE:
					case EXTEND:
					case ASSIGN:
					case PLUS_ASSIGN:
					case MINUS_ASSIGN:
					case MULT_ASSIGN:
					case DIV_ASSIGN:
					case MOD_ASSIGN:
					case SR_ASSIGN:
					case SL_ASSIGN:
					case BAND_ASSIGN:
					case BXOR_ASSIGN:
					case BOR_ASSIGN:
					case IDENTIFIER:
					case PROCESS_INSTANTIATION_AST:
					case GUARD_AST:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(_t);
					}
					}
					}
					{
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case STOP:
					case ALT:
					case DO:
					case BREAK:
					case PAR:
					case TRY:
					case THROW:
					case RELABEL:
					case HIDE:
					case EXTEND:
					case ASSIGN:
					case PLUS_ASSIGN:
					case MINUS_ASSIGN:
					case MULT_ASSIGN:
					case DIV_ASSIGN:
					case MOD_ASSIGN:
					case SR_ASSIGN:
					case SL_ASSIGN:
					case BAND_ASSIGN:
					case BXOR_ASSIGN:
					case BOR_ASSIGN:
					case IDENTIFIER:
					case PROCESS_INSTANTIATION_AST:
					case GUARD_AST:
					{
						if ( inputState.guessing==0 ) {
							altExists=true; alt = new Alternative(w.getLine(), w.getColumn(), palt, w.getWeight()); if (assi != null) alt.setAssignment(assignmentText); assi = null; assignmentText ="";
						}
						seq_process(_t,alt, "");
						_t = _retTree;
						break;
					}
					case 3:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(_t);
					}
					}
					}
					if ( inputState.guessing==0 ) {
						if (!altExists && assi!=null) //{act.setAssignment(assignmentText); assi = null;} }
												{ pseudoAlt = new Alternative(w.getLine(), w.getColumn(), palt, w.getWeight()); 
												  if (assi != null) pseudoAlt.setAssignment(assignmentText); 
												  assi = null; 
												  assignmentText = "";
												}
											
					}
					_t = __t69;
					_t = _t.getNextSibling();
				}
				else {
					if ( _cnt75>=1 ) { break _loop75; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt75++;
			} while (true);
			}
			_t = __t67;
			_t = _t.getNextSibling();
			_t = __t66;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#palt_stmnt_in);*/
				
						errorMessage = "palt_stmnt " + ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void range(AST _t) throws RecognitionException {
		
		ModestAST range_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t125 = _t;
			ModestAST tmp59_AST_in = (ModestAST)_t;
			match(_t,DOTDOT);
			_t = _t.getFirstChild();
			expression(_t);
			_t = _retTree;
			expression(_t);
			_t = _retTree;
			_t = __t125;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#range_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final String  set_element(AST _t) throws RecognitionException {
		String el = "";
		
		ModestAST set_element_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST i = null;
		ModestAST id = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case INT:
			{
				i = (ModestAST)_t;
				match(_t,INT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					el = i.getText();
				}
				break;
			}
			case IDENTIFIER:
			{
				id = (ModestAST)_t;
				match(_t,IDENTIFIER);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					el = id.getText();
				}
				break;
			}
			case TYPE_AST:
			{
				ModestAST tmp60_AST_in = (ModestAST)_t;
				match(_t,TYPE_AST);
				_t = _t.getNextSibling();
				break;
			}
			case DOTDOT:
			{
				range(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#set_element_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return el;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"typedef\"",
		"\"class\"",
		"\"const\"",
		"\"extern\"",
		"\"range\"",
		"\"enum\"",
		"\"struct\"",
		"\"set\"",
		"\"patient\"",
		"\"impatient\"",
		"\"STOP\"",
		"\"ERROR\"",
		"\"forall\"",
		"\"alt\"",
		"\"palt\"",
		"\"when\"",
		"\"urgent\"",
		"\"do\"",
		"\"break\"",
		"\"if\"",
		"\"else\"",
		"\"return\"",
		"\"par\"",
		"\"try\"",
		"\"throw\"",
		"\"catch\"",
		"\"process\"",
		"\"relabel\"",
		"\"by\"",
		"\"hide\"",
		"\"expose\"",
		"\"extend\"",
		"\"rewrite\"",
		"\"prefix\"",
		"\"package\"",
		"\"import\"",
		"\"export\"",
		"\"priority\"",
		"\"defaults\"",
		"\"|\"",
		"\"&\"",
		"\"^\"",
		"\"<<\"",
		"\">>\"",
		"\"!\"",
		"\"&&\"",
		"\"||\"",
		"\"==\"",
		"\"!=\"",
		"\"<\"",
		"\">\"",
		"\"<=\"",
		"\">=\"",
		"\"+\"",
		"\"-\"",
		"\"*\"",
		"\"/\"",
		"\"%\"",
		"\"(\"",
		"\")\"",
		"\"[\"",
		"\"]\"",
		"\"{\"",
		"\"}\"",
		"\"=\"",
		"\"+=\"",
		"\"-=\"",
		"\"*=\"",
		"\"/=\"",
		"\"%=\"",
		"\">>=\"",
		"\"<<=\"",
		"\"&=\"",
		"\"^=\"",
		"\"|=\"",
		"\"{=\"",
		"\"=}\"",
		"\"..\"",
		"\".\"",
		"\",\"",
		"\"?\"",
		"\"::\"",
		"\":\"",
		"\";\"",
		"\"@\"",
		"\"#\"",
		"INT",
		"FLOAT",
		"STRING",
		"an identifier",
		"EXPONENT_PART",
		"FLOAT_SUFFIX",
		"DOT_OR_DOTDOT",
		"NUMERIC",
		"a whitespace character",
		"'C-comment'",
		"CPP_COMMENT",
		"ESCAPE",
		"SHIFTR_OR_ASGN",
		"SHIFTL_OR_ASGN",
		"INTNUMERIC",
		"HASH_OR_LINENR",
		"IDENTIFIER_AST",
		"TYPE_AST",
		"VARIABLE_DECLARATION_AST",
		"FUNCTION_DEFINITION_AST",
		"PARAMETER_LIST_AST",
		"PROCESS_DEFINITION_AST",
		"CATCH_DEFINITION_AST",
		"TYPE_DEFINITION_AST",
		"FUNCTION_CALL_AST",
		"PROCESS_INSTANTIATION_AST",
		"WEIGHT_AST",
		"GUARD_AST",
		"TYPE_CAST"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 45573357568L, 11258999605329904L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 4611677222334365696L, 1134696772927493L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 0L, 8796697133056L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	}
	
