// $ANTLR 2.7.7 (20061129): "ModestParser.g" -> "ModestTreeWalker.java"$

package modesteditor.core.antlrparser;

import modesteditor.core.ModestEditor;
    
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream; 
import java.util.ArrayList;

import org.eclipse.jface.text.IDocument; 
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.Region;

import antlr.CommonAST;  

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;
import modesteditor.core.model.Process;
import modesteditor.core.model.*;
import java.util.ArrayList;
import java.util.Vector;


public class ModestTreeWalker extends antlr.TreeParser       implements ModestParserTokenTypes
 {
public ModestTreeWalker() {
	tokenNames = _tokenNames;
}

	public final Process  simulation(AST _t) throws RecognitionException {
		Process root = new Process("root",0,0);
		
		AST simulation_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		//ArrayList<ArrayList<Model>> decl; 
				ArrayList<Model> decl;
			
		
		try {      // for error handling
			{
			_loop205:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					decl=declaration(_t);
					_t = _retTree;
					//System.err.println("in Simulation");
							/*root.addActions(decl.get(0));
							root.addExceptions(decl.get(1));
					root.addVariables(decl.get(2));       
					root.addTypes(decl.get(3));
					root.addProcesses(decl.get(4)); */
							root.addModels(decl);
						
				}
				else {
					break _loop205;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return root;
	}
	
	public final ArrayList<Model>  declaration(AST _t) throws RecognitionException {
		ArrayList<Model> decl = new ArrayList<Model>();
		
		AST declaration_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		//for (int i=0;i<5;i++) decl.add(new ArrayList<Model>());
			  ArrayList<Model> actions;
			  ArrayList<Model> excs;
			  ArrayList<Model> vars;
			  ArrayList<Model> structs;
			  ArrayList<Model> procs;
			
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_exception:
			{
				excs=exceptionDeclaration(_t);
				_t = _retTree;
				//decl.get(1).addAll(excs);
						decl.addAll(excs);
						//System.err.println("Excs size: " + excs.size());
					
				break;
			}
			case LITERAL_typedef:
			{
				structs=structDeclaration(_t);
				_t = _retTree;
				//decl.get(3).addAll(structs);
						decl.addAll(structs);
						//System.err.println("Structs size: " + structs.size());
					
				break;
			}
			case LITERAL_process:
			{
				procs=processDeclaration(_t);
				_t = _retTree;
				//decl.get(4).addAll(procs);
						decl.addAll(procs);
						//System.err.println("Procs size: " + procs.size());
					
				break;
			}
			default:
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==LITERAL_patient||_t.getType()==LITERAL_impatient||_t.getType()==LITERAL_action)) {
					actions=actionDeclaration(_t);
					_t = _retTree;
					//decl.get(0).addAll(actions); 
							decl.addAll(actions);
							//System.err.println("Actions size: " + actions.size());
						
				}
				else if ((_tokenSet_1.member(_t.getType()))) {
					vars=variableDeclaration(_t);
					_t = _retTree;
					//decl.get(2).addAll(vars);
							decl.addAll(vars); 
						//System.err.println("Vars size: " + vars.size());
						
				}
			else {
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return decl;
	}
	
	public final ArrayList<Model>  actionDeclaration(AST _t) throws RecognitionException {
		ArrayList<Model> acts = new ArrayList<Model>();
		
		AST actionDeclaration_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST i = null;
		AST i2 = null;
		AST i3 = null;
		AST i4 = null;
		AST i5 = null;
		AST i6 = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_action:
			{
				AST tmp238_AST_in = (AST)_t;
				match(_t,LITERAL_action);
				_t = _t.getNextSibling();
				i = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				acts.add(new ModestAction(i.getText(), i.getLine(), i.getColumn()));
					/*System.err.println("action name: " + i.getText());
					System.err.println("action line: " + i.getLine());
					System.err.println("action column: " + i.getColumn()); */
				{
				_loop209:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==COMMA)) {
						AST tmp239_AST_in = (AST)_t;
						match(_t,COMMA);
						_t = _t.getNextSibling();
						i2 = (AST)_t;
						match(_t,ID);
						_t = _t.getNextSibling();
						acts.add(new ModestAction(i2.getText(), i2.getLine(), i2.getColumn()));
					}
					else {
						break _loop209;
					}
					
				} while (true);
				}
				AST tmp240_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_patient:
			{
				AST tmp241_AST_in = (AST)_t;
				match(_t,LITERAL_patient);
				_t = _t.getNextSibling();
				AST tmp242_AST_in = (AST)_t;
				match(_t,LITERAL_action);
				_t = _t.getNextSibling();
				i3 = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				acts.add(new ModestAction(i3.getText(), i3.getLine(), i3.getColumn()));
				{
				_loop211:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==COMMA)) {
						AST tmp243_AST_in = (AST)_t;
						match(_t,COMMA);
						_t = _t.getNextSibling();
						i4 = (AST)_t;
						match(_t,ID);
						_t = _t.getNextSibling();
						acts.add(new ModestAction(i4.getText(), i4.getLine(), i4.getColumn(), true));
					}
					else {
						break _loop211;
					}
					
				} while (true);
				}
				AST tmp244_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_impatient:
			{
				AST tmp245_AST_in = (AST)_t;
				match(_t,LITERAL_impatient);
				_t = _t.getNextSibling();
				AST tmp246_AST_in = (AST)_t;
				match(_t,LITERAL_action);
				_t = _t.getNextSibling();
				i5 = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				acts.add(new ModestAction(i5.getText(), i5.getLine(), i5.getColumn()));
				{
				_loop213:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==COMMA)) {
						AST tmp247_AST_in = (AST)_t;
						match(_t,COMMA);
						_t = _t.getNextSibling();
						i6 = (AST)_t;
						match(_t,ID);
						_t = _t.getNextSibling();
						acts.add(new ModestAction(i6.getText(), i6.getLine(), i6.getColumn(), false));
					}
					else {
						break _loop213;
					}
					
				} while (true);
				}
				AST tmp248_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return acts;
	}
	
	public final ArrayList<Model>  variableDeclaration(AST _t) throws RecognitionException {
		ArrayList<Model> vars = new ArrayList<Model>();
		
		AST variableDeclaration_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST tf = null;
		AST myid = null;
		AST myid2 = null;
		AST ti = null;
		AST myid3 = null;
		AST myid4 = null;
		AST tb = null;
		AST myid5 = null;
		AST myid6 = null;
		AST tc = null;
		AST myid7 = null;
		AST myid8 = null;
		AST i = null;
		AST i2 = null;
		//ArrayList<String> i = new ArrayList<String>(); 
			String q = ""; //int m = 0; 
			//ArrayList<String> a = new ArrayList<String>(); 
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			if ((_t.getType()==LITERAL_float||_t.getType()==LITERAL_const||_t.getType()==LITERAL_extern)) {
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier(_t);
					_t = _retTree;
					break;
				}
				case LITERAL_float:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				tf = (AST)_t;
				match(_t,LITERAL_float);
				_t = _t.getNextSibling();
				myid = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				vars.add(new ModestVariable(myid.getText(), myid.getLine(), myid.getColumn(), "float"));
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case EQUAL:
				{
					AST tmp249_AST_in = (AST)_t;
					match(_t,EQUAL);
					_t = _t.getNextSibling();
					AST tmp250_AST_in = (AST)_t;
					match(_t,FLOAT);
					_t = _t.getNextSibling();
					break;
				}
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				{
				_loop219:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==COMMA)) {
						AST tmp251_AST_in = (AST)_t;
						match(_t,COMMA);
						_t = _t.getNextSibling();
						myid2 = (AST)_t;
						match(_t,ID);
						_t = _t.getNextSibling();
						vars.add(new ModestVariable(myid2.getText(), myid2.getLine(), myid2.getColumn(), "float"));
						{
						if (_t==null) _t=ASTNULL;
						switch ( _t.getType()) {
						case EQUAL:
						{
							AST tmp252_AST_in = (AST)_t;
							match(_t,EQUAL);
							_t = _t.getNextSibling();
							AST tmp253_AST_in = (AST)_t;
							match(_t,FLOAT);
							_t = _t.getNextSibling();
							break;
						}
						case SEMI:
						case COMMA:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(_t);
						}
						}
						}
					}
					else {
						break _loop219;
					}
					
				} while (true);
				}
				AST tmp254_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
			}
			else if ((_t.getType()==LITERAL_int||_t.getType()==LITERAL_const||_t.getType()==LITERAL_extern)) {
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier(_t);
					_t = _retTree;
					break;
				}
				case LITERAL_int:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				ti = (AST)_t;
				match(_t,LITERAL_int);
				_t = _t.getNextSibling();
				myid3 = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				vars.add(new ModestVariable(myid3.getText(), myid3.getLine(), myid3.getColumn(), "int"));
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case EQUAL:
				{
					AST tmp255_AST_in = (AST)_t;
					match(_t,EQUAL);
					_t = _t.getNextSibling();
					AST tmp256_AST_in = (AST)_t;
					match(_t,INT);
					_t = _t.getNextSibling();
					break;
				}
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				{
				_loop224:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==COMMA)) {
						AST tmp257_AST_in = (AST)_t;
						match(_t,COMMA);
						_t = _t.getNextSibling();
						myid4 = (AST)_t;
						match(_t,ID);
						_t = _t.getNextSibling();
						vars.add(new ModestVariable(myid4.getText(), myid4.getLine(), myid4.getColumn(), "int"));
						{
						if (_t==null) _t=ASTNULL;
						switch ( _t.getType()) {
						case EQUAL:
						{
							AST tmp258_AST_in = (AST)_t;
							match(_t,EQUAL);
							_t = _t.getNextSibling();
							AST tmp259_AST_in = (AST)_t;
							match(_t,INT);
							_t = _t.getNextSibling();
							break;
						}
						case SEMI:
						case COMMA:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(_t);
						}
						}
						}
					}
					else {
						break _loop224;
					}
					
				} while (true);
				}
				AST tmp260_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
			}
			else if ((_t.getType()==LITERAL_bool||_t.getType()==LITERAL_const||_t.getType()==LITERAL_extern)) {
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier(_t);
					_t = _retTree;
					break;
				}
				case LITERAL_bool:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				tb = (AST)_t;
				match(_t,LITERAL_bool);
				_t = _t.getNextSibling();
				myid5 = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				vars.add(new ModestVariable(myid5.getText(), myid5.getLine(), myid5.getColumn(), "bool"));
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case EQUAL:
				{
					AST tmp261_AST_in = (AST)_t;
					match(_t,EQUAL);
					_t = _t.getNextSibling();
					{
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case LITERAL_true:
					{
						AST tmp262_AST_in = (AST)_t;
						match(_t,LITERAL_true);
						_t = _t.getNextSibling();
						break;
					}
					case LITERAL_false:
					{
						AST tmp263_AST_in = (AST)_t;
						match(_t,LITERAL_false);
						_t = _t.getNextSibling();
						break;
					}
					default:
					{
						throw new NoViableAltException(_t);
					}
					}
					}
					break;
				}
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				{
				_loop231:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==COMMA)) {
						AST tmp264_AST_in = (AST)_t;
						match(_t,COMMA);
						_t = _t.getNextSibling();
						myid6 = (AST)_t;
						match(_t,ID);
						_t = _t.getNextSibling();
						vars.add(new ModestVariable(myid6.getText(), myid6.getLine(), myid6.getColumn(), "bool"));
						{
						if (_t==null) _t=ASTNULL;
						switch ( _t.getType()) {
						case EQUAL:
						{
							AST tmp265_AST_in = (AST)_t;
							match(_t,EQUAL);
							_t = _t.getNextSibling();
							{
							if (_t==null) _t=ASTNULL;
							switch ( _t.getType()) {
							case LITERAL_true:
							{
								AST tmp266_AST_in = (AST)_t;
								match(_t,LITERAL_true);
								_t = _t.getNextSibling();
								break;
							}
							case LITERAL_false:
							{
								AST tmp267_AST_in = (AST)_t;
								match(_t,LITERAL_false);
								_t = _t.getNextSibling();
								break;
							}
							default:
							{
								throw new NoViableAltException(_t);
							}
							}
							}
							break;
						}
						case SEMI:
						case COMMA:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(_t);
						}
						}
						}
					}
					else {
						break _loop231;
					}
					
				} while (true);
				}
				AST tmp268_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
			}
			else if (((_t.getType() >= LITERAL_clock && _t.getType() <= LITERAL_extern))) {
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier(_t);
					_t = _retTree;
					break;
				}
				case LITERAL_clock:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				tc = (AST)_t;
				match(_t,LITERAL_clock);
				_t = _t.getNextSibling();
				myid7 = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				vars.add(new ModestVariable(myid7.getText(), myid7.getLine(), myid7.getColumn(), "clock"));
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case EQUAL:
				{
					AST tmp269_AST_in = (AST)_t;
					match(_t,EQUAL);
					_t = _t.getNextSibling();
					AST tmp270_AST_in = (AST)_t;
					match(_t,INT);
					_t = _t.getNextSibling();
					break;
				}
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				{
				_loop236:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==COMMA)) {
						AST tmp271_AST_in = (AST)_t;
						match(_t,COMMA);
						_t = _t.getNextSibling();
						myid8 = (AST)_t;
						match(_t,ID);
						_t = _t.getNextSibling();
						vars.add(new ModestVariable(myid8.getText(), myid8.getLine(), myid8.getColumn(), "clock"));
						{
						if (_t==null) _t=ASTNULL;
						switch ( _t.getType()) {
						case EQUAL:
						{
							AST tmp272_AST_in = (AST)_t;
							match(_t,EQUAL);
							_t = _t.getNextSibling();
							AST tmp273_AST_in = (AST)_t;
							match(_t,INT);
							_t = _t.getNextSibling();
							break;
						}
						case SEMI:
						case COMMA:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(_t);
						}
						}
						}
					}
					else {
						break _loop236;
					}
					
				} while (true);
				}
				AST tmp274_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
			}
			else if ((_tokenSet_2.member(_t.getType()))) {
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case LITERAL_const:
				case LITERAL_extern:
				{
					modifier(_t);
					_t = _retTree;
					break;
				}
				case LITERAL_action:
				case ID:
				case LITERAL_float:
				case LITERAL_int:
				case LITERAL_clock:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				q=qType(_t);
				_t = _retTree;
				i = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				AST tmp275_AST_in = (AST)_t;
				match(_t,LBRACKET);
				_t = _t.getNextSibling();
				AST tmp276_AST_in = (AST)_t;
				match(_t,RBRACKET);
				_t = _t.getNextSibling();
				vars.add(new ModestVariable(i.getText(), i.getLine(), i.getColumn(), q + "_array"));
				{
				_loop239:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==COMMA)) {
						AST tmp277_AST_in = (AST)_t;
						match(_t,COMMA);
						_t = _t.getNextSibling();
						i2 = (AST)_t;
						match(_t,ID);
						_t = _t.getNextSibling();
						AST tmp278_AST_in = (AST)_t;
						match(_t,LBRACKET);
						_t = _t.getNextSibling();
						AST tmp279_AST_in = (AST)_t;
						match(_t,RBRACKET);
						_t = _t.getNextSibling();
						vars.add(new ModestVariable(i2.getText(), i2.getLine(), i2.getColumn(), q + "_array"));
					}
					else {
						break _loop239;
					}
					
				} while (true);
				}
				AST tmp280_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
			}
			else {
				throw new NoViableAltException(_t);
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return vars;
	}
	
	public final ArrayList<Model>  exceptionDeclaration(AST _t) throws RecognitionException {
		ArrayList<Model> excs = new ArrayList<Model>();
		
		AST exceptionDeclaration_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST i = null;
		AST i2 = null;
		
		try {      // for error handling
			AST tmp281_AST_in = (AST)_t;
			match(_t,LITERAL_exception);
			_t = _t.getNextSibling();
			i = (AST)_t;
			match(_t,ID);
			_t = _t.getNextSibling();
			excs.add(new ModestException(i.getText(), i.getLine(), i.getColumn()));
			{
			_loop244:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==COMMA)) {
					AST tmp282_AST_in = (AST)_t;
					match(_t,COMMA);
					_t = _t.getNextSibling();
					i2 = (AST)_t;
					match(_t,ID);
					_t = _t.getNextSibling();
					excs.add(new ModestException(i2.getText(), i2.getLine(), i2.getColumn()));
				}
				else {
					break _loop244;
				}
				
			} while (true);
			}
			AST tmp283_AST_in = (AST)_t;
			match(_t,SEMI);
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return excs;
	}
	
	public final ArrayList<Model>  structDeclaration(AST _t) throws RecognitionException {
		ArrayList<Model> structs = new ArrayList<Model>();
		
		AST structDeclaration_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST i = null;
		AST i2 = null;
		AST i3 = null;
		
		try {      // for error handling
			AST tmp284_AST_in = (AST)_t;
			match(_t,LITERAL_typedef);
			_t = _t.getNextSibling();
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_struct:
			{
				AST tmp285_AST_in = (AST)_t;
				match(_t,LITERAL_struct);
				_t = _t.getNextSibling();
				AST tmp286_AST_in = (AST)_t;
				match(_t,LBRACE);
				_t = _t.getNextSibling();
				AST tmp287_AST_in = (AST)_t;
				match(_t,RBRACE);
				_t = _t.getNextSibling();
				i = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				AST tmp288_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
				structs.add(new ModestType(i.getText(), i.getLine(), i.getColumn(), "struct"));
						 //System.err.println("Name: " + i.getText());
						 //System.err.println("Line: " + i.getLine());
					
				break;
			}
			case LITERAL_set:
			{
				AST tmp289_AST_in = (AST)_t;
				match(_t,LITERAL_set);
				_t = _t.getNextSibling();
				AST tmp290_AST_in = (AST)_t;
				match(_t,LBRACE);
				_t = _t.getNextSibling();
				AST tmp291_AST_in = (AST)_t;
				match(_t,RBRACE);
				_t = _t.getNextSibling();
				i2 = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				AST tmp292_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
				structs.add(new ModestType(i2.getText(), i2.getLine(), i.getColumn(), "set"));
						 //System.err.println("Name: " + i2.getText());
						 //System.err.println("Line: " + i2.getLine());
					
				break;
			}
			case LITERAL_range:
			{
				AST tmp293_AST_in = (AST)_t;
				match(_t,LITERAL_range);
				_t = _t.getNextSibling();
				AST tmp294_AST_in = (AST)_t;
				match(_t,LBRACKET);
				_t = _t.getNextSibling();
				AST tmp295_AST_in = (AST)_t;
				match(_t,INT);
				_t = _t.getNextSibling();
				AST tmp296_AST_in = (AST)_t;
				match(_t,DOTDOT);
				_t = _t.getNextSibling();
				AST tmp297_AST_in = (AST)_t;
				match(_t,INT);
				_t = _t.getNextSibling();
				AST tmp298_AST_in = (AST)_t;
				match(_t,RBRACKET);
				_t = _t.getNextSibling();
				i3 = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				AST tmp299_AST_in = (AST)_t;
				match(_t,SEMI);
				_t = _t.getNextSibling();
				structs.add(new ModestType(i3.getText(), i3.getLine(), i.getColumn(), "range"));
						 //System.err.println("Name: " + i3.getText());
						 //System.err.println("Line: " + i3.getLine());
					
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return structs;
	}
	
	public final ArrayList<Model>  processDeclaration(AST _t) throws RecognitionException {
		ArrayList<Model> procs = new ArrayList<Model>();
		
		AST processDeclaration_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST i = null;
		//System.err.println("In ProcessDeclaration"); 
			//ArrayList<ArrayList<Model>> b = new ArrayList<ArrayList<Model>>();
			ArrayList<Model> b = new ArrayList<Model>();
			
		
		try {      // for error handling
			AST tmp300_AST_in = (AST)_t;
			match(_t,LITERAL_process);
			_t = _t.getNextSibling();
			i = (AST)_t;
			match(_t,ID);
			_t = _t.getNextSibling();
			AST tmp301_AST_in = (AST)_t;
			match(_t,LPAR);
			_t = _t.getNextSibling();
			AST tmp302_AST_in = (AST)_t;
			match(_t,RPAR);
			_t = _t.getNextSibling();
			AST tmp303_AST_in = (AST)_t;
			match(_t,LBRACE);
			_t = _t.getNextSibling();
			b=body(_t);
			_t = _retTree;
			AST tmp304_AST_in = (AST)_t;
			match(_t,RBRACE);
			_t = _t.getNextSibling();
			Process actProc = new Process(i.getText(),i.getLine(), i.getColumn());
					/*actProc.addActions(b.get(0)); 
					actProc.addExceptions(b.get(1));
					actProc.addVariables(b.get(2));
					actProc.addTypes(b.get(3));
					actProc.addProcesses(b.get(4));*/
					actProc.addModels(b);
					procs.add(actProc);
				
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return procs;
	}
	
	public final int  modifier(AST _t) throws RecognitionException {
		int line = 0;
		
		AST modifier_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST c = null;
		AST e = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_const:
			{
				c = (AST)_t;
				match(_t,LITERAL_const);
				_t = _t.getNextSibling();
				line = c.getLine();
				break;
			}
			case LITERAL_extern:
			{
				e = (AST)_t;
				match(_t,LITERAL_extern);
				_t = _t.getNextSibling();
				line = e.getLine();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return line;
	}
	
	public final String  qType(AST _t) throws RecognitionException {
		String s = "";
		
		AST qType_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		AST i = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_int:
			{
				AST tmp305_AST_in = (AST)_t;
				match(_t,LITERAL_int);
				_t = _t.getNextSibling();
				s = "int";
				break;
			}
			case LITERAL_float:
			{
				AST tmp306_AST_in = (AST)_t;
				match(_t,LITERAL_float);
				_t = _t.getNextSibling();
				s = "float";
				break;
			}
			case LITERAL_clock:
			{
				AST tmp307_AST_in = (AST)_t;
				match(_t,LITERAL_clock);
				_t = _t.getNextSibling();
				s = "clock";
				break;
			}
			case LITERAL_action:
			{
				AST tmp308_AST_in = (AST)_t;
				match(_t,LITERAL_action);
				_t = _t.getNextSibling();
				s = "action";
				break;
			}
			case ID:
			{
				i = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				s = i.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return s;
	}
	
	public final ArrayList<Model>  body(AST _t) throws RecognitionException {
		ArrayList<Model> b = new ArrayList<Model>();
		
		AST body_AST_in = (_t == ASTNULL) ? null : (AST)_t;
		//ArrayList<ArrayList<Model>> decl = new ArrayList<ArrayList<Model>>(); 
				ArrayList<Model> decl = new ArrayList<Model>();
			//for (int i=0;i<5;i++) b.add(new ArrayList<Model>());
			
		
		try {      // for error handling
			{
			_loop250:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					decl=declaration(_t);
					_t = _retTree;
					
							/*b.get(0).addAll(decl.get(0));
							b.get(1).addAll(decl.get(1));
							b.get(2).addAll(decl.get(2));
							b.get(3).addAll(decl.get(3));
							b.get(4).addAll(decl.get(4));*/
							b.addAll(decl);
						
				}
				else {
					break _loop250;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return b;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"defaults\"",
		"'{'",
		"\"actions\"",
		"'='",
		"\"patient\"",
		"\"impatient\"",
		"';'",
		"\"guards\"",
		"\"urgent\"",
		"\"not_urgent\"",
		"'}'",
		"\"action\"",
		"an identifier",
		"','",
		"\"float\"",
		"FLOAT",
		"\"int\"",
		"INT",
		"\"bool\"",
		"\"true\"",
		"\"false\"",
		"\"clock\"",
		"\"const\"",
		"\"extern\"",
		"'['",
		"']'",
		"\"exception\"",
		"\"typedef\"",
		"\"struct\"",
		"\"set\"",
		"\"range\"",
		"'..'",
		"\"process\"",
		"'('",
		"')'",
		"'?'",
		"':'",
		"'||'",
		"'&&'",
		"'|'",
		"'^'",
		"AND",
		"'=='",
		"'!='",
		"'>'",
		"'<'",
		"'>='",
		"'<='",
		"LEFTSHIFT",
		"RIGHTSHIFT",
		"ULEFTSHIFT",
		"URIGHTSHIFT",
		"'+'",
		"'-'",
		"'*'",
		"'/'",
		"'%'",
		"'!'",
		"'.'",
		"\"try\"",
		"\"catch\"",
		"\"when\"",
		"\"alt\"",
		"\"do\"",
		"\"par\"",
		"\"hide\"",
		"\"relabel\"",
		"\"extend\"",
		"\"prefix\"",
		"\"by\"",
		"PLUS_EQUAL",
		"MINUS_EQUAL",
		"TIME_EQUAL",
		"DIV_EQUAL",
		"REMAINDER_EQUAL",
		"LSHIFT_EQUAL",
		"RSHIFT_EQUAL",
		"AND_EQUAL",
		"OR_EQUAL",
		"XOR_EQUAL",
		"ULSHIFT_EQUAL",
		"URSHIFT_EQUAL",
		"\"palt\"",
		"\"break\"",
		"\"return\"",
		"\"throw\"",
		"EXPONENT_PART",
		"FLOAT_SUFFIX",
		"NUMERIC",
		"a whitespace character",
		"COMMENT",
		"ML_COMMENT",
		"CHAR",
		"STRING",
		"'~'",
		"'--'",
		"'++'",
		"TIMES_EQUAL"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 72181187328L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 240484352L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 236290048L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	}
	
