/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.model;




/**
 * Superclass of all MoDeST models.
 */
public abstract class Model {
	
	/** Parent process of the model, either a process or the root of the tree. */
	protected Process parent;
	protected String name;
	protected int length;
	protected int line;
	protected int column;
	
	
	public void setName(String name) {
		this.name = name;
	}
	
	public Process getParent() {
		return parent;
	}
	
	/* The receiver should visit the toVisit object and
	 * pass along the argument. */
	public abstract void accept(IModelVisitor visitor, Object passAlongArgument);
	
	public String getName() {
		return name;
	}
	
	
	
	public Model(String name) {
		this.name = name;
	}
	
	public Model() {
	}	
	
	

	public int getLength() {
		return length;
	}
	
		
	public int getLine(){
		return line;
	}
	
	public int getColumn() {
		return column;
	}
	
}