/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.model;

/**
 * Model of a MoDeST action.
 */
public class ModestAction extends Model {
	
	private boolean patient;

	/* (non-Javadoc)
	 * @see modesteditor.core.model.Model#accept(modesteditor.core.model.IModelVisitor, java.lang.Object)
	 */
	@Override
	public void accept(IModelVisitor visitor, Object passAlongArgument) {
		visitor.visitAction(this, passAlongArgument);
	}

	public ModestAction(String name, int line, int column) {
		this.name = name;
		this.line = line;
		this.column = column;
		this.length = name.length();
		this.patient = false;
	}
	
	public ModestAction(String name, int line, int column, boolean patient) {
		this(name, line, column);
		this.patient = patient;
	}
	
	public boolean isPatient() {
		return patient;
	}
	
}
