/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.model;

/**
 * Model of a MoDeST type definition.
 *
 */
public class ModestType extends Model {

	/** Kind of type which is defined. */
	private String type;
	
	/* (non-Javadoc)
	 * @see modesteditor.core.model.Model#accept(modesteditor.core.model.IModelVisitor, java.lang.Object)
	 */
	@Override
	public void accept(IModelVisitor visitor, Object passAlongArgument) {
		visitor.visitType(this, passAlongArgument);
	}

	public ModestType(String name, int line, int column, String type) {
		this.name = name;
		this.line = line;
		this.column = column;
		this.length = name.length();
		this.type = type;
	}
	
	public String getType() {
		return type;
	}
	
}
