/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.model;

/**
 * Model of a MoDeST variable.
 *
 */
public class ModestVariable extends Model {

	/** Type of the variable */
	private String type;
	
	/* (non-Javadoc)
	 * @see modesteditor.core.model.Model#accept(modesteditor.core.model.IModelVisitor, java.lang.Object)
	 */
	@Override
	public void accept(IModelVisitor visitor, Object passAlongArgument) {
		visitor.visitVariable(this, passAlongArgument);
	}
	
	/** 
	 * Constructor which sets the type to int. 
	 * Should not be used, since a variable has to be defined with a type.
	 * @param name
	 * @param offset
	 */
	public ModestVariable(String name, int line, int column) {
		this.name = name;
		this.line = line;
		this.column = column;
		this.length = name.length();
		this.type = "int";
	}
	
	/**
	 * Constructor which sets the appropriate type.
	 * @param name
	 * @param offset
	 * @param type
	 */
	public ModestVariable(String name, int line, int column, String type) {
		this(name, line, column);
		this.type = type;
	}
	
	/**
	 * Returns the type of the variable.
	 * @return type of the variable
	 */
	public String getType() {
		return type;
	}

}
