/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.launch.ui;

import modesteditor.launch.ModestLaunchPlugin;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.DirectoryFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

/**
 * The MoDeST -> Run page in the preferences.
 */
public class ModestLaunchPreferencePage extends FieldEditorPreferencePage 
	implements IWorkbenchPreferencePage{

	public ModestLaunchPreferencePage() {
		super(GRID);
		setPreferenceStore(ModestLaunchPlugin.getDefault().getPreferenceStore());
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	/**
	 * We create the fields for the compiler location, 
	 * for the output directory and a flag for the creation of the dot file.
	 */
	protected void createFieldEditors() {
		FileFieldEditor compilerField = new FileFieldEditor(
				ModestLaunchPlugin.COMPILER_LOCATION,
				"momodest binary:",
				false,
				getFieldEditorParent());
		compilerField.setEmptyStringAllowed(true);
		addField(compilerField);
		
		FileFieldEditor fsnsField = new FileFieldEditor(
				ModestLaunchPlugin.FSNS_LOCATION,
				"fsns binary:",
				false,
				getFieldEditorParent());
		fsnsField.setEmptyStringAllowed(true);
		addField(fsnsField);
		
		DirectoryFieldEditor outputDirectoryField = new DirectoryFieldEditor(
				ModestLaunchPlugin.OUTPUT_FOLDER_LOCATION,
				"Output folder:",
				getFieldEditorParent());
		outputDirectoryField.setEmptyStringAllowed(true);
		addField(outputDirectoryField);
		
		BooleanFieldEditor dotFileGeneration = new BooleanFieldEditor(
				ModestLaunchPlugin.DOT_FILE_CREATION,
				"Generate dot file",
				getFieldEditorParent());
		addField(dotFileGeneration);
	}
	
	public void init (IWorkbench workbench) {}

}
